/* application.c generated by valac 0.56.13, the Vala compiler
 * generated from application.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2017-2023 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <ibus.h>
#include <glib-object.h>
#include <stdio.h>
#include <ibuswaylandim.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <glib/gstdio.h>
#include <pwd.h>
#include <unistd.h>
#include <gdk/gdk.h>
#include <gdk/gdkwayland.h>
#include <gobject/gvaluecollector.h>

#define IBUS_WAYLAND_VERSION "1.1"
#define G_USEC_PER_SEC ((gulong) 1000000L)
#define SLEEP_DIV_PER_SEC ((gulong) 100L)
#define MAX_DISPLAY_IDLE_TIME (((G_USEC_PER_SEC * SLEEP_DIV_PER_SEC) * 60) * 3)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
typedef struct _ApplicationPrivate ApplicationPrivate;

#define TYPE_PANEL (panel_get_type ())
#define PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL, Panel))
#define PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL, PanelClass))
#define IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL))
#define IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL))
#define PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL, PanelClass))

typedef struct _Panel Panel;
typedef struct _PanelClass PanelClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))
typedef struct _ParamSpecApplication ParamSpecApplication;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Application {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ApplicationPrivate * priv;
};

struct _ApplicationClass {
	GTypeClass parent_class;
	void (*finalize) (Application *self);
};

struct _ApplicationPrivate {
	Panel* m_panel;
};

struct _ParamSpecApplication {
	GParamSpec parent_instance;
};

VALA_EXTERN gchar* prgname;
gchar* prgname = NULL;
VALA_EXTERN IBusBus* bus;
IBusBus* bus = NULL;
static gint Application_private_offset;
static gpointer application_parent_class = NULL;
static FILE* application_m_log;
static FILE* application_m_log = NULL;
static gboolean application_m_verbose;
static gboolean application_m_verbose = FALSE;
static gboolean application_m_enable_wayland_im;
static gboolean application_m_enable_wayland_im = FALSE;
static gulong application_m_realize_surface_id;
static gulong application_m_realize_surface_id = 0UL;
static gchar* application_m_user;
static gchar* application_m_user = NULL;
static IBusWaylandIM* application_m_wayland_im;
static IBusWaylandIM* application_m_wayland_im = NULL;
static gboolean application_m_exec_daemon;
static gboolean application_m_exec_daemon = FALSE;
static gchar* application_m_daemon_args;
static gchar* application_m_daemon_args = NULL;

VALA_EXTERN gpointer application_ref (gpointer instance);
VALA_EXTERN void application_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_application (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_application (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_application (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_application (const GValue* value);
VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, application_unref)
VALA_EXTERN GType panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Panel, g_object_unref)
VALA_EXTERN Application* application_new (void);
VALA_EXTERN Application* application_construct (GType object_type);
static void application_bus_connected (Application* self,
                                IBusBus* bus);
static void _application_bus_connected_ibus_bus_connected (IBusBus* _sender,
                                                    gpointer self);
static void application_bus_disconnected (Application* self,
                                   IBusBus* bus);
static void _application_bus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                          gpointer self);
static void application_bus_global_shortcut_key_cb (Application* self,
                                             IBusBus* bus,
                                             guint8 type,
                                             gboolean is_pressed,
                                             gboolean is_backward);
static void _application_bus_global_shortcut_key_cb_ibus_bus_global_shortcut_key_responded (IBusBus* _sender,
                                                                                     guint8 type,
                                                                                     gboolean is_pressed,
                                                                                     gboolean is_backward,
                                                                                     gpointer self);
static void application_init (Application* self);
static void application_bus_name_acquired_cb (Application* self,
                                       GDBusConnection* connection,
                                       const gchar* sender_name,
                                       const gchar* object_path,
                                       const gchar* interface_name,
                                       const gchar* signal_name,
                                       GVariant* parameters);
static void _application_bus_name_acquired_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                               const gchar* sender_name,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* signal_name,
                                                               GVariant* parameters,
                                                               gpointer self);
static void application_bus_name_lost_cb (Application* self,
                                   GDBusConnection* connection,
                                   const gchar* sender_name,
                                   const gchar* object_path,
                                   const gchar* interface_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static void _application_bus_name_lost_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                           const gchar* sender_name,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* signal_name,
                                                           GVariant* parameters,
                                                           gpointer self);
VALA_EXTERN gint application_run (Application* self);
VALA_EXTERN Panel* panel_new (IBusBus* bus,
                  gboolean is_wayland_im);
VALA_EXTERN Panel* panel_construct (GType object_type,
                        IBusBus* bus,
                        gboolean is_wayland_im);
VALA_EXTERN void panel_set_log (Panel* self,
                    FILE* log,
                    gboolean verbose);
static void __lambda108_ (Application* self,
                   Panel* w,
                   void* s);
static void application_set_wayland_surface (Application* self,
                                      void* surface);
static void ___lambda108__panel_realize_surface (Panel* _sender,
                                          void* surface,
                                          gpointer self);
VALA_EXTERN void panel_load_settings (Panel* self);
VALA_EXTERN void panel_disconnect_signals (Panel* self);
VALA_EXTERN void panel_set_global_shortcut_key_state (Panel* self,
                                          IBusBusGlobalBindingType type,
                                          gboolean is_pressed,
                                          gboolean is_backward);
static gboolean application_open_log (void);
static void application_check_ps (void);
static void application_run_ibus_daemon (void);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void application_make_wayland_im (void);
VALA_EXTERN gboolean application_show_version (const gchar* option_name,
                                   const gchar* data,
                                   void* user_data,
                                   GError** _error_);
static void application_main (gchar** argv,
                       gint argv_length1);
static void application_finalize (Application * obj);
static GType application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
application_get_instance_private (Application* self)
{
	return G_STRUCT_MEMBER_P (self, Application_private_offset);
}

static void
_application_bus_connected_ibus_bus_connected (IBusBus* _sender,
                                               gpointer self)
{
#line 54 "application.vala"
	application_bus_connected ((Application*) self, _sender);
#line 260 "application.c"
}

static void
_application_bus_disconnected_ibus_bus_disconnected (IBusBus* _sender,
                                                     gpointer self)
{
#line 55 "application.vala"
	application_bus_disconnected ((Application*) self, _sender);
#line 269 "application.c"
}

static void
_application_bus_global_shortcut_key_cb_ibus_bus_global_shortcut_key_responded (IBusBus* _sender,
                                                                                guint8 type,
                                                                                gboolean is_pressed,
                                                                                gboolean is_backward,
                                                                                gpointer self)
{
#line 57 "application.vala"
	application_bus_global_shortcut_key_cb ((Application*) self, _sender, type, is_pressed, is_backward);
#line 281 "application.c"
}

Application*
application_construct (GType object_type)
{
	Application* self = NULL;
	IBusBus* _tmp0_;
	IBusBus* _tmp2_;
	IBusBus* _tmp3_;
	IBusBus* _tmp4_;
	IBusBus* _tmp5_;
	IBusBus* _tmp6_;
#line 47 "application.vala"
	self = (Application*) g_type_create_instance (object_type);
#line 48 "application.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 49 "application.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 51 "application.vala"
	_tmp0_ = bus;
#line 51 "application.vala"
	if (_tmp0_ == NULL) {
#line 304 "application.c"
		IBusBus* _tmp1_;
#line 52 "application.vala"
		_tmp1_ = ibus_bus_new ();
#line 52 "application.vala"
		g_object_ref_sink (_tmp1_);
#line 52 "application.vala"
		_g_object_unref0 (bus);
#line 52 "application.vala"
		bus = _tmp1_;
#line 314 "application.c"
	}
#line 54 "application.vala"
	_tmp2_ = bus;
#line 54 "application.vala"
	g_signal_connect (_tmp2_, "connected", (GCallback) _application_bus_connected_ibus_bus_connected, self);
#line 55 "application.vala"
	_tmp3_ = bus;
#line 55 "application.vala"
	g_signal_connect (_tmp3_, "disconnected", (GCallback) _application_bus_disconnected_ibus_bus_disconnected, self);
#line 56 "application.vala"
	_tmp4_ = bus;
#line 56 "application.vala"
	ibus_bus_set_watch_ibus_signal (_tmp4_, TRUE);
#line 57 "application.vala"
	_tmp5_ = bus;
#line 57 "application.vala"
	g_signal_connect (_tmp5_, "global-shortcut-key-responded", (GCallback) _application_bus_global_shortcut_key_cb_ibus_bus_global_shortcut_key_responded, self);
#line 59 "application.vala"
	_tmp6_ = bus;
#line 59 "application.vala"
	if (ibus_bus_is_connected (_tmp6_)) {
#line 60 "application.vala"
		application_init (self);
#line 338 "application.c"
	}
#line 47 "application.vala"
	return self;
#line 342 "application.c"
}

Application*
application_new (void)
{
#line 47 "application.vala"
	return application_construct (TYPE_APPLICATION);
#line 350 "application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 65 "application.vala"
	return self ? g_object_ref (self) : NULL;
#line 358 "application.c"
}

static void
_application_bus_name_acquired_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                          const gchar* sender_name,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* signal_name,
                                                          GVariant* parameters,
                                                          gpointer self)
{
#line 66 "application.vala"
	application_bus_name_acquired_cb ((Application*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 372 "application.c"
}

static void
_application_bus_name_lost_cb_gd_bus_signal_callback (GDBusConnection* connection,
                                                      const gchar* sender_name,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* signal_name,
                                                      GVariant* parameters,
                                                      gpointer self)
{
#line 73 "application.vala"
	application_bus_name_lost_cb ((Application*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 386 "application.c"
}

static void
application_init (Application* self)
{
	GDBusConnection* connection = NULL;
	IBusBus* _tmp0_;
	GDBusConnection* _tmp1_;
	GDBusConnection* _tmp2_;
	IBusBusNameFlag flags = 0U;
	IBusBus* _tmp3_;
#line 64 "application.vala"
	g_return_if_fail (self != NULL);
#line 65 "application.vala"
	_tmp0_ = bus;
#line 65 "application.vala"
	_tmp1_ = ibus_bus_get_connection (_tmp0_);
#line 65 "application.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 65 "application.vala"
	connection = _tmp2_;
#line 66 "application.vala"
	g_dbus_connection_signal_subscribe (connection, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameAcquired", "/org/freedesktop/DBus", IBUS_SERVICE_PANEL, G_DBUS_SIGNAL_FLAGS_NONE, _application_bus_name_acquired_cb_gd_bus_signal_callback, application_ref (self), application_unref);
#line 73 "application.vala"
	g_dbus_connection_signal_subscribe (connection, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameLost", "/org/freedesktop/DBus", IBUS_SERVICE_PANEL, G_DBUS_SIGNAL_FLAGS_NONE, _application_bus_name_lost_cb_gd_bus_signal_callback, application_ref (self), application_unref);
#line 80 "application.vala"
	flags = IBUS_BUS_NAME_FLAG_ALLOW_REPLACEMENT | IBUS_BUS_NAME_FLAG_REPLACE_EXISTING;
#line 83 "application.vala"
	_tmp3_ = bus;
#line 83 "application.vala"
	ibus_bus_request_name (_tmp3_, IBUS_SERVICE_PANEL, (guint32) flags);
#line 64 "application.vala"
	_g_object_unref0 (connection);
#line 420 "application.c"
}

gint
application_run (Application* self)
{
	gint result;
#line 86 "application.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 87 "application.vala"
	gtk_main ();
#line 88 "application.vala"
	result = 0;
#line 88 "application.vala"
	return result;
#line 435 "application.c"
}

static void
__lambda108_ (Application* self,
              Panel* w,
              void* s)
{
#line 103 "application.vala"
	g_return_if_fail (w != NULL);
#line 103 "application.vala"
	application_set_wayland_surface (self, s);
#line 447 "application.c"
}

static void
___lambda108__panel_realize_surface (Panel* _sender,
                                     void* surface,
                                     gpointer self)
{
#line 102 "application.vala"
	__lambda108_ ((Application*) self, _sender, surface);
#line 457 "application.c"
}

static void
application_bus_name_acquired_cb (Application* self,
                                  GDBusConnection* connection,
                                  const gchar* sender_name,
                                  const gchar* object_path,
                                  const gchar* interface_name,
                                  const gchar* signal_name,
                                  GVariant* parameters)
{
	IBusBus* _tmp0_;
	Panel* _tmp1_;
	FILE* _tmp2_;
	Panel* _tmp5_;
	gulong _tmp6_;
	Panel* _tmp7_;
#line 91 "application.vala"
	g_return_if_fail (self != NULL);
#line 91 "application.vala"
	g_return_if_fail (connection != NULL);
#line 91 "application.vala"
	g_return_if_fail (object_path != NULL);
#line 91 "application.vala"
	g_return_if_fail (interface_name != NULL);
#line 91 "application.vala"
	g_return_if_fail (signal_name != NULL);
#line 91 "application.vala"
	g_return_if_fail (parameters != NULL);
#line 97 "application.vala"
	g_debug ("application.vala:97: signal_name = %s", signal_name);
#line 98 "application.vala"
	_tmp0_ = bus;
#line 98 "application.vala"
	_tmp1_ = panel_new (_tmp0_, application_m_enable_wayland_im);
#line 98 "application.vala"
	g_object_ref_sink (_tmp1_);
#line 98 "application.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 98 "application.vala"
	self->priv->m_panel = _tmp1_;
#line 99 "application.vala"
	_tmp2_ = application_m_log;
#line 99 "application.vala"
	if (_tmp2_ != NULL) {
#line 503 "application.c"
		Panel* _tmp3_;
		FILE* _tmp4_;
#line 100 "application.vala"
		_tmp3_ = self->priv->m_panel;
#line 100 "application.vala"
		_tmp4_ = application_m_log;
#line 100 "application.vala"
		panel_set_log (_tmp3_, _tmp4_, application_m_verbose);
#line 512 "application.c"
	}
#line 102 "application.vala"
	_tmp5_ = self->priv->m_panel;
#line 102 "application.vala"
	_tmp6_ = g_signal_connect (_tmp5_, "realize-surface", (GCallback) ___lambda108__panel_realize_surface, self);
#line 102 "application.vala"
	application_m_realize_surface_id = _tmp6_;
#line 105 "application.vala"
	_tmp7_ = self->priv->m_panel;
#line 105 "application.vala"
	panel_load_settings (_tmp7_);
#line 524 "application.c"
}

static void
application_bus_name_lost_cb (Application* self,
                              GDBusConnection* connection,
                              const gchar* sender_name,
                              const gchar* object_path,
                              const gchar* interface_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
	Panel* _tmp0_;
#line 108 "application.vala"
	g_return_if_fail (self != NULL);
#line 108 "application.vala"
	g_return_if_fail (connection != NULL);
#line 108 "application.vala"
	g_return_if_fail (object_path != NULL);
#line 108 "application.vala"
	g_return_if_fail (interface_name != NULL);
#line 108 "application.vala"
	g_return_if_fail (signal_name != NULL);
#line 108 "application.vala"
	g_return_if_fail (parameters != NULL);
#line 120 "application.vala"
	g_debug ("application.vala:120: signal_name = %s", signal_name);
#line 123 "application.vala"
	_tmp0_ = self->priv->m_panel;
#line 123 "application.vala"
	panel_disconnect_signals (_tmp0_);
#line 125 "application.vala"
	if (application_m_realize_surface_id != ((gulong) 0)) {
#line 557 "application.c"
		Panel* _tmp1_;
#line 126 "application.vala"
		_tmp1_ = self->priv->m_panel;
#line 126 "application.vala"
		g_signal_handler_disconnect (_tmp1_, application_m_realize_surface_id);
#line 127 "application.vala"
		application_m_realize_surface_id = (gulong) 0;
#line 565 "application.c"
	}
#line 130 "application.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 130 "application.vala"
	self->priv->m_panel = NULL;
#line 571 "application.c"
}

static void
application_bus_disconnected (Application* self,
                              IBusBus* bus)
{
#line 133 "application.vala"
	g_return_if_fail (self != NULL);
#line 133 "application.vala"
	g_return_if_fail (bus != NULL);
#line 134 "application.vala"
	g_debug ("application.vala:134: connection is lost.");
#line 135 "application.vala"
	gtk_main_quit ();
#line 586 "application.c"
}

static void
application_bus_connected (Application* self,
                           IBusBus* bus)
{
#line 138 "application.vala"
	g_return_if_fail (self != NULL);
#line 138 "application.vala"
	g_return_if_fail (bus != NULL);
#line 139 "application.vala"
	application_init (self);
#line 599 "application.c"
}

static void
application_bus_global_shortcut_key_cb (Application* self,
                                        IBusBus* bus,
                                        guint8 type,
                                        gboolean is_pressed,
                                        gboolean is_backward)
{
	Panel* _tmp0_;
	IBusBusGlobalBindingType gtype = 0;
	Panel* _tmp5_;
#line 142 "application.vala"
	g_return_if_fail (self != NULL);
#line 142 "application.vala"
	g_return_if_fail (bus != NULL);
#line 146 "application.vala"
	_tmp0_ = self->priv->m_panel;
#line 146 "application.vala"
	if (_tmp0_ == NULL) {
#line 147 "application.vala"
		return;
#line 622 "application.c"
	}
#line 148 "application.vala"
	if (application_m_verbose) {
#line 626 "application.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		FILE* _tmp3_;
		FILE* _tmp4_;
#line 151 "application.vala"
		if (is_pressed) {
#line 151 "application.vala"
			_tmp1_ = "TRUE";
#line 635 "application.c"
		} else {
#line 151 "application.vala"
			_tmp1_ = "FALSE";
#line 639 "application.c"
		}
#line 152 "application.vala"
		if (is_backward) {
#line 152 "application.vala"
			_tmp2_ = "TRUE";
#line 645 "application.c"
		} else {
#line 152 "application.vala"
			_tmp2_ = "FALSE";
#line 649 "application.c"
		}
#line 149 "application.vala"
		_tmp3_ = application_m_log;
#line 149 "application.vala"
		fprintf (_tmp3_, "Global shortcut key %u pressed %s backward %s\n", (guint) type, _tmp1_, _tmp2_);
#line 153 "application.vala"
		_tmp4_ = application_m_log;
#line 153 "application.vala"
		fflush (_tmp4_);
#line 659 "application.c"
	}
#line 155 "application.vala"
	gtype = (IBusBusGlobalBindingType) type;
#line 156 "application.vala"
	_tmp5_ = self->priv->m_panel;
#line 156 "application.vala"
	panel_set_global_shortcut_key_state (_tmp5_, gtype, is_pressed, is_backward);
#line 667 "application.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 690 "application.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 699 "application.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 718 "application.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 722 "application.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 728 "application.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 738 "application.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 746 "application.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 750 "application.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 756 "application.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 766 "application.c"
}

static gboolean
application_open_log (void)
{
	gchar* directory = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* path = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	FILE* _tmp9_;
	struct passwd* pw = NULL;
	struct passwd* _tmp10_;
	struct passwd* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp17_;
	GDateTime* now = NULL;
	GDateTime* _tmp19_;
	gint msec = 0;
	GDateTime* _tmp20_;
	FILE* _tmp21_;
	GDateTime* _tmp22_;
	GDateTime* _tmp23_;
	GDateTime* _tmp24_;
	FILE* _tmp25_;
	gboolean result;
#line 161 "application.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 161 "application.vala"
	_tmp1_ = g_build_filename (_tmp0_, "ibus", NULL);
#line 161 "application.vala"
	directory = _tmp1_;
#line 164 "application.vala"
	_tmp2_ = directory;
#line 164 "application.vala"
	g_return_val_if_fail (_tmp2_ != NULL, FALSE);
#line 165 "application.vala"
	errno = 0;
#line 166 "application.vala"
	_tmp3_ = directory;
#line 166 "application.vala"
	if (g_mkdir_with_parents (_tmp3_, 0700) != 0) {
#line 815 "application.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 167 "application.vala"
		_tmp4_ = directory;
#line 167 "application.vala"
		_tmp5_ = strerror (errno);
#line 167 "application.vala"
		g_warning ("application.vala:167: mkdir is failed in %s: %s", _tmp4_, _tmp5_);
#line 169 "application.vala"
		result = FALSE;
#line 169 "application.vala"
		_g_free0 (directory);
#line 169 "application.vala"
		return result;
#line 830 "application.c"
	}
#line 171 "application.vala"
	_tmp6_ = directory;
#line 171 "application.vala"
	_tmp7_ = g_build_filename (_tmp6_, "wayland.log", NULL);
#line 171 "application.vala"
	path = _tmp7_;
#line 173 "application.vala"
	_tmp8_ = path;
#line 173 "application.vala"
	_tmp9_ = g_fopen (_tmp8_, "w");
#line 173 "application.vala"
	_fclose0 (application_m_log);
#line 173 "application.vala"
	application_m_log = _tmp9_;
#line 174 "application.vala"
	_tmp10_ = getpwuid (getuid ());
#line 174 "application.vala"
	pw = _tmp10_;
#line 175 "application.vala"
	_tmp11_ = pw;
#line 175 "application.vala"
	_tmp12_ = _tmp11_->pw_name;
#line 175 "application.vala"
	_tmp13_ = string_substring (_tmp12_, (glong) 0, (glong) 6);
#line 175 "application.vala"
	_g_free0 (application_m_user);
#line 175 "application.vala"
	application_m_user = _tmp13_;
#line 176 "application.vala"
	_tmp14_ = application_m_user;
#line 176 "application.vala"
	if (_tmp14_ == NULL) {
#line 864 "application.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 177 "application.vala"
		_tmp15_ = g_getenv ("USER");
#line 177 "application.vala"
		_tmp16_ = string_substring (_tmp15_, (glong) 0, (glong) 6);
#line 177 "application.vala"
		_g_free0 (application_m_user);
#line 177 "application.vala"
		application_m_user = _tmp16_;
#line 875 "application.c"
	}
#line 178 "application.vala"
	_tmp17_ = application_m_user;
#line 178 "application.vala"
	if (_tmp17_ == NULL) {
#line 881 "application.c"
		gchar* _tmp18_;
#line 179 "application.vala"
		_tmp18_ = g_strdup ("UNKNOW");
#line 179 "application.vala"
		_g_free0 (application_m_user);
#line 179 "application.vala"
		application_m_user = _tmp18_;
#line 889 "application.c"
	}
#line 180 "application.vala"
	_tmp19_ = g_date_time_new_now_local ();
#line 180 "application.vala"
	now = _tmp19_;
#line 181 "application.vala"
	_tmp20_ = now;
#line 181 "application.vala"
	msec = g_date_time_get_microsecond (_tmp20_) / 1000;
#line 182 "application.vala"
	_tmp21_ = application_m_log;
#line 182 "application.vala"
	_tmp22_ = now;
#line 182 "application.vala"
	_tmp23_ = now;
#line 182 "application.vala"
	_tmp24_ = now;
#line 182 "application.vala"
	fprintf (_tmp21_, "Start %02d:%02d:%02d:%06d\n", g_date_time_get_hour (_tmp22_), g_date_time_get_minute (_tmp23_), g_date_time_get_second (_tmp24_), msec);
#line 184 "application.vala"
	_tmp25_ = application_m_log;
#line 184 "application.vala"
	fflush (_tmp25_);
#line 185 "application.vala"
	result = TRUE;
#line 185 "application.vala"
	_g_date_time_unref0 (now);
#line 185 "application.vala"
	_g_free0 (path);
#line 185 "application.vala"
	_g_free0 (directory);
#line 185 "application.vala"
	return result;
#line 923 "application.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 947 "application.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 955 "application.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 961 "application.c"
	}
}

static void
application_check_ps (void)
{
	gchar* standard_output = NULL;
	gchar* standard_error = NULL;
	gint wait_status = 0;
	gchar** lines = NULL;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint lines_length1;
	gint _lines_size_;
	FILE* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	FILE* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 189 "application.vala"
	standard_output = NULL;
#line 190 "application.vala"
	standard_error = NULL;
#line 191 "application.vala"
	wait_status = 0;
#line 988 "application.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
#line 193 "application.vala"
		g_spawn_command_line_sync ("ps -ef", &_tmp0_, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 193 "application.vala"
		_g_free0 (standard_output);
#line 193 "application.vala"
		standard_output = _tmp0_;
#line 193 "application.vala"
		_g_free0 (standard_error);
#line 193 "application.vala"
		standard_error = _tmp1_;
#line 193 "application.vala"
		wait_status = _tmp2_;
#line 193 "application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 193 "application.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1009 "application.c"
				goto __catch0_g_spawn_error;
			}
#line 193 "application.vala"
			_g_free0 (standard_error);
#line 193 "application.vala"
			_g_free0 (standard_output);
#line 193 "application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 193 "application.vala"
			g_clear_error (&_inner_error0_);
#line 193 "application.vala"
			return;
#line 1022 "application.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		FILE* _tmp7_;
#line 192 "application.vala"
		e = _inner_error0_;
#line 192 "application.vala"
		_inner_error0_ = NULL;
#line 198 "application.vala"
		_tmp3_ = application_m_log;
#line 198 "application.vala"
		_tmp4_ = e;
#line 198 "application.vala"
		_tmp5_ = _tmp4_->message;
#line 198 "application.vala"
		_tmp6_ = standard_error;
#line 198 "application.vala"
		fprintf (_tmp3_, "Failed ps %s: %s\n", _tmp5_, _tmp6_);
#line 199 "application.vala"
		_tmp7_ = application_m_log;
#line 199 "application.vala"
		fflush (_tmp7_);
#line 200 "application.vala"
		_g_error_free0 (e);
#line 200 "application.vala"
		_g_free0 (standard_error);
#line 200 "application.vala"
		_g_free0 (standard_output);
#line 200 "application.vala"
		return;
#line 1060 "application.c"
	}
	__finally0:
#line 192 "application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "application.vala"
		_g_free0 (standard_error);
#line 192 "application.vala"
		_g_free0 (standard_output);
#line 192 "application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "application.vala"
		g_clear_error (&_inner_error0_);
#line 192 "application.vala"
		return;
#line 1075 "application.c"
	}
#line 202 "application.vala"
	_tmp8_ = standard_output;
#line 202 "application.vala"
	_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "\n", -1);
#line 202 "application.vala"
	lines = _tmp10_;
#line 202 "application.vala"
	lines_length1 = _vala_array_length (_tmp9_);
#line 202 "application.vala"
	_lines_size_ = lines_length1;
#line 203 "application.vala"
	_tmp11_ = application_m_log;
#line 203 "application.vala"
	fprintf (_tmp11_, "ps -ef\n");
#line 204 "application.vala"
	_tmp12_ = lines;
#line 204 "application.vala"
	_tmp12__length1 = lines_length1;
#line 1095 "application.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 204 "application.vala"
		line_collection = _tmp12_;
#line 204 "application.vala"
		line_collection_length1 = _tmp12__length1;
#line 204 "application.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1107 "application.c"
			gchar* _tmp13_;
			gchar* line = NULL;
#line 204 "application.vala"
			_tmp13_ = g_strdup (line_collection[line_it]);
#line 204 "application.vala"
			line = _tmp13_;
#line 1114 "application.c"
			{
				gboolean _tmp14_ = FALSE;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
#line 205 "application.vala"
				_tmp15_ = line;
#line 205 "application.vala"
				_tmp16_ = application_m_user;
#line 205 "application.vala"
				if (string_index_of (_tmp15_, _tmp16_, 0) >= 0) {
#line 1125 "application.c"
					const gchar* _tmp17_;
#line 205 "application.vala"
					_tmp17_ = line;
#line 205 "application.vala"
					_tmp14_ = string_index_of (_tmp17_, "wayland", 0) >= 0;
#line 1131 "application.c"
				} else {
#line 205 "application.vala"
					_tmp14_ = FALSE;
#line 1135 "application.c"
				}
#line 205 "application.vala"
				if (_tmp14_) {
#line 1139 "application.c"
					FILE* _tmp18_;
					const gchar* _tmp19_;
#line 206 "application.vala"
					_tmp18_ = application_m_log;
#line 206 "application.vala"
					_tmp19_ = line;
#line 206 "application.vala"
					fprintf (_tmp18_, "  %s\n", _tmp19_);
#line 1148 "application.c"
				}
#line 204 "application.vala"
				_g_free0 (line);
#line 1152 "application.c"
			}
		}
	}
#line 208 "application.vala"
	_tmp20_ = application_m_log;
#line 208 "application.vala"
	fflush (_tmp20_);
#line 188 "application.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 188 "application.vala"
	_g_free0 (standard_error);
#line 188 "application.vala"
	_g_free0 (standard_output);
#line 1166 "application.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 214 "application.vala"
	if ((*length) == (*size)) {
#line 214 "application.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 214 "application.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1181 "application.c"
	}
#line 214 "application.vala"
	(*array)[(*length)++] = value;
#line 214 "application.vala"
	(*array)[*length] = NULL;
#line 1187 "application.c"
}

static void
application_run_ibus_daemon (void)
{
	gchar** args = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	GPid child_pid = 0;
	GError* _inner_error0_ = NULL;
#line 212 "application.vala"
	_tmp0_ = g_strdup ("ibus-daemon");
#line 212 "application.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 212 "application.vala"
	_tmp1_[0] = _tmp0_;
#line 212 "application.vala"
	args = _tmp1_;
#line 212 "application.vala"
	args_length1 = 1;
#line 212 "application.vala"
	_args_size_ = args_length1;
#line 213 "application.vala"
	_tmp2_ = application_m_daemon_args;
#line 213 "application.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
#line 1219 "application.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 213 "application.vala"
		arg_collection = _tmp4_;
#line 213 "application.vala"
		arg_collection_length1 = _vala_array_length (_tmp3_);
#line 213 "application.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 1231 "application.c"
			gchar* _tmp5_;
			gchar* arg = NULL;
#line 213 "application.vala"
			_tmp5_ = g_strdup (arg_collection[arg_it]);
#line 213 "application.vala"
			arg = _tmp5_;
#line 1238 "application.c"
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
#line 214 "application.vala"
				_tmp6_ = arg;
#line 214 "application.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 214 "application.vala"
				_vala_array_add1 (&args, &args_length1, &_args_size_, _tmp7_);
#line 213 "application.vala"
				_g_free0 (arg);
#line 1250 "application.c"
			}
		}
#line 213 "application.vala"
		arg_collection = (_vala_array_free (arg_collection, arg_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1255 "application.c"
	}
#line 215 "application.vala"
	child_pid = (GPid) 0;
#line 1259 "application.c"
	{
		gchar** _tmp8_;
		gint _tmp8__length1;
		GPid _tmp9_ = 0;
#line 217 "application.vala"
		_tmp8_ = args;
#line 217 "application.vala"
		_tmp8__length1 = args_length1;
#line 217 "application.vala"
		g_spawn_async (NULL, _tmp8_, NULL, G_SPAWN_DO_NOT_REAP_CHILD | G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp9_, &_inner_error0_);
#line 217 "application.vala"
		child_pid = _tmp9_;
#line 217 "application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "application.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1276 "application.c"
				goto __catch0_g_spawn_error;
			}
#line 217 "application.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 217 "application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 217 "application.vala"
			g_clear_error (&_inner_error0_);
#line 217 "application.vala"
			return;
#line 1287 "application.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		FILE* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 216 "application.vala"
		e = _inner_error0_;
#line 216 "application.vala"
		_inner_error0_ = NULL;
#line 223 "application.vala"
		_tmp10_ = application_m_log;
#line 223 "application.vala"
		_tmp11_ = e;
#line 223 "application.vala"
		_tmp12_ = _tmp11_->message;
#line 223 "application.vala"
		fprintf (_tmp10_, "ibus-daemon error: %s\n", _tmp12_);
#line 224 "application.vala"
		_tmp13_ = e;
#line 224 "application.vala"
		_tmp14_ = _tmp13_->message;
#line 224 "application.vala"
		g_warning ("application.vala:224: %s\n", _tmp14_);
#line 216 "application.vala"
		_g_error_free0 (e);
#line 1319 "application.c"
	}
	__finally0:
#line 216 "application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "application.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 216 "application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "application.vala"
		g_clear_error (&_inner_error0_);
#line 216 "application.vala"
		return;
#line 1332 "application.c"
	}
#line 226 "application.vala"
	g_usleep (5 * G_USEC_PER_SEC);
#line 211 "application.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 1338 "application.c"
}

static void
application_make_wayland_im (void)
{
	void* wl_display = NULL;
	gulong i = 0UL;
	gint _errno = 0;
	void* _tmp9_;
	IBusBus* _tmp13_;
	gboolean _tmp14_ = FALSE;
	IBusBus* _tmp15_;
	IBusBus* _tmp18_;
	IBusBus* _tmp21_;
	void* _tmp22_;
	FILE* _tmp23_;
	IBusWaylandIM* _tmp24_;
#line 230 "application.vala"
	_vala_assert (application_open_log (), "open_log()");
#line 231 "application.vala"
	wl_display = NULL;
#line 232 "application.vala"
	i = (gulong) 0;
#line 233 "application.vala"
	while (TRUE) {
#line 1364 "application.c"
		GdkDisplay* display = NULL;
		GdkDisplay* _tmp0_;
		GdkDisplay* _tmp1_;
		GdkDisplay* _tmp2_;
		void* _tmp5_;
		gulong _tmp8_;
#line 234 "application.vala"
		_tmp0_ = gdk_display_get_default ();
#line 234 "application.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 234 "application.vala"
		display = _tmp1_;
#line 235 "application.vala"
		_tmp2_ = display;
#line 235 "application.vala"
		if (_tmp2_ != NULL) {
#line 1381 "application.c"
			GdkDisplay* _tmp3_;
			void* _tmp4_;
#line 236 "application.vala"
			_tmp3_ = display;
#line 236 "application.vala"
			_tmp4_ = gdk_wayland_display_get_wl_display (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gdk_wayland_display_get_type (), GdkWaylandDisplay));
#line 236 "application.vala"
			wl_display = _tmp4_;
#line 1390 "application.c"
		}
#line 237 "application.vala"
		_tmp5_ = wl_display;
#line 237 "application.vala"
		if (_tmp5_ != NULL) {
#line 238 "application.vala"
			_g_object_unref0 (display);
#line 238 "application.vala"
			break;
#line 1400 "application.c"
		}
#line 239 "application.vala"
		if (i == MAX_DISPLAY_IDLE_TIME) {
#line 240 "application.vala"
			_g_object_unref0 (display);
#line 240 "application.vala"
			break;
#line 1408 "application.c"
		}
#line 241 "application.vala"
		g_usleep (G_USEC_PER_SEC / SLEEP_DIV_PER_SEC);
#line 242 "application.vala"
		if (application_m_verbose) {
#line 1414 "application.c"
			FILE* _tmp6_;
			FILE* _tmp7_;
#line 243 "application.vala"
			_tmp6_ = application_m_log;
#line 243 "application.vala"
			fprintf (_tmp6_, "Spend %lu/%lu secs\n", i, SLEEP_DIV_PER_SEC);
#line 244 "application.vala"
			_tmp7_ = application_m_log;
#line 244 "application.vala"
			fflush (_tmp7_);
#line 1425 "application.c"
		}
#line 246 "application.vala"
		i = i + 1;
#line 246 "application.vala"
		_tmp8_ = i;
#line 233 "application.vala"
		_g_object_unref0 (display);
#line 1433 "application.c"
	}
#line 248 "application.vala"
	_errno = errno;
#line 249 "application.vala"
	if (application_m_verbose) {
#line 250 "application.vala"
		application_check_ps ();
#line 1441 "application.c"
	}
#line 251 "application.vala"
	_tmp9_ = wl_display;
#line 251 "application.vala"
	if (_tmp9_ == NULL) {
#line 1447 "application.c"
		FILE* _tmp10_;
		const gchar* _tmp11_;
		FILE* _tmp12_;
#line 252 "application.vala"
		_tmp10_ = application_m_log;
#line 252 "application.vala"
		_tmp11_ = strerror (_errno);
#line 252 "application.vala"
		fprintf (_tmp10_, "Failed to connect to Wayland server: %s\n", _tmp11_);
#line 254 "application.vala"
		_tmp12_ = application_m_log;
#line 254 "application.vala"
		fflush (_tmp12_);
#line 255 "application.vala"
		g_assert_not_reached ();
#line 1463 "application.c"
	}
#line 257 "application.vala"
	_tmp13_ = ibus_bus_new ();
#line 257 "application.vala"
	g_object_ref_sink (_tmp13_);
#line 257 "application.vala"
	_g_object_unref0 (bus);
#line 257 "application.vala"
	bus = _tmp13_;
#line 258 "application.vala"
	_tmp15_ = bus;
#line 258 "application.vala"
	if (!ibus_bus_is_connected (_tmp15_)) {
#line 258 "application.vala"
		_tmp14_ = application_m_exec_daemon;
#line 1479 "application.c"
	} else {
#line 258 "application.vala"
		_tmp14_ = FALSE;
#line 1483 "application.c"
	}
#line 258 "application.vala"
	if (_tmp14_) {
#line 1487 "application.c"
		IBusBus* _tmp16_;
		IBusBus* _tmp17_;
#line 262 "application.vala"
		_tmp16_ = bus;
#line 262 "application.vala"
		ibus_object_destroy ((IBusObject*) _tmp16_);
#line 263 "application.vala"
		application_run_ibus_daemon ();
#line 264 "application.vala"
		_tmp17_ = ibus_bus_new ();
#line 264 "application.vala"
		g_object_ref_sink (_tmp17_);
#line 264 "application.vala"
		_g_object_unref0 (bus);
#line 264 "application.vala"
		bus = _tmp17_;
#line 1504 "application.c"
	}
#line 266 "application.vala"
	_tmp18_ = bus;
#line 266 "application.vala"
	if (!ibus_bus_is_connected (_tmp18_)) {
#line 1510 "application.c"
		FILE* _tmp19_;
		FILE* _tmp20_;
#line 267 "application.vala"
		_tmp19_ = application_m_log;
#line 267 "application.vala"
		fprintf (_tmp19_, "Failed to connect to ibus-daemon\n");
#line 268 "application.vala"
		_tmp20_ = application_m_log;
#line 268 "application.vala"
		fflush (_tmp20_);
#line 269 "application.vala"
		g_assert_not_reached ();
#line 1523 "application.c"
	}
#line 271 "application.vala"
	_tmp21_ = bus;
#line 271 "application.vala"
	_tmp22_ = wl_display;
#line 271 "application.vala"
	_tmp23_ = application_m_log;
#line 271 "application.vala"
	_tmp24_ = ibus_wayland_im_new ("bus", _tmp21_, "wl_display", _tmp22_, "log", _tmp23_, "verbose", application_m_verbose, NULL);
#line 271 "application.vala"
	g_object_ref_sink (_tmp24_);
#line 271 "application.vala"
	_g_object_unref0 (application_m_wayland_im);
#line 271 "application.vala"
	application_m_wayland_im = _tmp24_;
#line 1539 "application.c"
}

static void
application_set_wayland_surface (Application* self,
                                 void* surface)
{
	IBusWaylandIM* _tmp0_;
#line 277 "application.vala"
	g_return_if_fail (self != NULL);
#line 278 "application.vala"
	_tmp0_ = application_m_wayland_im;
#line 278 "application.vala"
	ibus_wayland_im_set_surface (_tmp0_, surface);
#line 1553 "application.c"
}

gboolean
application_show_version (const gchar* option_name,
                          const gchar* data,
                          void* user_data,
                          GError** _error_)
{
	GError* _vala__error_ = NULL;
	const gchar* _tmp0_;
	gboolean result;
#line 282 "application.vala"
	g_return_val_if_fail (option_name != NULL, FALSE);
#line 286 "application.vala"
	_tmp0_ = prgname;
#line 286 "application.vala"
	g_print ("%s %s Wayland %s\n", _tmp0_, PACKAGE_VERSION, IBUS_WAYLAND_VERSION);
#line 289 "application.vala"
	result = TRUE;
#line 289 "application.vala"
	if (_error_) {
#line 289 "application.vala"
		*_error_ = _vala__error_;
#line 1577 "application.c"
	} else {
#line 289 "application.vala"
		_g_error_free0 (_vala__error_);
#line 1581 "application.c"
	}
#line 289 "application.vala"
	return result;
#line 1585 "application.c"
}

static void
application_main (gchar** argv,
                  gint argv_length1)
{
	GOptionEntry entries[6] = {0};
	GOptionEntry _tmp0_ = {0};
	GOptionEntry _tmp1_ = {0};
	GOptionEntry _tmp2_ = {0};
	GOptionEntry _tmp3_ = {0};
	GOptionEntry _tmp4_ = {0};
	GOptionEntry _tmp5_ = {0};
	GOptionEntry _tmp6_[6] = {0};
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* parameter_string = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	GOptionContext* context = NULL;
	GOptionContext* _tmp11_;
	const gchar* _tmp12_;
	GOptionGroup* _tmp13_;
	const gchar* _tmp16_;
	Application* app = NULL;
	Application* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 301 "application.vala"
	g_unsetenv ("GDK_CORE_DEVICE_EVENTS");
#line 303 "application.vala"
	memset (&_tmp0_, 0, sizeof (GOptionEntry));
#line 303 "application.vala"
	_tmp0_.long_name = "version";
#line 303 "application.vala"
	_tmp0_.short_name = 'V';
#line 303 "application.vala"
	_tmp0_.flags = (gint) G_OPTION_FLAG_NO_ARG;
#line 303 "application.vala"
	_tmp0_.arg = G_OPTION_ARG_CALLBACK;
#line 303 "application.vala"
	_tmp0_.arg_data = (void*) application_show_version;
#line 303 "application.vala"
	_tmp0_.description = N_ ("Show version");
#line 303 "application.vala"
	_tmp0_.arg_description = NULL;
#line 303 "application.vala"
	memset (&_tmp1_, 0, sizeof (GOptionEntry));
#line 303 "application.vala"
	_tmp1_.long_name = "enable-wayland-im";
#line 303 "application.vala"
	_tmp1_.short_name = 'i';
#line 303 "application.vala"
	_tmp1_.flags = (gint) 0;
#line 303 "application.vala"
	_tmp1_.arg = G_OPTION_ARG_NONE;
#line 303 "application.vala"
	_tmp1_.arg_data = &application_m_enable_wayland_im;
#line 303 "application.vala"
	_tmp1_.description = N_ ("Connect Wayland input method protocol");
#line 303 "application.vala"
	_tmp1_.arg_description = NULL;
#line 303 "application.vala"
	memset (&_tmp2_, 0, sizeof (GOptionEntry));
#line 303 "application.vala"
	_tmp2_.long_name = "exec-daemon";
#line 303 "application.vala"
	_tmp2_.short_name = 'd';
#line 303 "application.vala"
	_tmp2_.flags = (gint) 0;
#line 303 "application.vala"
	_tmp2_.arg = G_OPTION_ARG_NONE;
#line 303 "application.vala"
	_tmp2_.arg_data = &application_m_exec_daemon;
#line 303 "application.vala"
	_tmp2_.description = N_ ("Execute ibus-daemon if it's not running");
#line 303 "application.vala"
	_tmp2_.arg_description = NULL;
#line 303 "application.vala"
	memset (&_tmp3_, 0, sizeof (GOptionEntry));
#line 303 "application.vala"
	_tmp3_.long_name = "daemon-args";
#line 303 "application.vala"
	_tmp3_.short_name = 'g';
#line 303 "application.vala"
	_tmp3_.flags = (gint) 0;
#line 303 "application.vala"
	_tmp3_.arg = G_OPTION_ARG_STRING;
#line 303 "application.vala"
	_tmp3_.arg_data = &application_m_daemon_args;
#line 303 "application.vala"
	_tmp3_.description = N_ ("ibus-daemon's arguments");
#line 303 "application.vala"
	_tmp3_.arg_description = NULL;
#line 303 "application.vala"
	memset (&_tmp4_, 0, sizeof (GOptionEntry));
#line 303 "application.vala"
	_tmp4_.long_name = "verbose";
#line 303 "application.vala"
	_tmp4_.short_name = 'v';
#line 303 "application.vala"
	_tmp4_.flags = (gint) 0;
#line 303 "application.vala"
	_tmp4_.arg = G_OPTION_ARG_NONE;
#line 303 "application.vala"
	_tmp4_.arg_data = &application_m_verbose;
#line 303 "application.vala"
	_tmp4_.description = N_ ("Verbose logging");
#line 303 "application.vala"
	_tmp4_.arg_description = NULL;
#line 303 "application.vala"
	memset (&_tmp5_, 0, sizeof (GOptionEntry));
#line 303 "application.vala"
	_tmp5_.long_name = NULL;
#line 303 "application.vala"
	_tmp6_[0] = _tmp0_;
#line 303 "application.vala"
	_tmp6_[1] = _tmp1_;
#line 303 "application.vala"
	_tmp6_[2] = _tmp2_;
#line 303 "application.vala"
	_tmp6_[3] = _tmp3_;
#line 303 "application.vala"
	_tmp6_[4] = _tmp4_;
#line 303 "application.vala"
	_tmp6_[5] = _tmp5_;
#line 303 "application.vala"
	memcpy (entries, _tmp6_, 6 * sizeof (GOptionEntry));
#line 329 "application.vala"
	_tmp7_ = argv[0];
#line 329 "application.vala"
	_tmp8_ = g_path_get_basename (_tmp7_);
#line 329 "application.vala"
	_g_free0 (prgname);
#line 329 "application.vala"
	prgname = _tmp8_;
#line 330 "application.vala"
	_tmp9_ = prgname;
#line 330 "application.vala"
	_tmp10_ = g_strdup_printf ("- %s", _tmp9_);
#line 330 "application.vala"
	parameter_string = _tmp10_;
#line 331 "application.vala"
	_tmp11_ = g_option_context_new (parameter_string);
#line 331 "application.vala"
	context = _tmp11_;
#line 332 "application.vala"
	_tmp12_ = prgname;
#line 332 "application.vala"
	g_option_context_add_main_entries (context, entries, _tmp12_);
#line 333 "application.vala"
	_tmp13_ = gtk_get_option_group (TRUE);
#line 333 "application.vala"
	g_option_context_add_group (context, _tmp13_);
#line 1739 "application.c"
	{
#line 335 "application.vala"
		g_option_context_parse (context, (gint*) (&argv_length1), &argv, &_inner_error0_);
#line 335 "application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "application.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 1747 "application.c"
				goto __catch0_g_option_error;
			}
#line 335 "application.vala"
			_g_option_context_free0 (context);
#line 335 "application.vala"
			_g_free0 (parameter_string);
#line 335 "application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 335 "application.vala"
			g_clear_error (&_inner_error0_);
#line 335 "application.vala"
			return;
#line 1760 "application.c"
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 334 "application.vala"
		e = _inner_error0_;
#line 334 "application.vala"
		_inner_error0_ = NULL;
#line 337 "application.vala"
		_tmp14_ = e;
#line 337 "application.vala"
		_tmp15_ = _tmp14_->message;
#line 337 "application.vala"
		g_warning ("application.vala:337: %s", _tmp15_);
#line 334 "application.vala"
		_g_error_free0 (e);
#line 1781 "application.c"
	}
	__finally0:
#line 334 "application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 334 "application.vala"
		_g_option_context_free0 (context);
#line 334 "application.vala"
		_g_free0 (parameter_string);
#line 334 "application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 334 "application.vala"
		g_clear_error (&_inner_error0_);
#line 334 "application.vala"
		return;
#line 1796 "application.c"
	}
#line 340 "application.vala"
	ibus_init ();
#line 342 "application.vala"
	_tmp16_ = application_m_daemon_args;
#line 342 "application.vala"
	if (_tmp16_ == NULL) {
#line 1804 "application.c"
		gchar* _tmp17_;
#line 343 "application.vala"
		_tmp17_ = g_strdup ("--xim");
#line 343 "application.vala"
		_g_free0 (application_m_daemon_args);
#line 343 "application.vala"
		application_m_daemon_args = _tmp17_;
#line 1812 "application.c"
	}
#line 345 "application.vala"
	if (application_m_enable_wayland_im) {
#line 346 "application.vala"
		application_make_wayland_im ();
#line 1818 "application.c"
	}
#line 348 "application.vala"
	_tmp18_ = application_new ();
#line 348 "application.vala"
	app = _tmp18_;
#line 349 "application.vala"
	application_run (app);
#line 292 "application.vala"
	_application_unref0 (app);
#line 292 "application.vala"
	_g_option_context_free0 (context);
#line 292 "application.vala"
	_g_free0 (parameter_string);
#line 1832 "application.c"
}

int
main (int argc,
      char ** argv)
{
#line 292 "application.vala"
	application_main (argv, argc);
#line 292 "application.vala"
	return 0;
#line 1843 "application.c"
}

static void
value_application_init (GValue* value)
{
#line 34 "application.vala"
	value->data[0].v_pointer = NULL;
#line 1851 "application.c"
}

static void
value_application_free_value (GValue* value)
{
#line 34 "application.vala"
	if (value->data[0].v_pointer) {
#line 34 "application.vala"
		application_unref (value->data[0].v_pointer);
#line 1861 "application.c"
	}
}

static void
value_application_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 34 "application.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "application.vala"
		dest_value->data[0].v_pointer = application_ref (src_value->data[0].v_pointer);
#line 1873 "application.c"
	} else {
#line 34 "application.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1877 "application.c"
	}
}

static gpointer
value_application_peek_pointer (const GValue* value)
{
#line 34 "application.vala"
	return value->data[0].v_pointer;
#line 1886 "application.c"
}

static gchar*
value_application_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 34 "application.vala"
	if (collect_values[0].v_pointer) {
#line 1897 "application.c"
		Application * object;
		object = collect_values[0].v_pointer;
#line 34 "application.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "application.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1904 "application.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "application.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1908 "application.c"
		}
#line 34 "application.vala"
		value->data[0].v_pointer = application_ref (object);
#line 1912 "application.c"
	} else {
#line 34 "application.vala"
		value->data[0].v_pointer = NULL;
#line 1916 "application.c"
	}
#line 34 "application.vala"
	return NULL;
#line 1920 "application.c"
}

static gchar*
value_application_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	Application ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "application.vala"
	if (!object_p) {
#line 34 "application.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1935 "application.c"
	}
#line 34 "application.vala"
	if (!value->data[0].v_pointer) {
#line 34 "application.vala"
		*object_p = NULL;
#line 1941 "application.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "application.vala"
		*object_p = value->data[0].v_pointer;
#line 1945 "application.c"
	} else {
#line 34 "application.vala"
		*object_p = application_ref (value->data[0].v_pointer);
#line 1949 "application.c"
	}
#line 34 "application.vala"
	return NULL;
#line 1953 "application.c"
}

GParamSpec*
param_spec_application (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecApplication* spec;
#line 34 "application.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_APPLICATION), NULL);
#line 34 "application.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "application.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "application.vala"
	return G_PARAM_SPEC (spec);
#line 1972 "application.c"
}

gpointer
value_get_application (const GValue* value)
{
#line 34 "application.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_APPLICATION), NULL);
#line 34 "application.vala"
	return value->data[0].v_pointer;
#line 1982 "application.c"
}

void
value_set_application (GValue* value,
                       gpointer v_object)
{
	Application * old;
#line 34 "application.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_APPLICATION));
#line 34 "application.vala"
	old = value->data[0].v_pointer;
#line 34 "application.vala"
	if (v_object) {
#line 34 "application.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_APPLICATION));
#line 34 "application.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "application.vala"
		value->data[0].v_pointer = v_object;
#line 34 "application.vala"
		application_ref (value->data[0].v_pointer);
#line 2004 "application.c"
	} else {
#line 34 "application.vala"
		value->data[0].v_pointer = NULL;
#line 2008 "application.c"
	}
#line 34 "application.vala"
	if (old) {
#line 34 "application.vala"
		application_unref (old);
#line 2014 "application.c"
	}
}

void
value_take_application (GValue* value,
                        gpointer v_object)
{
	Application * old;
#line 34 "application.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_APPLICATION));
#line 34 "application.vala"
	old = value->data[0].v_pointer;
#line 34 "application.vala"
	if (v_object) {
#line 34 "application.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_APPLICATION));
#line 34 "application.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "application.vala"
		value->data[0].v_pointer = v_object;
#line 2035 "application.c"
	} else {
#line 34 "application.vala"
		value->data[0].v_pointer = NULL;
#line 2039 "application.c"
	}
#line 34 "application.vala"
	if (old) {
#line 34 "application.vala"
		application_unref (old);
#line 2045 "application.c"
	}
}

static void
application_class_init (ApplicationClass * klass,
                        gpointer klass_data)
{
#line 34 "application.vala"
	application_parent_class = g_type_class_peek_parent (klass);
#line 34 "application.vala"
	((ApplicationClass *) klass)->finalize = application_finalize;
#line 34 "application.vala"
	g_type_class_adjust_private_offset (klass, &Application_private_offset);
#line 2059 "application.c"
}

static void
application_instance_init (Application * self,
                           gpointer klass)
{
#line 34 "application.vala"
	self->priv = application_get_instance_private (self);
#line 34 "application.vala"
	self->ref_count = 1;
#line 2070 "application.c"
}

static void
application_finalize (Application * obj)
{
	Application * self;
#line 34 "application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION, Application);
#line 34 "application.vala"
	g_signal_handlers_destroy (self);
#line 35 "application.vala"
	_g_object_unref0 (self->priv->m_panel);
#line 2083 "application.c"
}

static GType
application_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_application_init, value_application_free_value, value_application_copy_value, value_application_peek_pointer, "p", value_application_collect_value, "p", value_application_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Application), 0, (GInstanceInitFunc) application_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType application_type_id;
	application_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Application", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Application_private_offset = g_type_add_instance_private (application_type_id, sizeof (ApplicationPrivate));
	return application_type_id;
}

GType
application_get_type (void)
{
	static volatile gsize application_type_id__once = 0;
	if (g_once_init_enter (&application_type_id__once)) {
		GType application_type_id;
		application_type_id = application_get_type_once ();
		g_once_init_leave (&application_type_id__once, application_type_id);
	}
	return application_type_id__once;
}

gpointer
application_ref (gpointer instance)
{
	Application * self;
	self = instance;
#line 34 "application.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "application.vala"
	return instance;
#line 2119 "application.c"
}

void
application_unref (gpointer instance)
{
	Application * self;
	self = instance;
#line 34 "application.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "application.vala"
		APPLICATION_GET_CLASS (self)->finalize (self);
#line 34 "application.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2133 "application.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

