/* panel.c generated by valac 0.56.13, the Vala compiler
 * generated from panel.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2014 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2015-2023 Takao Fujwiara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <ibus.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <gdk/gdkwayland.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <locale.h>
#include <float.h>
#include <math.h>
#include <libnotify/notify.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <signal.h>
#include <sys/types.h>
#include <config.h>

#define PANEL_PRELOAD_ENGINES_DELAY_TIME ((guint) 30000)
#define KEYBINDING_MANAGER_MODIFIER_FILTER ((guint) (GDK_MODIFIER_MASK & (~(((((((((GDK_LOCK_MASK | GDK_MOD2_MASK) | GDK_BUTTON1_MASK) | GDK_BUTTON2_MASK) | GDK_BUTTON3_MASK) | GDK_BUTTON4_MASK) | GDK_BUTTON5_MASK) | GDK_SUPER_MASK) | GDK_HYPER_MASK) | GDK_META_MASK))))
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PANEL (panel_get_type ())
#define PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANEL, Panel))
#define PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANEL, PanelClass))
#define IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANEL))
#define IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANEL))
#define PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANEL, PanelClass))

typedef struct _Panel Panel;
typedef struct _PanelClass PanelClass;
typedef struct _PanelPrivate PanelPrivate;
typedef enum  {
	PANEL_ICON_TYPE_STATUS_ICON,
	PANEL_ICON_TYPE_INDICATOR
} PanelIconType;

#define PANEL_TYPE_ICON_TYPE (panel_icon_type_get_type ())

#define TYPE_INDICATOR (indicator_get_type ())
#define INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR, Indicator))
#define INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR, IndicatorClass))
#define IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR))
#define IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR))
#define INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR, IndicatorClass))

typedef struct _Indicator Indicator;
typedef struct _IndicatorClass IndicatorClass;

#define TYPE_CANDIDATE_PANEL (candidate_panel_get_type ())
#define CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANDIDATE_PANEL, CandidatePanel))
#define CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANDIDATE_PANEL, CandidatePanelClass))
#define IS_CANDIDATE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANDIDATE_PANEL))
#define IS_CANDIDATE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANDIDATE_PANEL))
#define CANDIDATE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANDIDATE_PANEL, CandidatePanelClass))

typedef struct _CandidatePanel CandidatePanel;
typedef struct _CandidatePanelClass CandidatePanelClass;

#define TYPE_SWITCHER (switcher_get_type ())
#define SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWITCHER, Switcher))
#define SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWITCHER, SwitcherClass))
#define IS_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWITCHER))
#define IS_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWITCHER))
#define SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWITCHER, SwitcherClass))

typedef struct _Switcher Switcher;
typedef struct _SwitcherClass SwitcherClass;

#define TYPE_PROPERTY_MANAGER (property_manager_get_type ())
#define PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_MANAGER, PropertyManager))
#define PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_MANAGER, PropertyManagerClass))
#define IS_PROPERTY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_MANAGER))
#define IS_PROPERTY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_MANAGER))
#define PROPERTY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_MANAGER, PropertyManagerClass))

typedef struct _PropertyManager PropertyManager;
typedef struct _PropertyManagerClass PropertyManagerClass;

#define TYPE_PROPERTY_PANEL (property_panel_get_type ())
#define PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTY_PANEL, PropertyPanel))
#define PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTY_PANEL, PropertyPanelClass))
#define IS_PROPERTY_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTY_PANEL))
#define IS_PROPERTY_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTY_PANEL))
#define PROPERTY_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTY_PANEL, PropertyPanelClass))

typedef struct _PropertyPanel PropertyPanel;
typedef struct _PropertyPanelClass PropertyPanelClass;

#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;

#define BINDING_COMMON_TYPE_KEYBINDING (binding_common_keybinding_get_type ())
#define BINDING_COMMON_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybinding))
#define BINDING_COMMON_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))
#define BINDING_COMMON_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BINDING_COMMON_TYPE_KEYBINDING))
#define BINDING_COMMON_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BINDING_COMMON_TYPE_KEYBINDING, BindingCommonKeybindingClass))

typedef struct _BindingCommonKeybinding BindingCommonKeybinding;
typedef struct _BindingCommonKeybindingClass BindingCommonKeybindingClass;
enum  {
	PANEL_0_PROPERTY,
	PANEL_NUM_PROPERTIES
};
static GParamSpec* panel_properties[PANEL_NUM_PROPERTIES];
typedef enum  {
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER,
	BINDING_COMMON_KEY_EVENT_FUNC_TYPE_EMOJI_TYPING
} BindingCommonKeyEventFuncType;

#define BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE (binding_common_key_event_func_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _property_manager_unref0(var) ((var == NULL) ? NULL : (var = (property_manager_unref (var), NULL)))
#define _xkb_layout_unref0(var) ((var == NULL) ? NULL : (var = (xkb_layout_unref (var), NULL)))
typedef enum  {
	INDICATOR_CATEGORY_APPLICATION_STATUS,
	INDICATOR_CATEGORY_COMMUNICATIONS,
	INDICATOR_CATEGORY_SYSTEM_SERVICES,
	INDICATOR_CATEGORY_HARDWARE,
	INDICATOR_CATEGORY_OTHER
} IndicatorCategory;

#define INDICATOR_TYPE_CATEGORY (indicator_category_get_type ())
typedef enum  {
	INDICATOR_STATUS_PASSIVE,
	INDICATOR_STATUS_ACTIVE,
	INDICATOR_STATUS_ATTENTION
} IndicatorStatus;

#define INDICATOR_TYPE_STATUS (indicator_status_get_type ())
typedef struct _Block6Data Block6Data;

#define TYPE_KEYBINDING_MANAGER (keybinding_manager_get_type ())
#define KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManager))
#define KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))
#define IS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYBINDING_MANAGER))
#define IS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYBINDING_MANAGER))
#define KEYBINDING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))

typedef struct _KeybindingManager KeybindingManager;
typedef struct _KeybindingManagerClass KeybindingManagerClass;
typedef void (*KeybindingManagerKeybindingHandlerFunc) (GdkEvent* event, gpointer user_data);
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
enum  {
	PANEL_REALIZE_SURFACE_SIGNAL,
	PANEL_UPDATE_SHORTCUT_KEYS_SIGNAL,
	PANEL_NUM_SIGNALS
};
static guint panel_signals[PANEL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Panel {
	IBusPanelService parent_instance;
	PanelPrivate * priv;
};

struct _PanelClass {
	IBusPanelServiceClass parent_class;
};

struct _PanelPrivate {
	IBusBus* m_bus;
	GSettings* m_settings_general;
	GSettings* m_settings_hotkey;
	GSettings* m_settings_panel;
	PanelIconType m_icon_type;
	Indicator* m_indicator;
	GtkStatusIcon* m_status_icon;
	GtkMenu* m_ime_menu;
	GtkMenu* m_sys_menu;
	IBusEngineDesc** m_engines;
	gint m_engines_length1;
	gint _m_engines_size_;
	GHashTable* m_engine_contexts;
	gchar* m_current_context_path;
	gchar* m_real_current_context_path;
	gboolean m_use_global_engine;
	gboolean m_use_engine_lang;
	CandidatePanel* m_candidate_panel;
	Switcher* m_switcher;
	guint m_switcher_focus_set_engine_id;
	gint m_switcher_selected_index;
	GThread* m_switcher_waiting_release;
	PropertyManager* m_property_manager;
	PropertyPanel* m_property_panel;
	GPid m_setup_pid;
	GtkAboutDialog* m_about_dialog;
	GtkCssProvider* m_css_provider;
	gint m_switcher_delay_time;
	gboolean m_use_system_keyboard_layout;
	GHashTable* m_xkb_icon_pixbufs;
	GHashTable* m_xkb_icon_image;
	GdkRGBA m_xkb_icon_rgba;
	XKBLayout* m_xkblayout;
	gboolean inited_engines_order;
	guint m_preload_engines_id;
	gchar* m_icon_prop_key;
	gint m_property_icon_delay_time;
	guint m_property_icon_delay_time_id;
	guint m_menu_update_delay_time;
	guint m_menu_update_delay_time_id;
	gboolean m_is_wayland;
	gboolean m_is_wayland_im;
	gboolean m_is_kde;
	gboolean m_is_context_menu;
	gulong m_popup_menu_id;
	gulong m_activate_id;
	gulong m_registered_status_notifier_item_id;
	FILE* m_log;
	gboolean m_verbose;
	GList* m_keybindings;
};

struct _Block6Data {
	int _ref_count_;
	Panel* self;
	GdkRectangle area;
	GdkWindow* window;
	GtkMenuPositionFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

struct _Block7Data {
	int _ref_count_;
	Panel* self;
	gchar** names;
	gint names_length1;
	gint _names_size_;
};

struct _Block8Data {
	int _ref_count_;
	Panel* self;
	GtkMessageDialog* dialog;
};

struct _Block9Data {
	int _ref_count_;
	Panel* self;
	IBusEngineDesc* e;
};

struct _Block10Data {
	int _ref_count_;
	Panel* self;
	gchar* symbol;
};

static gint Panel_private_offset;
static gpointer panel_parent_class = NULL;

VALA_EXTERN GType panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Panel, g_object_unref)
static GType panel_icon_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indicator, g_object_unref)
VALA_EXTERN GType candidate_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CandidatePanel, g_object_unref)
VALA_EXTERN GType switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Switcher, g_object_unref)
VALA_EXTERN gpointer property_manager_ref (gpointer instance);
VALA_EXTERN void property_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_property_manager (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_property_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_property_manager (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_property_manager (const GValue* value);
VALA_EXTERN GType property_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyManager, property_manager_unref)
VALA_EXTERN GType property_panel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PropertyPanel, g_object_unref)
VALA_EXTERN gpointer xkb_layout_ref (gpointer instance);
VALA_EXTERN void xkb_layout_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_xkb_layout (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_xkb_layout (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_xkb_layout (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_xkb_layout (const GValue* value);
VALA_EXTERN GType xkb_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (XKBLayout, xkb_layout_unref)
VALA_EXTERN GType binding_common_keybinding_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BindingCommonKeybinding, g_object_unref)
VALA_EXTERN void indicator_unregister_connection (Indicator* self);
VALA_EXTERN GType binding_common_key_event_func_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void binding_common_unbind_switch_shortcut (BindingCommonKeyEventFuncType ftype,
                                            GList* keybindings);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _g_free0_ (gpointer var);
static void _cairo_surface_destroy0_ (gpointer var);
VALA_EXTERN XKBLayout* xkb_layout_new (void);
VALA_EXTERN XKBLayout* xkb_layout_construct (GType object_type);
static gboolean panel_is_kde (void);
VALA_EXTERN Panel* panel_new (IBusBus* bus,
                  gboolean is_wayland_im);
VALA_EXTERN Panel* panel_construct (GType object_type,
                        IBusBus* bus,
                        gboolean is_wayland_im);
static void panel_init_settings (Panel* self);
VALA_EXTERN PropertyManager* property_manager_new (void);
VALA_EXTERN PropertyManager* property_manager_construct (GType object_type);
static void __lambda84_ (Panel* self,
                  PropertyManager* w,
                  const gchar* k,
                  gint s);
static void ___lambda84__property_manager_property_activate (PropertyManager* _sender,
                                                      const gchar* key,
                                                      gint state,
                                                      gpointer self);
static void panel_init_indicator (Panel* self);
static void panel_init_status_icon (Panel* self);
VALA_EXTERN CandidatePanel* candidate_panel_new (void);
VALA_EXTERN CandidatePanel* candidate_panel_construct (GType object_type);
static void __lambda96_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda96__candidate_panel_page_up (CandidatePanel* _sender,
                                           gpointer self);
static void __lambda97_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda97__candidate_panel_page_down (CandidatePanel* _sender,
                                             gpointer self);
static void __lambda98_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda98__candidate_panel_cursor_up (CandidatePanel* _sender,
                                             gpointer self);
static void __lambda99_ (Panel* self,
                  CandidatePanel* w);
static void ___lambda99__candidate_panel_cursor_down (CandidatePanel* _sender,
                                               gpointer self);
static void __lambda100_ (Panel* self,
                   CandidatePanel* w,
                   guint i,
                   guint b,
                   guint s);
static void ___lambda100__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                      guint index,
                                                      guint button,
                                                      guint state,
                                                      gpointer self);
static void __lambda101_ (Panel* self,
                   CandidatePanel* w,
                   void* s);
static void ___lambda101__candidate_panel_realize_surface (CandidatePanel* _sender,
                                                    void* surface,
                                                    gpointer self);
VALA_EXTERN Switcher* switcher_new (void);
VALA_EXTERN Switcher* switcher_construct (GType object_type);
static void __lambda102_ (Panel* self,
                   Switcher* w,
                   void* s);
static void ___lambda102__switcher_realize_surface (Switcher* _sender,
                                             void* surface,
                                             gpointer self);
static void panel_bind_switch_shortcut (Panel* self);
VALA_EXTERN void switcher_set_popup_delay_time (Switcher* self,
                                    guint popup_delay_time);
VALA_EXTERN PropertyPanel* property_panel_new (void);
VALA_EXTERN PropertyPanel* property_panel_construct (GType object_type);
static void __lambda103_ (Panel* self,
                   PropertyPanel* w,
                   const gchar* k,
                   gint s);
static void ___lambda103__property_panel_property_activate (PropertyPanel* _sender,
                                                     const gchar* key,
                                                     gint state,
                                                     gpointer self);
static void __lambda60_ (Panel* self,
                  const gchar* key);
static void panel_update_engines (Panel* self,
                           gchar** unowned_engine_names,
                           gint unowned_engine_names_length1,
                           gchar** order_names,
                           gint order_names_length1);
static void ___lambda60__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda63_ (Panel* self,
                  const gchar* key);
static void panel_set_switcher_delay_time (Panel* self);
static void ___lambda63__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda64_ (Panel* self,
                  const gchar* key);
static void panel_set_use_system_keyboard_layout (Panel* self);
static void ___lambda64__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda65_ (Panel* self,
                  const gchar* key);
static void panel_set_embed_preedit_text (Panel* self);
static void ___lambda65__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda66_ (Panel* self,
                  const gchar* key);
static void panel_set_use_global_engine (Panel* self);
static void ___lambda66__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda67_ (Panel* self,
                  const gchar* key);
static void panel_set_use_xmodmap (Panel* self);
static void ___lambda67__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda68_ (Panel* self,
                  const gchar* key);
static void ___lambda68__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda70_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_font (GSettings* settings_panel,
                                     GSettings* settings_emoji,
                                     GtkCssProvider** css_provider);
static void ___lambda70__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda71_ (Panel* self,
                  const gchar* key);
static void ___lambda71__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda72_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_theme (GSettings* settings_panel);
static void ___lambda72__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda73_ (Panel* self,
                  const gchar* key);
static void ___lambda73__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda74_ (Panel* self,
                  const gchar* key);
VALA_EXTERN void binding_common_set_custom_icon (GSettings* settings_panel);
static void ___lambda74__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda75_ (Panel* self,
                  const gchar* key);
static void ___lambda75__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda76_ (Panel* self,
                  const gchar* key);
static void panel_set_language_from_engine (Panel* self,
                                     IBusEngineDesc* engine);
static void ___lambda76__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda77_ (Panel* self,
                  const gchar* key);
static void panel_set_show_icon_on_systray (Panel* self);
static void ___lambda77__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda78_ (Panel* self,
                  const gchar* key);
static void panel_set_lookup_table_orientation (Panel* self);
static void ___lambda78__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda79_ (Panel* self,
                  const gchar* key);
static void panel_set_show_property_panel (Panel* self);
static void ___lambda79__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda80_ (Panel* self,
                  const gchar* key);
static void panel_set_timeout_property_panel (Panel* self);
static void ___lambda80__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda81_ (Panel* self,
                  const gchar* key);
static void panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self);
static void ___lambda81__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda82_ (Panel* self,
                  const gchar* key);
static void panel_set_xkb_icon_rgba (Panel* self);
static void ___lambda82__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void __lambda83_ (Panel* self,
                  const gchar* key);
static void panel_set_property_icon_delay_time (Panel* self);
static void ___lambda83__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void panel_popup_menu_at_area_window (Panel* self,
                                      GtkMenu* menu,
                                      GdkRectangle* area,
                                      GdkWindow* window,
                                      GtkMenuPositionFunc func,
                                      gpointer func_target);
static gboolean panel_is_gnome (void);
static void panel_popup_menu_at_pointer_window (Panel* self,
                                         GtkMenu* menu,
                                         gint x,
                                         gint y,
                                         GdkWindow* window,
                                         GtkMenuPositionFunc func,
                                         gpointer func_target);
VALA_EXTERN GType indicator_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Indicator* indicator_new (const gchar* id,
                          IndicatorCategory category);
VALA_EXTERN Indicator* indicator_construct (GType object_type,
                                const gchar* id,
                                IndicatorCategory category);
VALA_EXTERN void indicator_set_title (Indicator* self,
                          const gchar* value);
static void __lambda85_ (Panel* self);
VALA_EXTERN GType indicator_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void indicator_set_status (Indicator* self,
                           IndicatorStatus status);
static void ___lambda85__indicator_registered_status_notifier_item (Indicator* _sender,
                                                             gpointer self);
static void __lambda86_ (Panel* self);
VALA_EXTERN void indicator_set_menu (Indicator* self,
                         GtkMenu* menu);
static GtkMenu* panel_create_context_menu (Panel* self,
                                    gboolean use_x11);
static GtkMenu* panel_create_activate_menu (Panel* self,
                                     gboolean use_x11);
static void ___lambda86__indicator_secondary_activate (Indicator* _sender,
                                                gpointer self);
static void panel_init_status_icon_menu (Panel* self);
static void _panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN GdkX11Display* binding_common_get_xdisplay (void);
VALA_EXTERN gboolean binding_common_default_is_xdisplay (void);
static void __lambda94_ (Block6Data* _data6_,
                  guint b,
                  guint t);
static void ___lambda94__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                              guint button,
                                              guint activate_time,
                                              gpointer self);
static void __lambda95_ (Block6Data* _data6_);
static void ___lambda95__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                            gpointer self);
VALA_EXTERN GType keybinding_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeybindingManager, g_object_unref)
VALA_EXTERN KeybindingManager* keybinding_manager_get_instance (void);
VALA_EXTERN void binding_common_keybinding_manager_bind (KeybindingManager* keybinding_manager,
                                             GList** keybindings,
                                             const gchar* accelerator,
                                             BindingCommonKeyEventFuncType ftype,
                                             KeybindingManagerKeybindingHandlerFunc handler_normal,
                                             gpointer handler_normal_target,
                                             KeybindingManagerKeybindingHandlerFunc handler_reverse,
                                             gpointer handler_reverse_target);
static void panel_handle_engine_switch_normal (Panel* self,
                                        GdkEvent* event);
static void _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                    gpointer self);
static void panel_handle_engine_switch_reverse (Panel* self,
                                         GdkEvent* event);
static void _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                     gpointer self);
VALA_EXTERN gboolean binding_common_keybinding_get_reverse (BindingCommonKeybinding* self);
VALA_EXTERN guint binding_common_keybinding_get_keysym (BindingCommonKeybinding* self);
VALA_EXTERN GdkModifierType binding_common_keybinding_get_modifiers (BindingCommonKeybinding* self);
static void _vala_array_add18 (IBusProcessKeyEventData* * array,
                        gint* length,
                        gint* size,
                        const IBusProcessKeyEventData* value);
static void _vala_array_add19 (IBusProcessKeyEventData* * array,
                        gint* length,
                        gint* size,
                        const IBusProcessKeyEventData* value);
static GList* panel_get_engines_from_xkb (Panel* self,
                                   GList* engines);
VALA_EXTERN void xkb_layout_get_layout (gchar** layout,
                            gchar** variant,
                            gchar** option);
static GList* panel_get_engines_from_locale (Panel* self,
                                      GList* engines);
static gint __lambda104_ (IBusEngineDesc* a,
                   IBusEngineDesc* b);
static gint ___lambda104__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void panel_init_engines_order (Panel* self);
VALA_EXTERN void xkb_layout_set_latin_layouts (XKBLayout* self,
                                   gchar** xkb_latin_layouts,
                                   gint xkb_latin_layouts_length1);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void xkb_layout_set_use_xmodmap (XKBLayout* self,
                                 gboolean use_xmodmap);
VALA_EXTERN void candidate_panel_set_vertical (CandidatePanel* self,
                                   gboolean vertical);
VALA_EXTERN void property_panel_set_show (PropertyPanel* self,
                              gint _show);
VALA_EXTERN void property_panel_set_auto_hide_timeout (PropertyPanel* self,
                                           guint timeout);
VALA_EXTERN void property_panel_set_follow_input_cursor_when_always_shown (PropertyPanel* self,
                                                               gboolean is_follow);
static gint panel_compare_versions (Panel* self,
                             const gchar* version1,
                             const gchar* version2);
static void panel_update_version_1_5_8 (Panel* self);
static void panel_set_version (Panel* self);
static void panel_check_wayland (Panel* self);
static void panel_save_log (Panel* self,
                     const gchar* format);
VALA_EXTERN void panel_load_settings (Panel* self);
VALA_EXTERN void panel_disconnect_signals (Panel* self);
VALA_EXTERN void panel_set_global_shortcut_key_state (Panel* self,
                                          IBusBusGlobalBindingType type,
                                          gboolean is_pressed,
                                          gboolean is_backward);
static void panel_handle_engine_switch_focused (Panel* self,
                                         gboolean pressed,
                                         gboolean reverse);
VALA_EXTERN void panel_set_log (Panel* self,
                    FILE* log,
                    gboolean verbose);
static void panel_engine_contexts_insert (Panel* self,
                                   IBusEngineDesc* engine);
VALA_EXTERN void candidate_panel_set_language (CandidatePanel* self,
                                   PangoAttribute* language_attribute);
static void panel_set_engine (Panel* self,
                       IBusEngineDesc* engine);
VALA_EXTERN void xkb_layout_set_layout (XKBLayout* self,
                            IBusEngineDesc* engine);
static void panel_switch_engine (Panel* self,
                          gint i,
                          gboolean force);
static void panel_handle_engine_switch (Panel* self,
                                 GdkEvent* event,
                                 gboolean reverse);
VALA_EXTERN GdkModifierType keybinding_manager_get_primary_modifier (guint binding_mask);
VALA_EXTERN gboolean keybinding_manager_primary_modifier_still_pressed (GdkEvent* event,
                                                            guint primary_modifier);
VALA_EXTERN gint switcher_run (Switcher* self,
                   guint keyval,
                   guint state,
                   GdkEvent* event,
                   IBusEngineDesc** engines,
                   gint engines_length1,
                   gint index,
                   const gchar* input_context_path);
static void panel_switcher_focus_set_engine (Panel* self);
VALA_EXTERN gint switcher_run_popup (Switcher* self,
                         IBusEngineDesc** engines,
                         gint engines_length1,
                         gint index);
static gboolean ___lambda105_ (Panel* self);
static void panel_handle_engine_switch_release (Panel* self,
                                         gboolean is_timeout);
static gpointer ____lambda105__gthread_func (gpointer self);
static void panel_run_preload_engines (Panel* self,
                                IBusEngineDesc** engines,
                                gint engines_length1,
                                gint index);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean __lambda62_ (Block7Data* _data7_);
static gboolean ___lambda62__gsource_func (gpointer self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add24 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda61_ (Block8Data* _data8_,
                   gint id);
static void ____lambda61__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static IBusEngineDesc** _vala_array_dup3 (IBusEngineDesc** self,
                                   gssize length);
static IBusEngineDesc** _vala_array_dup4 (IBusEngineDesc** self,
                                   gssize length);
static void panel_context_render_string (Panel* self,
                                  cairo_t* cr,
                                  const gchar* symbol,
                                  gint image_width,
                                  gint image_height);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static cairo_surface_t* panel_create_cairo_image_surface_with_string (Panel* self,
                                                               const gchar* symbol,
                                                               gboolean cache);
static GdkPixbuf* panel_create_icon_pixbuf_with_string (Panel* self,
                                                 const gchar* symbol);
static void panel_show_setup_dialog (Panel* self);
static void __lambda88_ (Panel* self,
                  GPid pid,
                  gint state);
static void ___lambda88__gchild_watch_func (GPid pid,
                                     gint wait_status,
                                     gpointer self);
static void panel_show_about_dialog (Panel* self);
static void __lambda87_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda89_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda90_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda91_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda92_ (Panel* self,
                  GtkMenuItem* i);
static void ___lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
VALA_EXTERN gint property_manager_create_menu_items (PropertyManager* self,
                                         GtkMenu* menu);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void ____lambda93_ (Block9Data* _data9_,
                    GtkMenuItem* item);
static void _____lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void panel_set_properties (Panel* self,
                           IBusPropList* props);
static void panel_set_property (Panel* self,
                         IBusProperty* prop,
                         gboolean all_update);
static void panel_animate_icon (Panel* self,
                         const gchar* symbol,
                         gboolean all_update);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean __lambda106_ (Block10Data* _data10_);
VALA_EXTERN void indicator_set_cairo_image_surface_full (Indicator* self,
                                             cairo_surface_t* image,
                                             const gchar* icon_desc);
static gboolean ___lambda106__gsource_func (gpointer self);
static void panel_real_set_cursor_location (IBusPanelService* base,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height);
VALA_EXTERN void candidate_panel_set_cursor_location (CandidatePanel* self,
                                          gint x,
                                          gint y,
                                          gint width,
                                          gint height);
VALA_EXTERN void property_panel_set_cursor_location (PropertyPanel* self,
                                         gint x,
                                         gint y,
                                         gint width,
                                         gint height);
static gboolean panel_switcher_focus_set_engine_real (Panel* self);
VALA_EXTERN IBusEngineDesc* switcher_get_selected_engine (Switcher* self);
VALA_EXTERN gchar* switcher_get_input_context_path (Switcher* self);
VALA_EXTERN void switcher_reset (Switcher* self);
VALA_EXTERN gboolean switcher_is_running (Switcher* self);
static gboolean ___lambda69_ (Panel* self);
static gboolean ____lambda69__gsource_func (gpointer self);
static void panel_real_focus_in (IBusPanelService* base,
                          const gchar* input_context_path);
VALA_EXTERN void property_panel_focus_in (PropertyPanel* self);
static void panel_real_focus_out (IBusPanelService* base,
                           const gchar* input_context_path);
static void panel_real_destroy_context (IBusPanelService* base,
                                 const gchar* input_context_path);
static void panel_real_register_properties (IBusPanelService* base,
                                     IBusPropList* props);
VALA_EXTERN void property_manager_set_properties (PropertyManager* self,
                                      IBusPropList* props);
VALA_EXTERN void property_panel_set_properties (PropertyPanel* self,
                                    IBusPropList* props);
static gboolean __lambda107_ (Panel* self);
static gboolean ___lambda107__gsource_func (gpointer self);
static void panel_real_update_property (IBusPanelService* base,
                                 IBusProperty* prop);
VALA_EXTERN void property_manager_update_property (PropertyManager* self,
                                       IBusProperty* prop);
VALA_EXTERN void property_panel_update_property (PropertyPanel* self,
                                     IBusProperty* prop);
static void panel_real_update_preedit_text (IBusPanelService* base,
                                     IBusText* text,
                                     guint cursor_pos,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_preedit_text (CandidatePanel* self,
                                       IBusText* text,
                                       guint cursor);
VALA_EXTERN void property_panel_set_preedit_text (PropertyPanel* self,
                                      IBusText* text,
                                      guint cursor);
static void panel_real_hide_preedit_text (IBusPanelService* base);
static void panel_real_update_auxiliary_text (IBusPanelService* base,
                                       IBusText* text,
                                       gboolean visible);
VALA_EXTERN void candidate_panel_set_auxiliary_text (CandidatePanel* self,
                                         IBusText* text);
VALA_EXTERN void property_panel_set_auxiliary_text (PropertyPanel* self,
                                        IBusText* text);
static void panel_real_hide_auxiliary_text (IBusPanelService* base);
static void panel_real_update_lookup_table (IBusPanelService* base,
                                     IBusLookupTable* table,
                                     gboolean visible);
VALA_EXTERN void candidate_panel_set_lookup_table (CandidatePanel* self,
                                       IBusLookupTable* table);
VALA_EXTERN void property_panel_set_lookup_table (PropertyPanel* self,
                                      IBusLookupTable* table);
static void panel_real_hide_lookup_table (IBusPanelService* base);
static void panel_real_set_content_type (IBusPanelService* base,
                                  guint purpose,
                                  guint hints);
VALA_EXTERN void candidate_panel_set_content_type (CandidatePanel* self,
                                       guint purpose,
                                       guint hints);
static void panel_real_state_changed (IBusPanelService* base);
VALA_EXTERN void indicator_set_icon_full (Indicator* self,
                              const gchar* icon_name,
                              const gchar* icon_desc);
VALA_EXTERN gchar* switcher_get_xkb_language (Switcher* self,
                                  IBusEngineDesc* engine);
static void _vala_array_add25 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void g_cclosure_user_marshal_VOID__POINTER_INT_ENUM (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static void panel_finalize (GObject * obj);
static GType panel_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
panel_get_instance_private (Panel* self)
{
	return G_STRUCT_MEMBER_P (self, Panel_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 182 "panel.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 960 "panel.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 182 "panel.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 968 "panel.c"
}

static GType
panel_icon_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PANEL_ICON_TYPE_STATUS_ICON, "PANEL_ICON_TYPE_STATUS_ICON", "status-icon"}, {PANEL_ICON_TYPE_INDICATOR, "PANEL_ICON_TYPE_INDICATOR", "indicator"}, {0, NULL, NULL}};
	GType panel_icon_type_type_id;
	panel_icon_type_type_id = g_enum_register_static ("PanelIconType", values);
	return panel_icon_type_type_id;
}

static GType
panel_icon_type_get_type (void)
{
	static volatile gsize panel_icon_type_type_id__once = 0;
	if (g_once_init_enter (&panel_icon_type_type_id__once)) {
		GType panel_icon_type_type_id;
		panel_icon_type_type_id = panel_icon_type_get_type_once ();
		g_once_init_leave (&panel_icon_type_type_id__once, panel_icon_type_type_id);
	}
	return panel_icon_type_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 43 "panel.vala"
	var = (g_free (var), NULL);
#line 997 "panel.c"
}

static void
_cairo_surface_destroy0_ (gpointer var)
{
#line 65 "panel.vala"
	(var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL));
#line 1005 "panel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "panel.vala"
	return self ? g_object_ref (self) : NULL;
#line 1013 "panel.c"
}

static void
__lambda84_ (Panel* self,
             PropertyManager* w,
             const gchar* k,
             gint s)
{
#line 127 "panel.vala"
	g_return_if_fail (w != NULL);
#line 127 "panel.vala"
	g_return_if_fail (k != NULL);
#line 128 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1028 "panel.c"
}

static void
___lambda84__property_manager_property_activate (PropertyManager* _sender,
                                                 const gchar* key,
                                                 gint state,
                                                 gpointer self)
{
#line 127 "panel.vala"
	__lambda84_ ((Panel*) self, _sender, key, state);
#line 1039 "panel.c"
}

static void
__lambda96_ (Panel* self,
             CandidatePanel* w)
{
#line 143 "panel.vala"
	g_return_if_fail (w != NULL);
#line 143 "panel.vala"
	ibus_panel_service_page_up ((IBusPanelService*) self);
#line 1050 "panel.c"
}

static void
___lambda96__candidate_panel_page_up (CandidatePanel* _sender,
                                      gpointer self)
{
#line 143 "panel.vala"
	__lambda96_ ((Panel*) self, _sender);
#line 1059 "panel.c"
}

static void
__lambda97_ (Panel* self,
             CandidatePanel* w)
{
#line 144 "panel.vala"
	g_return_if_fail (w != NULL);
#line 144 "panel.vala"
	ibus_panel_service_page_down ((IBusPanelService*) self);
#line 1070 "panel.c"
}

static void
___lambda97__candidate_panel_page_down (CandidatePanel* _sender,
                                        gpointer self)
{
#line 144 "panel.vala"
	__lambda97_ ((Panel*) self, _sender);
#line 1079 "panel.c"
}

static void
__lambda98_ (Panel* self,
             CandidatePanel* w)
{
#line 145 "panel.vala"
	g_return_if_fail (w != NULL);
#line 145 "panel.vala"
	ibus_panel_service_cursor_up ((IBusPanelService*) self);
#line 1090 "panel.c"
}

static void
___lambda98__candidate_panel_cursor_up (CandidatePanel* _sender,
                                        gpointer self)
{
#line 145 "panel.vala"
	__lambda98_ ((Panel*) self, _sender);
#line 1099 "panel.c"
}

static void
__lambda99_ (Panel* self,
             CandidatePanel* w)
{
#line 146 "panel.vala"
	g_return_if_fail (w != NULL);
#line 146 "panel.vala"
	ibus_panel_service_cursor_down ((IBusPanelService*) self);
#line 1110 "panel.c"
}

static void
___lambda99__candidate_panel_cursor_down (CandidatePanel* _sender,
                                          gpointer self)
{
#line 146 "panel.vala"
	__lambda99_ ((Panel*) self, _sender);
#line 1119 "panel.c"
}

static void
__lambda100_ (Panel* self,
              CandidatePanel* w,
              guint i,
              guint b,
              guint s)
{
#line 148 "panel.vala"
	g_return_if_fail (w != NULL);
#line 148 "panel.vala"
	ibus_panel_service_candidate_clicked ((IBusPanelService*) self, i, b, s);
#line 1133 "panel.c"
}

static void
___lambda100__candidate_panel_candidate_clicked (CandidatePanel* _sender,
                                                 guint index,
                                                 guint button,
                                                 guint state,
                                                 gpointer self)
{
#line 147 "panel.vala"
	__lambda100_ ((Panel*) self, _sender, index, button, state);
#line 1145 "panel.c"
}

static void
__lambda101_ (Panel* self,
              CandidatePanel* w,
              void* s)
{
#line 151 "panel.vala"
	g_return_if_fail (w != NULL);
#line 151 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, s);
#line 1157 "panel.c"
}

static void
___lambda101__candidate_panel_realize_surface (CandidatePanel* _sender,
                                               void* surface,
                                               gpointer self)
{
#line 150 "panel.vala"
	__lambda101_ ((Panel*) self, _sender, surface);
#line 1167 "panel.c"
}

static void
__lambda102_ (Panel* self,
              Switcher* w,
              void* s)
{
#line 157 "panel.vala"
	g_return_if_fail (w != NULL);
#line 157 "panel.vala"
	g_signal_emit (self, panel_signals[PANEL_REALIZE_SURFACE_SIGNAL], 0, s);
#line 1179 "panel.c"
}

static void
___lambda102__switcher_realize_surface (Switcher* _sender,
                                        void* surface,
                                        gpointer self)
{
#line 156 "panel.vala"
	__lambda102_ ((Panel*) self, _sender, surface);
#line 1189 "panel.c"
}

static void
__lambda103_ (Panel* self,
              PropertyPanel* w,
              const gchar* k,
              gint s)
{
#line 167 "panel.vala"
	g_return_if_fail (w != NULL);
#line 167 "panel.vala"
	g_return_if_fail (k != NULL);
#line 168 "panel.vala"
	ibus_panel_service_property_activate ((IBusPanelService*) self, k, (guint) s);
#line 1204 "panel.c"
}

static void
___lambda103__property_panel_property_activate (PropertyPanel* _sender,
                                                const gchar* key,
                                                gint state,
                                                gpointer self)
{
#line 167 "panel.vala"
	__lambda103_ ((Panel*) self, _sender, key, state);
#line 1215 "panel.c"
}

Panel*
panel_construct (GType object_type,
                 IBusBus* bus,
                 gboolean is_wayland_im)
{
	Panel * self = NULL;
	GDBusConnection* _tmp0_;
	IBusBus* _tmp1_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp2_;
	GdkDisplay* _tmp3_;
	GType instance_type = 0UL;
	GdkDisplay* _tmp4_;
	GType wayland_type = 0UL;
	PropertyManager* _tmp5_;
	PropertyManager* _tmp6_;
	CandidatePanel* _tmp7_;
	CandidatePanel* _tmp8_;
	CandidatePanel* _tmp9_;
	CandidatePanel* _tmp10_;
	CandidatePanel* _tmp11_;
	CandidatePanel* _tmp12_;
	CandidatePanel* _tmp13_;
	Switcher* _tmp14_;
	Switcher* _tmp15_;
	PropertyPanel* _tmp17_;
	PropertyPanel* _tmp18_;
#line 103 "panel.vala"
	g_return_val_if_fail (bus != NULL, NULL);
#line 105 "panel.vala"
	_vala_assert (ibus_bus_is_connected (bus), "bus.is_connected()");
#line 107 "panel.vala"
	_tmp0_ = ibus_bus_get_connection (bus);
#line 107 "panel.vala"
	self = (Panel*) g_object_new (object_type, "connection", _tmp0_, "object-path", "/org/freedesktop/IBus/Panel", NULL);
#line 110 "panel.vala"
	_tmp1_ = _g_object_ref0 (bus);
#line 110 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 110 "panel.vala"
	self->priv->m_bus = _tmp1_;
#line 111 "panel.vala"
	self->priv->m_is_wayland_im = is_wayland_im;
#line 114 "panel.vala"
	_tmp2_ = gdk_display_get_default ();
#line 114 "panel.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 114 "panel.vala"
	display = _tmp3_;
#line 115 "panel.vala"
	_tmp4_ = display;
#line 115 "panel.vala"
	instance_type = G_TYPE_FROM_INSTANCE ((GObject*) _tmp4_);
#line 116 "panel.vala"
	wayland_type = gdk_wayland_display_get_type ();
#line 117 "panel.vala"
	self->priv->m_is_wayland = g_type_is_a (instance_type, wayland_type);
#line 123 "panel.vala"
	panel_init_settings (self);
#line 126 "panel.vala"
	_tmp5_ = property_manager_new ();
#line 126 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 126 "panel.vala"
	self->priv->m_property_manager = _tmp5_;
#line 127 "panel.vala"
	_tmp6_ = self->priv->m_property_manager;
#line 127 "panel.vala"
	g_signal_connect_object (_tmp6_, "property-activate", (GCallback) ___lambda84__property_manager_property_activate, self, 0);
#line 133 "panel.vala"
	if (self->priv->m_is_kde) {
#line 134 "panel.vala"
		panel_init_indicator (self);
#line 1291 "panel.c"
	} else {
#line 136 "panel.vala"
		panel_init_status_icon (self);
#line 1295 "panel.c"
	}
#line 142 "panel.vala"
	_tmp7_ = candidate_panel_new ();
#line 142 "panel.vala"
	g_object_ref_sink (_tmp7_);
#line 142 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 142 "panel.vala"
	self->priv->m_candidate_panel = _tmp7_;
#line 143 "panel.vala"
	_tmp8_ = self->priv->m_candidate_panel;
#line 143 "panel.vala"
	g_signal_connect_object (_tmp8_, "page-up", (GCallback) ___lambda96__candidate_panel_page_up, self, 0);
#line 144 "panel.vala"
	_tmp9_ = self->priv->m_candidate_panel;
#line 144 "panel.vala"
	g_signal_connect_object (_tmp9_, "page-down", (GCallback) ___lambda97__candidate_panel_page_down, self, 0);
#line 145 "panel.vala"
	_tmp10_ = self->priv->m_candidate_panel;
#line 145 "panel.vala"
	g_signal_connect_object (_tmp10_, "cursor-up", (GCallback) ___lambda98__candidate_panel_cursor_up, self, 0);
#line 146 "panel.vala"
	_tmp11_ = self->priv->m_candidate_panel;
#line 146 "panel.vala"
	g_signal_connect_object (_tmp11_, "cursor-down", (GCallback) ___lambda99__candidate_panel_cursor_down, self, 0);
#line 147 "panel.vala"
	_tmp12_ = self->priv->m_candidate_panel;
#line 147 "panel.vala"
	g_signal_connect_object (_tmp12_, "candidate-clicked", (GCallback) ___lambda100__candidate_panel_candidate_clicked, self, 0);
#line 150 "panel.vala"
	_tmp13_ = self->priv->m_candidate_panel;
#line 150 "panel.vala"
	g_signal_connect_object (_tmp13_, "realize-surface", (GCallback) ___lambda101__candidate_panel_realize_surface, self, 0);
#line 154 "panel.vala"
	_tmp14_ = switcher_new ();
#line 154 "panel.vala"
	g_object_ref_sink (_tmp14_);
#line 154 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 154 "panel.vala"
	self->priv->m_switcher = _tmp14_;
#line 156 "panel.vala"
	_tmp15_ = self->priv->m_switcher;
#line 156 "panel.vala"
	g_signal_connect_object (_tmp15_, "realize-surface", (GCallback) ___lambda102__switcher_realize_surface, self, 0);
#line 160 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 162 "panel.vala"
	if (self->priv->m_switcher_delay_time >= 0) {
#line 1345 "panel.c"
		Switcher* _tmp16_;
#line 163 "panel.vala"
		_tmp16_ = self->priv->m_switcher;
#line 163 "panel.vala"
		switcher_set_popup_delay_time (_tmp16_, (guint) self->priv->m_switcher_delay_time);
#line 1351 "panel.c"
	}
#line 166 "panel.vala"
	_tmp17_ = property_panel_new ();
#line 166 "panel.vala"
	g_object_ref_sink (_tmp17_);
#line 166 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 166 "panel.vala"
	self->priv->m_property_panel = _tmp17_;
#line 167 "panel.vala"
	_tmp18_ = self->priv->m_property_panel;
#line 167 "panel.vala"
	g_signal_connect_object (_tmp18_, "property-activate", (GCallback) ___lambda103__property_panel_property_activate, self, 0);
#line 171 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 103 "panel.vala"
	_g_object_unref0 (display);
#line 103 "panel.vala"
	return self;
#line 1371 "panel.c"
}

Panel*
panel_new (IBusBus* bus,
           gboolean is_wayland_im)
{
#line 103 "panel.vala"
	return panel_construct (TYPE_PANEL, bus, is_wayland_im);
#line 1380 "panel.c"
}

static void
__lambda60_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 191 "panel.vala"
	g_return_if_fail (key != NULL);
#line 192 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 192 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, key);
#line 192 "panel.vala"
	_tmp3_ = _tmp2_;
#line 192 "panel.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 192 "panel.vala"
	panel_update_engines (self, _tmp3_, (gint) _vala_array_length (_tmp1_), NULL, (gint) 0);
#line 192 "panel.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 1406 "panel.c"
}

static void
___lambda60__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 191 "panel.vala"
	__lambda60_ ((Panel*) self, key);
#line 1416 "panel.c"
}

static void
__lambda63_ (Panel* self,
             const gchar* key)
{
#line 196 "panel.vala"
	g_return_if_fail (key != NULL);
#line 197 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 1427 "panel.c"
}

static void
___lambda63__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 196 "panel.vala"
	__lambda63_ ((Panel*) self, key);
#line 1437 "panel.c"
}

static void
__lambda64_ (Panel* self,
             const gchar* key)
{
#line 201 "panel.vala"
	g_return_if_fail (key != NULL);
#line 202 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 1448 "panel.c"
}

static void
___lambda64__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 200 "panel.vala"
	__lambda64_ ((Panel*) self, key);
#line 1458 "panel.c"
}

static void
__lambda65_ (Panel* self,
             const gchar* key)
{
#line 205 "panel.vala"
	g_return_if_fail (key != NULL);
#line 206 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 1469 "panel.c"
}

static void
___lambda65__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 205 "panel.vala"
	__lambda65_ ((Panel*) self, key);
#line 1479 "panel.c"
}

static void
__lambda66_ (Panel* self,
             const gchar* key)
{
#line 209 "panel.vala"
	g_return_if_fail (key != NULL);
#line 210 "panel.vala"
	panel_set_use_global_engine (self);
#line 1490 "panel.c"
}

static void
___lambda66__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 209 "panel.vala"
	__lambda66_ ((Panel*) self, key);
#line 1500 "panel.c"
}

static void
__lambda67_ (Panel* self,
             const gchar* key)
{
#line 213 "panel.vala"
	g_return_if_fail (key != NULL);
#line 214 "panel.vala"
	panel_set_use_xmodmap (self);
#line 1511 "panel.c"
}

static void
___lambda67__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 213 "panel.vala"
	__lambda67_ ((Panel*) self, key);
#line 1521 "panel.c"
}

static void
__lambda68_ (Panel* self,
             const gchar* key)
{
	GList* _tmp0_;
#line 217 "panel.vala"
	g_return_if_fail (key != NULL);
#line 218 "panel.vala"
	_tmp0_ = self->priv->m_keybindings;
#line 218 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER, _tmp0_);
#line 221 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 221 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 222 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 1541 "panel.c"
}

static void
___lambda68__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 217 "panel.vala"
	__lambda68_ ((Panel*) self, key);
#line 1551 "panel.c"
}

static void
__lambda70_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 225 "panel.vala"
	g_return_if_fail (key != NULL);
#line 226 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 226 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1565 "panel.c"
}

static void
___lambda70__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 225 "panel.vala"
	__lambda70_ ((Panel*) self, key);
#line 1575 "panel.c"
}

static void
__lambda71_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 231 "panel.vala"
	g_return_if_fail (key != NULL);
#line 232 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 232 "panel.vala"
	binding_common_set_custom_font (_tmp0_, NULL, &self->priv->m_css_provider);
#line 1589 "panel.c"
}

static void
___lambda71__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 231 "panel.vala"
	__lambda71_ ((Panel*) self, key);
#line 1599 "panel.c"
}

static void
__lambda72_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 237 "panel.vala"
	g_return_if_fail (key != NULL);
#line 238 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 238 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1613 "panel.c"
}

static void
___lambda72__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 237 "panel.vala"
	__lambda72_ ((Panel*) self, key);
#line 1623 "panel.c"
}

static void
__lambda73_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 241 "panel.vala"
	g_return_if_fail (key != NULL);
#line 242 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 242 "panel.vala"
	binding_common_set_custom_theme (_tmp0_);
#line 1637 "panel.c"
}

static void
___lambda73__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 241 "panel.vala"
	__lambda73_ ((Panel*) self, key);
#line 1647 "panel.c"
}

static void
__lambda74_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 245 "panel.vala"
	g_return_if_fail (key != NULL);
#line 246 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 246 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 1661 "panel.c"
}

static void
___lambda74__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 245 "panel.vala"
	__lambda74_ ((Panel*) self, key);
#line 1671 "panel.c"
}

static void
__lambda75_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
#line 249 "panel.vala"
	g_return_if_fail (key != NULL);
#line 250 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 250 "panel.vala"
	binding_common_set_custom_icon (_tmp0_);
#line 1685 "panel.c"
}

static void
___lambda75__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 249 "panel.vala"
	__lambda75_ ((Panel*) self, key);
#line 1695 "panel.c"
}

static void
__lambda76_ (Panel* self,
             const gchar* key)
{
	GSettings* _tmp0_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp1_;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* _tmp3_;
#line 253 "panel.vala"
	g_return_if_fail (key != NULL);
#line 255 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 255 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 257 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 257 "panel.vala"
	_tmp2_ = ibus_bus_get_global_engine (_tmp1_);
#line 257 "panel.vala"
	engine = _tmp2_;
#line 258 "panel.vala"
	_tmp3_ = engine;
#line 258 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1723 "panel.c"
		IBusEngineDesc* _tmp4_;
#line 259 "panel.vala"
		_tmp4_ = engine;
#line 259 "panel.vala"
		panel_set_language_from_engine (self, _tmp4_);
#line 1729 "panel.c"
	}
#line 253 "panel.vala"
	_g_object_unref0 (engine);
#line 1733 "panel.c"
}

static void
___lambda76__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 253 "panel.vala"
	__lambda76_ ((Panel*) self, key);
#line 1743 "panel.c"
}

static void
__lambda77_ (Panel* self,
             const gchar* key)
{
#line 262 "panel.vala"
	g_return_if_fail (key != NULL);
#line 263 "panel.vala"
	panel_set_show_icon_on_systray (self);
#line 1754 "panel.c"
}

static void
___lambda77__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 262 "panel.vala"
	__lambda77_ ((Panel*) self, key);
#line 1764 "panel.c"
}

static void
__lambda78_ (Panel* self,
             const gchar* key)
{
#line 266 "panel.vala"
	g_return_if_fail (key != NULL);
#line 267 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 1775 "panel.c"
}

static void
___lambda78__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 266 "panel.vala"
	__lambda78_ ((Panel*) self, key);
#line 1785 "panel.c"
}

static void
__lambda79_ (Panel* self,
             const gchar* key)
{
#line 270 "panel.vala"
	g_return_if_fail (key != NULL);
#line 271 "panel.vala"
	panel_set_show_property_panel (self);
#line 1796 "panel.c"
}

static void
___lambda79__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 270 "panel.vala"
	__lambda79_ ((Panel*) self, key);
#line 1806 "panel.c"
}

static void
__lambda80_ (Panel* self,
             const gchar* key)
{
#line 274 "panel.vala"
	g_return_if_fail (key != NULL);
#line 275 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 1817 "panel.c"
}

static void
___lambda80__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 274 "panel.vala"
	__lambda80_ ((Panel*) self, key);
#line 1827 "panel.c"
}

static void
__lambda81_ (Panel* self,
             const gchar* key)
{
#line 279 "panel.vala"
	g_return_if_fail (key != NULL);
#line 280 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 1838 "panel.c"
}

static void
___lambda81__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 278 "panel.vala"
	__lambda81_ ((Panel*) self, key);
#line 1848 "panel.c"
}

static void
__lambda82_ (Panel* self,
             const gchar* key)
{
#line 283 "panel.vala"
	g_return_if_fail (key != NULL);
#line 284 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 1859 "panel.c"
}

static void
___lambda82__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 283 "panel.vala"
	__lambda82_ ((Panel*) self, key);
#line 1869 "panel.c"
}

static void
__lambda83_ (Panel* self,
             const gchar* key)
{
#line 287 "panel.vala"
	g_return_if_fail (key != NULL);
#line 288 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 1880 "panel.c"
}

static void
___lambda83__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 287 "panel.vala"
	__lambda83_ ((Panel*) self, key);
#line 1890 "panel.c"
}

static void
panel_init_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
#line 185 "panel.vala"
	g_return_if_fail (self != NULL);
#line 186 "panel.vala"
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.general");
#line 186 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 186 "panel.vala"
	self->priv->m_settings_general = _tmp0_;
#line 187 "panel.vala"
	_tmp1_ = g_settings_new ("org.freedesktop.ibus.general.hotkey");
#line 187 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 187 "panel.vala"
	self->priv->m_settings_hotkey = _tmp1_;
#line 189 "panel.vala"
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
#line 189 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 189 "panel.vala"
	self->priv->m_settings_panel = _tmp2_;
#line 191 "panel.vala"
	_tmp3_ = self->priv->m_settings_general;
#line 191 "panel.vala"
	g_signal_connect_object (_tmp3_, "changed::preload-engines", (GCallback) ___lambda60__g_settings_changed, self, 0);
#line 196 "panel.vala"
	_tmp4_ = self->priv->m_settings_general;
#line 196 "panel.vala"
	g_signal_connect_object (_tmp4_, "changed::switcher-delay-time", (GCallback) ___lambda63__g_settings_changed, self, 0);
#line 200 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 200 "panel.vala"
	g_signal_connect_object (_tmp5_, "changed::use-system-keyboard-layout", (GCallback) ___lambda64__g_settings_changed, self, 0);
#line 205 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 205 "panel.vala"
	g_signal_connect_object (_tmp6_, "changed::embed-preedit-text", (GCallback) ___lambda65__g_settings_changed, self, 0);
#line 209 "panel.vala"
	_tmp7_ = self->priv->m_settings_general;
#line 209 "panel.vala"
	g_signal_connect_object (_tmp7_, "changed::use-global-engine", (GCallback) ___lambda66__g_settings_changed, self, 0);
#line 213 "panel.vala"
	_tmp8_ = self->priv->m_settings_general;
#line 213 "panel.vala"
	g_signal_connect_object (_tmp8_, "changed::use-xmodmap", (GCallback) ___lambda67__g_settings_changed, self, 0);
#line 217 "panel.vala"
	_tmp9_ = self->priv->m_settings_hotkey;
#line 217 "panel.vala"
	g_signal_connect_object (_tmp9_, "changed::triggers", (GCallback) ___lambda68__g_settings_changed, self, 0);
#line 225 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 225 "panel.vala"
	g_signal_connect_object (_tmp10_, "changed::custom-font", (GCallback) ___lambda70__g_settings_changed, self, 0);
#line 231 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 231 "panel.vala"
	g_signal_connect_object (_tmp11_, "changed::use-custom-font", (GCallback) ___lambda71__g_settings_changed, self, 0);
#line 237 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 237 "panel.vala"
	g_signal_connect_object (_tmp12_, "changed::custom-theme", (GCallback) ___lambda72__g_settings_changed, self, 0);
#line 241 "panel.vala"
	_tmp13_ = self->priv->m_settings_panel;
#line 241 "panel.vala"
	g_signal_connect_object (_tmp13_, "changed::use-custom-theme", (GCallback) ___lambda73__g_settings_changed, self, 0);
#line 245 "panel.vala"
	_tmp14_ = self->priv->m_settings_panel;
#line 245 "panel.vala"
	g_signal_connect_object (_tmp14_, "changed::custom-icon", (GCallback) ___lambda74__g_settings_changed, self, 0);
#line 249 "panel.vala"
	_tmp15_ = self->priv->m_settings_panel;
#line 249 "panel.vala"
	g_signal_connect_object (_tmp15_, "changed::use-custom-icon", (GCallback) ___lambda75__g_settings_changed, self, 0);
#line 253 "panel.vala"
	_tmp16_ = self->priv->m_settings_panel;
#line 253 "panel.vala"
	g_signal_connect_object (_tmp16_, "changed::use-glyph-from-engine-lang", (GCallback) ___lambda76__g_settings_changed, self, 0);
#line 262 "panel.vala"
	_tmp17_ = self->priv->m_settings_panel;
#line 262 "panel.vala"
	g_signal_connect_object (_tmp17_, "changed::show-icon-on-systray", (GCallback) ___lambda77__g_settings_changed, self, 0);
#line 266 "panel.vala"
	_tmp18_ = self->priv->m_settings_panel;
#line 266 "panel.vala"
	g_signal_connect_object (_tmp18_, "changed::lookup-table-orientation", (GCallback) ___lambda78__g_settings_changed, self, 0);
#line 270 "panel.vala"
	_tmp19_ = self->priv->m_settings_panel;
#line 270 "panel.vala"
	g_signal_connect_object (_tmp19_, "changed::show", (GCallback) ___lambda79__g_settings_changed, self, 0);
#line 274 "panel.vala"
	_tmp20_ = self->priv->m_settings_panel;
#line 274 "panel.vala"
	g_signal_connect_object (_tmp20_, "changed::timeout", (GCallback) ___lambda80__g_settings_changed, self, 0);
#line 278 "panel.vala"
	_tmp21_ = self->priv->m_settings_panel;
#line 278 "panel.vala"
	g_signal_connect_object (_tmp21_, "changed::follow-input-cursor-when-always-shown", (GCallback) ___lambda81__g_settings_changed, self, 0);
#line 283 "panel.vala"
	_tmp22_ = self->priv->m_settings_panel;
#line 283 "panel.vala"
	g_signal_connect_object (_tmp22_, "changed::xkb-icon-rgba", (GCallback) ___lambda82__g_settings_changed, self, 0);
#line 287 "panel.vala"
	_tmp23_ = self->priv->m_settings_panel;
#line 287 "panel.vala"
	g_signal_connect_object (_tmp23_, "changed::property-icon-delay-time", (GCallback) ___lambda83__g_settings_changed, self, 0);
#line 2024 "panel.c"
}

static void
panel_popup_menu_at_area_window (Panel* self,
                                 GtkMenu* menu,
                                 GdkRectangle* area,
                                 GdkWindow* window,
                                 GtkMenuPositionFunc func,
                                 gpointer func_target)
{
	GdkGravity rect_anchor = 0;
	GdkGravity menu_anchor = 0;
	GdkRectangle _tmp0_;
#line 292 "panel.vala"
	g_return_if_fail (self != NULL);
#line 292 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 292 "panel.vala"
	g_return_if_fail (area != NULL);
#line 296 "panel.vala"
	rect_anchor = GDK_GRAVITY_SOUTH_WEST;
#line 297 "panel.vala"
	menu_anchor = GDK_GRAVITY_NORTH_WEST;
#line 306 "panel.vala"
	_tmp0_ = *area;
#line 306 "panel.vala"
	gtk_menu_popup_at_rect (menu, window, &_tmp0_, rect_anchor, menu_anchor, NULL);
#line 2052 "panel.c"
}

static gboolean
panel_is_gnome (void)
{
	const gchar* desktop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gboolean result;
#line 311 "panel.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 311 "panel.vala"
	desktop = _tmp0_;
#line 313 "panel.vala"
	_tmp1_ = desktop;
#line 313 "panel.vala"
	if (g_strcmp0 (_tmp1_, "GNOME") == 0) {
#line 314 "panel.vala"
		result = TRUE;
#line 314 "panel.vala"
		return result;
#line 2078 "panel.c"
	}
#line 315 "panel.vala"
	_tmp3_ = desktop;
#line 315 "panel.vala"
	if (_tmp3_ == NULL) {
#line 315 "panel.vala"
		_tmp2_ = TRUE;
#line 2086 "panel.c"
	} else {
		const gchar* _tmp4_;
#line 315 "panel.vala"
		_tmp4_ = desktop;
#line 315 "panel.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "(null)") == 0;
#line 2093 "panel.c"
	}
#line 315 "panel.vala"
	if (_tmp2_) {
#line 2097 "panel.c"
		const gchar* _tmp5_;
#line 316 "panel.vala"
		_tmp5_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 316 "panel.vala"
		desktop = _tmp5_;
#line 2103 "panel.c"
	}
#line 317 "panel.vala"
	_tmp7_ = desktop;
#line 317 "panel.vala"
	if (g_strcmp0 (_tmp7_, "gnome") == 0) {
#line 317 "panel.vala"
		_tmp6_ = TRUE;
#line 2111 "panel.c"
	} else {
		const gchar* _tmp8_;
#line 317 "panel.vala"
		_tmp8_ = desktop;
#line 317 "panel.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "GNOME") == 0;
#line 2118 "panel.c"
	}
#line 317 "panel.vala"
	if (_tmp6_) {
#line 318 "panel.vala"
		result = TRUE;
#line 318 "panel.vala"
		return result;
#line 2126 "panel.c"
	}
#line 319 "panel.vala"
	result = FALSE;
#line 319 "panel.vala"
	return result;
#line 2132 "panel.c"
}

static gboolean
panel_is_kde (void)
{
	const gchar* desktop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp9_;
	gboolean result;
#line 325 "panel.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 325 "panel.vala"
	desktop = _tmp0_;
#line 327 "panel.vala"
	_tmp1_ = desktop;
#line 327 "panel.vala"
	if (g_strcmp0 (_tmp1_, "KDE") == 0) {
#line 328 "panel.vala"
		result = TRUE;
#line 328 "panel.vala"
		return result;
#line 2159 "panel.c"
	}
#line 334 "panel.vala"
	_tmp3_ = desktop;
#line 334 "panel.vala"
	if (_tmp3_ == NULL) {
#line 334 "panel.vala"
		_tmp2_ = TRUE;
#line 2167 "panel.c"
	} else {
		const gchar* _tmp4_;
#line 334 "panel.vala"
		_tmp4_ = desktop;
#line 334 "panel.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "(null)") == 0;
#line 2174 "panel.c"
	}
#line 334 "panel.vala"
	if (_tmp2_) {
#line 2178 "panel.c"
		const gchar* _tmp5_;
#line 335 "panel.vala"
		_tmp5_ = g_getenv ("XDG_SESSION_DESKTOP");
#line 335 "panel.vala"
		desktop = _tmp5_;
#line 2184 "panel.c"
	}
#line 336 "panel.vala"
	_tmp7_ = desktop;
#line 336 "panel.vala"
	if (g_strcmp0 (_tmp7_, "plasma") == 0) {
#line 336 "panel.vala"
		_tmp6_ = TRUE;
#line 2192 "panel.c"
	} else {
		const gchar* _tmp8_;
#line 336 "panel.vala"
		_tmp8_ = desktop;
#line 336 "panel.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "KDE-wayland") == 0;
#line 2199 "panel.c"
	}
#line 336 "panel.vala"
	if (_tmp6_) {
#line 337 "panel.vala"
		result = TRUE;
#line 337 "panel.vala"
		return result;
#line 2207 "panel.c"
	}
#line 338 "panel.vala"
	_tmp9_ = desktop;
#line 338 "panel.vala"
	if (_tmp9_ == NULL) {
#line 339 "panel.vala"
		g_warning ("panel.vala:339: %s", "XDG_CURRENT_DESKTOP is not exported in your desktop " "session.");
#line 2215 "panel.c"
	}
#line 342 "panel.vala"
	g_warning ("panel.vala:342: %s", "If you launch KDE5 on xterm, " "export XDG_CURRENT_DESKTOP=KDE before launch KDE5.");
#line 344 "panel.vala"
	result = FALSE;
#line 344 "panel.vala"
	return result;
#line 2223 "panel.c"
}

static void
panel_popup_menu_at_pointer_window (Panel* self,
                                    GtkMenu* menu,
                                    gint x,
                                    gint y,
                                    GdkWindow* window,
                                    GtkMenuPositionFunc func,
                                    gpointer func_target)
{
	gint win_x = 0;
	gint win_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkRectangle area = {0};
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
#line 347 "panel.vala"
	g_return_if_fail (self != NULL);
#line 347 "panel.vala"
	g_return_if_fail (menu != NULL);
#line 352 "panel.vala"
	win_x = 0;
#line 353 "panel.vala"
	win_y = 0;
#line 354 "panel.vala"
	gdk_window_get_origin (window, &_tmp0_, &_tmp1_);
#line 354 "panel.vala"
	win_x = _tmp0_;
#line 354 "panel.vala"
	win_y = _tmp1_;
#line 355 "panel.vala"
	_tmp2_.x = x - win_x;
#line 355 "panel.vala"
	_tmp2_.y = y - win_y;
#line 355 "panel.vala"
	_tmp2_.width = 1;
#line 355 "panel.vala"
	_tmp2_.height = 1;
#line 355 "panel.vala"
	area = _tmp2_;
#line 357 "panel.vala"
	_tmp3_ = area;
#line 357 "panel.vala"
	panel_popup_menu_at_area_window (self, menu, &_tmp3_, window, func, func_target);
#line 2270 "panel.c"
}

static void
__lambda85_ (Panel* self)
{
	Indicator* _tmp0_;
#line 370 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 370 "panel.vala"
	indicator_set_status (_tmp0_, INDICATOR_STATUS_ACTIVE);
#line 371 "panel.vala"
	g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 2283 "panel.c"
}

static void
___lambda85__indicator_registered_status_notifier_item (Indicator* _sender,
                                                        gpointer self)
{
#line 368 "panel.vala"
	__lambda85_ ((Panel*) self);
#line 2292 "panel.c"
}

static void
__lambda86_ (Panel* self)
{
#line 375 "panel.vala"
	self->priv->m_is_context_menu = !self->priv->m_is_context_menu;
#line 376 "panel.vala"
	if (self->priv->m_is_context_menu) {
#line 2302 "panel.c"
		Indicator* _tmp0_;
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 377 "panel.vala"
		_tmp0_ = self->priv->m_indicator;
#line 377 "panel.vala"
		_tmp1_ = panel_create_context_menu (self, FALSE);
#line 377 "panel.vala"
		_tmp2_ = _tmp1_;
#line 377 "panel.vala"
		indicator_set_menu (_tmp0_, _tmp2_);
#line 377 "panel.vala"
		_g_object_unref0 (_tmp2_);
#line 2316 "panel.c"
	} else {
		Indicator* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
#line 379 "panel.vala"
		_tmp3_ = self->priv->m_indicator;
#line 379 "panel.vala"
		_tmp4_ = panel_create_activate_menu (self, FALSE);
#line 379 "panel.vala"
		_tmp5_ = _tmp4_;
#line 379 "panel.vala"
		indicator_set_menu (_tmp3_, _tmp5_);
#line 379 "panel.vala"
		_g_object_unref0 (_tmp5_);
#line 2331 "panel.c"
	}
}

static void
___lambda86__indicator_secondary_activate (Indicator* _sender,
                                           gpointer self)
{
#line 373 "panel.vala"
	__lambda86_ ((Panel*) self);
#line 2341 "panel.c"
}

static void
panel_init_indicator (Panel* self)
{
	Indicator* _tmp0_;
	Indicator* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	Indicator* _tmp4_;
	gulong _tmp5_;
	Indicator* _tmp6_;
	gulong _tmp7_;
	Indicator* _tmp8_;
	GtkMenu* _tmp9_;
	GtkMenu* _tmp10_;
#line 360 "panel.vala"
	g_return_if_fail (self != NULL);
#line 361 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_INDICATOR;
#line 362 "panel.vala"
	_tmp0_ = indicator_new ("ibus-ui-gtk3", INDICATOR_CATEGORY_APPLICATION_STATUS);
#line 362 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 362 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 362 "panel.vala"
	self->priv->m_indicator = _tmp0_;
#line 364 "panel.vala"
	_tmp1_ = self->priv->m_indicator;
#line 364 "panel.vala"
	_tmp2_ = g_strdup_printf ("%s\n%s", _ ("IBus Panel"), _ ("You can toggle the activate menu and context one with " "clicking the mouse middle button on the panel icon."));
#line 364 "panel.vala"
	_tmp3_ = _tmp2_;
#line 364 "panel.vala"
	indicator_set_title (_tmp1_, _tmp3_);
#line 364 "panel.vala"
	_g_free0 (_tmp3_);
#line 368 "panel.vala"
	_tmp4_ = self->priv->m_indicator;
#line 368 "panel.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "registered-status-notifier-item", (GCallback) ___lambda85__indicator_registered_status_notifier_item, self, 0);
#line 368 "panel.vala"
	self->priv->m_registered_status_notifier_item_id = _tmp5_;
#line 373 "panel.vala"
	_tmp6_ = self->priv->m_indicator;
#line 373 "panel.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "secondary-activate", (GCallback) ___lambda86__indicator_secondary_activate, self, 0);
#line 373 "panel.vala"
	self->priv->m_popup_menu_id = _tmp7_;
#line 381 "panel.vala"
	_tmp8_ = self->priv->m_indicator;
#line 381 "panel.vala"
	_tmp9_ = panel_create_activate_menu (self, FALSE);
#line 381 "panel.vala"
	_tmp10_ = _tmp9_;
#line 381 "panel.vala"
	indicator_set_menu (_tmp8_, _tmp10_);
#line 381 "panel.vala"
	_g_object_unref0 (_tmp10_);
#line 2402 "panel.c"
}

static void
_panel_init_status_icon_menu_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 394 "panel.vala"
	panel_init_status_icon_menu ((Panel*) self);
#line 2412 "panel.c"
}

static void
panel_init_status_icon (Panel* self)
{
	GtkStatusIcon* _tmp0_;
	GtkStatusIcon* _tmp1_;
	GtkStatusIcon* _tmp2_;
	GtkStatusIcon* _tmp3_;
#line 385 "panel.vala"
	g_return_if_fail (self != NULL);
#line 386 "panel.vala"
	_tmp0_ = gtk_status_icon_new ();
#line 386 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 386 "panel.vala"
	self->priv->m_status_icon = _tmp0_;
#line 387 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 387 "panel.vala"
	gtk_status_icon_set_name (_tmp1_, "ibus-ui-gtk");
#line 388 "panel.vala"
	_tmp2_ = self->priv->m_status_icon;
#line 388 "panel.vala"
	gtk_status_icon_set_title (_tmp2_, _ ("IBus Panel"));
#line 391 "panel.vala"
	_tmp3_ = self->priv->m_status_icon;
#line 391 "panel.vala"
	if (gtk_status_icon_get_size (_tmp3_) > 0) {
#line 392 "panel.vala"
		panel_init_status_icon_menu (self);
#line 2444 "panel.c"
	} else {
		GtkStatusIcon* _tmp4_;
#line 394 "panel.vala"
		_tmp4_ = self->priv->m_status_icon;
#line 394 "panel.vala"
		g_signal_connect_object ((GObject*) _tmp4_, "notify::size", (GCallback) _panel_init_status_icon_menu_g_object_notify, self, 0);
#line 2451 "panel.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 397 "panel.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 397 "panel.vala"
	return _data6_;
#line 2462 "panel.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 397 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2472 "panel.c"
		Panel* self;
#line 397 "panel.vala"
		self = _data6_->self;
#line 397 "panel.vala"
		(_data6_->func_target_destroy_notify == NULL) ? NULL : (_data6_->func_target_destroy_notify (_data6_->func_target), NULL);
#line 397 "panel.vala"
		_data6_->func = NULL;
#line 397 "panel.vala"
		_data6_->func_target = NULL;
#line 397 "panel.vala"
		_data6_->func_target_destroy_notify = NULL;
#line 397 "panel.vala"
		_g_object_unref0 (_data6_->window);
#line 397 "panel.vala"
		_g_object_unref0 (self);
#line 397 "panel.vala"
		g_slice_free (Block6Data, _data6_);
#line 2490 "panel.c"
	}
}

static void
__lambda94_ (Block6Data* _data6_,
             guint b,
             guint t)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 435 "panel.vala"
	self = _data6_->self;
#line 436 "panel.vala"
	_tmp0_ = panel_create_context_menu (self, TRUE);
#line 436 "panel.vala"
	_tmp1_ = _tmp0_;
#line 436 "panel.vala"
	_tmp2_ = _data6_->area;
#line 436 "panel.vala"
	_tmp3_ = _data6_->window;
#line 436 "panel.vala"
	_tmp4_ = _data6_->func;
#line 436 "panel.vala"
	_tmp4__target = _data6_->func_target;
#line 436 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 436 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2524 "panel.c"
}

static void
___lambda94__gtk_status_icon_popup_menu (GtkStatusIcon* _sender,
                                         guint button,
                                         guint activate_time,
                                         gpointer self)
{
#line 435 "panel.vala"
	__lambda94_ (self, button, activate_time);
#line 2535 "panel.c"
}

static void
__lambda95_ (Block6Data* _data6_)
{
	Panel* self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GtkMenuPositionFunc _tmp4_;
	gpointer _tmp4__target;
#line 440 "panel.vala"
	self = _data6_->self;
#line 441 "panel.vala"
	_tmp0_ = panel_create_activate_menu (self, TRUE);
#line 441 "panel.vala"
	_tmp1_ = _tmp0_;
#line 441 "panel.vala"
	_tmp2_ = _data6_->area;
#line 441 "panel.vala"
	_tmp3_ = _data6_->window;
#line 441 "panel.vala"
	_tmp4_ = _data6_->func;
#line 441 "panel.vala"
	_tmp4__target = _data6_->func_target;
#line 441 "panel.vala"
	panel_popup_menu_at_area_window (self, _tmp1_, &_tmp2_, _tmp3_, _tmp4_, _tmp4__target);
#line 441 "panel.vala"
	_g_object_unref0 (_tmp1_);
#line 2566 "panel.c"
}

static void
___lambda95__gtk_status_icon_activate (GtkStatusIcon* _sender,
                                       gpointer self)
{
#line 440 "panel.vala"
	__lambda95_ (self);
#line 2575 "panel.c"
}

static void
panel_init_status_icon_menu (Panel* self)
{
	Block6Data* _data6_;
	GdkRectangle _tmp0_ = {0};
	GtkStatusIcon* _tmp1_;
	GdkX11Display* display = NULL;
	GdkX11Display* _tmp2_;
	GdkX11Display* _tmp3_;
	GdkX11Display* _tmp4_;
	GtkStatusIcon* _tmp5_;
	GdkX11Window* _tmp6_;
	GdkWindow* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GdkWindow* _tmp9_;
	GdkWindow* _tmp19_;
	GtkOrientation orient = 0;
	GtkStatusIcon* _tmp20_;
	GdkRectangle _tmp21_ = {0};
	GtkOrientation _tmp22_ = 0;
	gint win_x = 0;
	gint win_y = 0;
	GdkWindow* _tmp23_;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	GtkStatusIcon* _tmp26_;
	gulong _tmp27_;
	GtkStatusIcon* _tmp28_;
	gulong _tmp29_;
#line 397 "panel.vala"
	g_return_if_fail (self != NULL);
#line 397 "panel.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 397 "panel.vala"
	_data6_->_ref_count_ = 1;
#line 397 "panel.vala"
	_data6_->self = g_object_ref (self);
#line 398 "panel.vala"
	_tmp0_.x = 0;
#line 398 "panel.vala"
	_tmp0_.y = 0;
#line 398 "panel.vala"
	_tmp0_.width = 0;
#line 398 "panel.vala"
	_tmp0_.height = 0;
#line 398 "panel.vala"
	_data6_->area = _tmp0_;
#line 399 "panel.vala"
	_data6_->window = NULL;
#line 400 "panel.vala"
	_data6_->func = NULL;
#line 400 "panel.vala"
	_data6_->func_target = NULL;
#line 400 "panel.vala"
	_data6_->func_target_destroy_notify = NULL;
#line 401 "panel.vala"
	_tmp1_ = self->priv->m_status_icon;
#line 401 "panel.vala"
	gtk_status_icon_set_from_icon_name (_tmp1_, "ibus-keyboard");
#line 402 "panel.vala"
	_tmp2_ = binding_common_get_xdisplay ();
#line 402 "panel.vala"
	display = _tmp2_;
#line 403 "panel.vala"
	_tmp3_ = display;
#line 403 "panel.vala"
	if (_tmp3_ == NULL) {
#line 404 "panel.vala"
		g_warning ("panel.vala:404: No Gdk.X11.Display");
#line 405 "panel.vala"
		_g_object_unref0 (display);
#line 405 "panel.vala"
		block6_data_unref (_data6_);
#line 405 "panel.vala"
		_data6_ = NULL;
#line 405 "panel.vala"
		return;
#line 2655 "panel.c"
	}
#line 407 "panel.vala"
	_tmp4_ = display;
#line 407 "panel.vala"
	_tmp5_ = self->priv->m_status_icon;
#line 407 "panel.vala"
	_tmp6_ = gdk_x11_window_lookup_for_display (_tmp4_, (Window) gtk_status_icon_get_x11_window_id (_tmp5_));
#line 407 "panel.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_window_get_type ()) ? ((GdkWindow*) _tmp6_) : NULL);
#line 407 "panel.vala"
	_g_object_unref0 (_data6_->window);
#line 407 "panel.vala"
	_data6_->window = _tmp7_;
#line 410 "panel.vala"
	_tmp9_ = _data6_->window;
#line 410 "panel.vala"
	if (_tmp9_ == NULL) {
#line 410 "panel.vala"
		_tmp8_ = !binding_common_default_is_xdisplay ();
#line 2675 "panel.c"
	} else {
#line 410 "panel.vala"
		_tmp8_ = FALSE;
#line 2679 "panel.c"
	}
#line 410 "panel.vala"
	if (_tmp8_) {
#line 2683 "panel.c"
		Display* xdisplay = NULL;
		GdkX11Display* _tmp10_;
		Display* _tmp11_;
		Window root = 0;
		Display* _tmp12_;
		GdkX11Display* _tmp13_;
		GdkX11Window* _tmp14_;
		GdkWindow* _tmp15_;
		GdkWindow* _tmp16_;
#line 411 "panel.vala"
		_tmp10_ = display;
#line 411 "panel.vala"
		_tmp11_ = gdk_x11_display_get_xdisplay (_tmp10_);
#line 411 "panel.vala"
		xdisplay = _tmp11_;
#line 412 "panel.vala"
		_tmp12_ = xdisplay;
#line 412 "panel.vala"
		root = DefaultRootWindow (_tmp12_);
#line 413 "panel.vala"
		_tmp13_ = display;
#line 413 "panel.vala"
		_tmp14_ = gdk_x11_window_lookup_for_display (_tmp13_, root);
#line 413 "panel.vala"
		_tmp15_ = _g_object_ref0 ((GdkWindow*) _tmp14_);
#line 413 "panel.vala"
		_g_object_unref0 (_data6_->window);
#line 413 "panel.vala"
		_data6_->window = _tmp15_;
#line 416 "panel.vala"
		_tmp16_ = _data6_->window;
#line 416 "panel.vala"
		if (_tmp16_ == NULL) {
#line 2717 "panel.c"
			GdkX11Display* _tmp17_;
			GdkX11Window* _tmp18_;
#line 417 "panel.vala"
			_tmp17_ = display;
#line 417 "panel.vala"
			_tmp18_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp17_, root);
#line 417 "panel.vala"
			_g_object_unref0 (_data6_->window);
#line 417 "panel.vala"
			_data6_->window = (GdkWindow*) _tmp18_;
#line 2728 "panel.c"
		}
	}
#line 422 "panel.vala"
	_tmp19_ = _data6_->window;
#line 422 "panel.vala"
	if (_tmp19_ == NULL) {
#line 423 "panel.vala"
		g_warning ("panel.vala:423: StatusIcon does not have GdkWindow");
#line 424 "panel.vala"
		_g_object_unref0 (display);
#line 424 "panel.vala"
		block6_data_unref (_data6_);
#line 424 "panel.vala"
		_data6_ = NULL;
#line 424 "panel.vala"
		return;
#line 2745 "panel.c"
	}
#line 427 "panel.vala"
	_tmp20_ = self->priv->m_status_icon;
#line 427 "panel.vala"
	gtk_status_icon_get_geometry (_tmp20_, NULL, &_tmp21_, &_tmp22_);
#line 427 "panel.vala"
	_data6_->area = _tmp21_;
#line 427 "panel.vala"
	orient = _tmp22_;
#line 428 "panel.vala"
	win_x = 0;
#line 429 "panel.vala"
	win_y = 0;
#line 430 "panel.vala"
	_tmp23_ = _data6_->window;
#line 430 "panel.vala"
	gdk_window_get_origin (_tmp23_, &_tmp24_, &_tmp25_);
#line 430 "panel.vala"
	win_x = _tmp24_;
#line 430 "panel.vala"
	win_y = _tmp25_;
#line 433 "panel.vala"
	_data6_->area.x = _data6_->area.x - win_x;
#line 434 "panel.vala"
	_data6_->area.y = _data6_->area.y - win_y;
#line 435 "panel.vala"
	_tmp26_ = self->priv->m_status_icon;
#line 435 "panel.vala"
	_tmp27_ = g_signal_connect_data (_tmp26_, "popup-menu", (GCallback) ___lambda94__gtk_status_icon_popup_menu, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 435 "panel.vala"
	self->priv->m_popup_menu_id = _tmp27_;
#line 440 "panel.vala"
	_tmp28_ = self->priv->m_status_icon;
#line 440 "panel.vala"
	_tmp29_ = g_signal_connect_data (_tmp28_, "activate", (GCallback) ___lambda95__gtk_status_icon_activate, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 440 "panel.vala"
	self->priv->m_activate_id = _tmp29_;
#line 397 "panel.vala"
	_g_object_unref0 (display);
#line 397 "panel.vala"
	block6_data_unref (_data6_);
#line 397 "panel.vala"
	_data6_ = NULL;
#line 2789 "panel.c"
}

static void
_panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                               gpointer self)
{
#line 455 "panel.vala"
	panel_handle_engine_switch_normal ((Panel*) self, event);
#line 2798 "panel.c"
}

static void
_panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func (GdkEvent* event,
                                                                                gpointer self)
{
#line 455 "panel.vala"
	panel_handle_engine_switch_reverse ((Panel*) self, event);
#line 2807 "panel.c"
}

static void
_vala_array_add18 (IBusProcessKeyEventData* * array,
                   gint* length,
                   gint* size,
                   const IBusProcessKeyEventData* value)
{
#line 470 "panel.vala"
	if ((*length) == (*size)) {
#line 470 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 470 "panel.vala"
		*array = g_renew (IBusProcessKeyEventData, *array, *size);
#line 2822 "panel.c"
	}
#line 470 "panel.vala"
	(*array)[(*length)++] = *value;
#line 2826 "panel.c"
}

static void
_vala_array_add19 (IBusProcessKeyEventData* * array,
                   gint* length,
                   gint* size,
                   const IBusProcessKeyEventData* value)
{
#line 475 "panel.vala"
	if ((*length) == (*size)) {
#line 475 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 475 "panel.vala"
		*array = g_renew (IBusProcessKeyEventData, *array, *size);
#line 2841 "panel.c"
	}
#line 475 "panel.vala"
	(*array)[(*length)++] = *value;
#line 2845 "panel.c"
}

static void
panel_bind_switch_shortcut (Panel* self)
{
	gchar** accelerators = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint accelerators_length1;
	gint _accelerators_size_;
	KeybindingManager* keybinding_manager = NULL;
	KeybindingManager* _tmp3_;
	BindingCommonKeyEventFuncType ftype = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	IBusProcessKeyEventData* keys = NULL;
	IBusProcessKeyEventData* _tmp8_;
	gint keys_length1;
	gint _keys_size_;
	IBusProcessKeyEventData key = {0};
	GList* _tmp9_;
	IBusProcessKeyEventData* _tmp23_;
	gint _tmp23__length1;
	IBusProcessKeyEventData _tmp24_ = {0};
	IBusProcessKeyEventData _tmp25_;
	IBusBus* _tmp26_;
	IBusProcessKeyEventData* _tmp27_;
	gint _tmp27__length1;
#line 447 "panel.vala"
	g_return_if_fail (self != NULL);
#line 448 "panel.vala"
	_tmp0_ = self->priv->m_settings_hotkey;
#line 448 "panel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "triggers");
#line 448 "panel.vala"
	accelerators = _tmp2_;
#line 448 "panel.vala"
	accelerators_length1 = _vala_array_length (_tmp1_);
#line 448 "panel.vala"
	_accelerators_size_ = accelerators_length1;
#line 450 "panel.vala"
	_tmp3_ = keybinding_manager_get_instance ();
#line 450 "panel.vala"
	keybinding_manager = _tmp3_;
#line 452 "panel.vala"
	ftype = BINDING_COMMON_KEY_EVENT_FUNC_TYPE_IME_SWITCHER;
#line 454 "panel.vala"
	_tmp4_ = accelerators;
#line 454 "panel.vala"
	_tmp4__length1 = accelerators_length1;
#line 2897 "panel.c"
	{
		gchar** accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 454 "panel.vala"
		accelerator_collection = _tmp4_;
#line 454 "panel.vala"
		accelerator_collection_length1 = _tmp4__length1;
#line 454 "panel.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 2909 "panel.c"
			gchar* _tmp5_;
			gchar* accelerator = NULL;
#line 454 "panel.vala"
			_tmp5_ = g_strdup (accelerator_collection[accelerator_it]);
#line 454 "panel.vala"
			accelerator = _tmp5_;
#line 2916 "panel.c"
			{
				KeybindingManager* _tmp6_;
				const gchar* _tmp7_;
#line 455 "panel.vala"
				_tmp6_ = keybinding_manager;
#line 455 "panel.vala"
				_tmp7_ = accelerator;
#line 455 "panel.vala"
				binding_common_keybinding_manager_bind (_tmp6_, &self->priv->m_keybindings, _tmp7_, ftype, _panel_handle_engine_switch_normal_keybinding_manager_keybinding_handler_func, self, _panel_handle_engine_switch_reverse_keybinding_manager_keybinding_handler_func, self);
#line 454 "panel.vala"
				_g_free0 (accelerator);
#line 2928 "panel.c"
			}
		}
	}
#line 464 "panel.vala"
	if (binding_common_default_is_xdisplay ()) {
#line 465 "panel.vala"
		_g_object_unref0 (keybinding_manager);
#line 465 "panel.vala"
		accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 465 "panel.vala"
		return;
#line 2940 "panel.c"
	}
#line 466 "panel.vala"
	_tmp8_ = g_new0 (IBusProcessKeyEventData, 0);
#line 466 "panel.vala"
	keys = _tmp8_;
#line 466 "panel.vala"
	keys_length1 = 0;
#line 466 "panel.vala"
	_keys_size_ = keys_length1;
#line 468 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 2952 "panel.c"
	{
		GList* kb_collection = NULL;
		GList* kb_it = NULL;
#line 468 "panel.vala"
		kb_collection = _tmp9_;
#line 468 "panel.vala"
		for (kb_it = kb_collection; kb_it != NULL; kb_it = kb_it->next) {
#line 2960 "panel.c"
			BindingCommonKeybinding* _tmp10_;
			BindingCommonKeybinding* kb = NULL;
#line 468 "panel.vala"
			_tmp10_ = _g_object_ref0 ((BindingCommonKeybinding*) kb_it->data);
#line 468 "panel.vala"
			kb = _tmp10_;
#line 2967 "panel.c"
			{
				gint _tmp11_ = 0;
				BindingCommonKeybinding* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				BindingCommonKeybinding* _tmp15_;
				guint _tmp16_;
				guint _tmp17_;
				BindingCommonKeybinding* _tmp18_;
				GdkModifierType _tmp19_;
				GdkModifierType _tmp20_;
				IBusProcessKeyEventData _tmp21_ = {0};
				IBusProcessKeyEventData _tmp22_;
#line 469 "panel.vala"
				_tmp12_ = kb;
#line 469 "panel.vala"
				_tmp13_ = binding_common_keybinding_get_reverse (_tmp12_);
#line 469 "panel.vala"
				_tmp14_ = _tmp13_;
#line 469 "panel.vala"
				if (_tmp14_) {
#line 469 "panel.vala"
					_tmp11_ = 1;
#line 2991 "panel.c"
				} else {
#line 469 "panel.vala"
					_tmp11_ = 0;
#line 2995 "panel.c"
				}
#line 469 "panel.vala"
				_tmp15_ = kb;
#line 469 "panel.vala"
				_tmp16_ = binding_common_keybinding_get_keysym (_tmp15_);
#line 469 "panel.vala"
				_tmp17_ = _tmp16_;
#line 469 "panel.vala"
				_tmp18_ = kb;
#line 469 "panel.vala"
				_tmp19_ = binding_common_keybinding_get_modifiers (_tmp18_);
#line 469 "panel.vala"
				_tmp20_ = _tmp19_;
#line 469 "panel.vala"
				_tmp21_.keyval = _tmp17_;
#line 469 "panel.vala"
				_tmp21_.keycode = (guint) _tmp11_;
#line 469 "panel.vala"
				_tmp21_.state = (guint) _tmp20_;
#line 469 "panel.vala"
				key = _tmp21_;
#line 470 "panel.vala"
				_tmp22_ = key;
#line 470 "panel.vala"
				_vala_array_add18 (&keys, &keys_length1, &_keys_size_, &_tmp22_);
#line 468 "panel.vala"
				_g_object_unref0 (kb);
#line 3023 "panel.c"
			}
		}
	}
#line 472 "panel.vala"
	_tmp23_ = keys;
#line 472 "panel.vala"
	_tmp23__length1 = keys_length1;
#line 472 "panel.vala"
	if (_tmp23__length1 == 0) {
#line 473 "panel.vala"
		keys = (g_free (keys), NULL);
#line 473 "panel.vala"
		_g_object_unref0 (keybinding_manager);
#line 473 "panel.vala"
		accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 473 "panel.vala"
		return;
#line 3041 "panel.c"
	}
#line 474 "panel.vala"
	_tmp24_.keyval = (guint) 0;
#line 474 "panel.vala"
	key = _tmp24_;
#line 475 "panel.vala"
	_tmp25_ = key;
#line 475 "panel.vala"
	_vala_array_add19 (&keys, &keys_length1, &_keys_size_, &_tmp25_);
#line 476 "panel.vala"
	_tmp26_ = self->priv->m_bus;
#line 476 "panel.vala"
	_tmp27_ = keys;
#line 476 "panel.vala"
	_tmp27__length1 = keys_length1;
#line 476 "panel.vala"
	ibus_bus_set_global_shortcut_keys_async (_tmp26_, IBUS_BUS_GLOBAL_BINDING_TYPE_IME_SWITCHER, _tmp27_, -1, NULL, NULL, NULL);
#line 447 "panel.vala"
	keys = (g_free (keys), NULL);
#line 447 "panel.vala"
	_g_object_unref0 (keybinding_manager);
#line 447 "panel.vala"
	accelerators = (_vala_array_free (accelerators, accelerators_length1, (GDestroyNotify) g_free), NULL);
#line 3065 "panel.c"
}

/**
     * panel_get_engines_from_xkb:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus xkb engines
     *
     * Made ibus engines from the current XKB keymaps.
     * This returns only XKB engines whose name start with "xkb:".
     */
static GList*
panel_get_engines_from_xkb (Panel* self,
                            GList* engines)
{
	gchar* layouts = NULL;
	gchar* variants = NULL;
	gchar* option = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GList* xkb_engines = NULL;
	IBusEngineDesc* us_engine = NULL;
	IBusEngineDesc* _tmp3_;
	gchar** layout_array = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint layout_array_length1;
	gint _layout_array_size_;
	gchar** variant_array = NULL;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint variant_array_length1;
	gint _variant_array_size_;
	GList* _tmp45_;
	GList* result;
#line 510 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 515 "panel.vala"
	xkb_layout_get_layout (&_tmp0_, &_tmp1_, &_tmp2_);
#line 515 "panel.vala"
	_g_free0 (layouts);
#line 515 "panel.vala"
	layouts = _tmp0_;
#line 515 "panel.vala"
	_g_free0 (variants);
#line 515 "panel.vala"
	variants = _tmp1_;
#line 515 "panel.vala"
	_g_free0 (option);
#line 515 "panel.vala"
	option = _tmp2_;
#line 517 "panel.vala"
	xkb_engines = NULL;
#line 519 "panel.vala"
	_tmp3_ = ibus_engine_desc_new ("xkb:us::eng", "", "", "", "", "", "", "");
#line 519 "panel.vala"
	g_object_ref_sink (_tmp3_);
#line 519 "panel.vala"
	us_engine = _tmp3_;
#line 522 "panel.vala"
	_tmp4_ = layouts;
#line 522 "panel.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ",", 0);
#line 522 "panel.vala"
	layout_array = _tmp6_;
#line 522 "panel.vala"
	layout_array_length1 = _vala_array_length (_tmp5_);
#line 522 "panel.vala"
	_layout_array_size_ = layout_array_length1;
#line 523 "panel.vala"
	_tmp7_ = variants;
#line 523 "panel.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ",", 0);
#line 523 "panel.vala"
	variant_array = _tmp9_;
#line 523 "panel.vala"
	variant_array_length1 = _vala_array_length (_tmp8_);
#line 523 "panel.vala"
	_variant_array_size_ = variant_array_length1;
#line 3148 "panel.c"
	{
		gint i = 0;
#line 525 "panel.vala"
		i = 0;
#line 3153 "panel.c"
		{
			gboolean _tmp10_ = FALSE;
#line 525 "panel.vala"
			_tmp10_ = TRUE;
#line 525 "panel.vala"
			while (TRUE) {
#line 3160 "panel.c"
				gchar** _tmp12_;
				gint _tmp12__length1;
				gchar* layout = NULL;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* variant = NULL;
				IBusEngineDesc* current_engine = NULL;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp20_;
				IBusEngineDesc* _tmp35_;
#line 525 "panel.vala"
				if (!_tmp10_) {
#line 3176 "panel.c"
					gint _tmp11_;
#line 525 "panel.vala"
					_tmp11_ = i;
#line 525 "panel.vala"
					i = _tmp11_ + 1;
#line 3182 "panel.c"
				}
#line 525 "panel.vala"
				_tmp10_ = FALSE;
#line 525 "panel.vala"
				_tmp12_ = layout_array;
#line 525 "panel.vala"
				_tmp12__length1 = layout_array_length1;
#line 525 "panel.vala"
				if (!(i < _tmp12__length1)) {
#line 525 "panel.vala"
					break;
#line 3194 "panel.c"
				}
#line 526 "panel.vala"
				_tmp13_ = layout_array;
#line 526 "panel.vala"
				_tmp13__length1 = layout_array_length1;
#line 526 "panel.vala"
				_tmp14_ = _tmp13_[i];
#line 526 "panel.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 526 "panel.vala"
				layout = _tmp15_;
#line 527 "panel.vala"
				variant = NULL;
#line 528 "panel.vala"
				current_engine = NULL;
#line 530 "panel.vala"
				_tmp16_ = variant_array;
#line 530 "panel.vala"
				_tmp16__length1 = variant_array_length1;
#line 530 "panel.vala"
				if (i < _tmp16__length1) {
#line 3216 "panel.c"
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 531 "panel.vala"
					_tmp17_ = variant_array;
#line 531 "panel.vala"
					_tmp17__length1 = variant_array_length1;
#line 531 "panel.vala"
					_tmp18_ = _tmp17_[i];
#line 531 "panel.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 531 "panel.vala"
					_g_free0 (variant);
#line 531 "panel.vala"
					variant = _tmp19_;
#line 3233 "panel.c"
				}
#line 537 "panel.vala"
				_tmp20_ = variant;
#line 537 "panel.vala"
				if (_tmp20_ == NULL) {
#line 3239 "panel.c"
					gchar* _tmp21_;
#line 538 "panel.vala"
					_tmp21_ = g_strdup ("");
#line 538 "panel.vala"
					_g_free0 (variant);
#line 538 "panel.vala"
					variant = _tmp21_;
#line 3247 "panel.c"
				}
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
#line 540 "panel.vala"
					engine_collection = engines;
#line 540 "panel.vala"
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3256 "panel.c"
						IBusEngineDesc* engine = NULL;
#line 540 "panel.vala"
						engine = (IBusEngineDesc*) engine_it->data;
#line 3260 "panel.c"
						{
							gchar* name = NULL;
							IBusEngineDesc* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
							const gchar* _tmp25_;
							gboolean _tmp26_ = FALSE;
							IBusEngineDesc* _tmp27_;
							const gchar* _tmp28_;
							const gchar* _tmp29_;
#line 542 "panel.vala"
							_tmp22_ = engine;
#line 542 "panel.vala"
							_tmp23_ = ibus_engine_desc_get_name (_tmp22_);
#line 542 "panel.vala"
							_tmp24_ = g_strdup (_tmp23_);
#line 542 "panel.vala"
							name = _tmp24_;
#line 543 "panel.vala"
							_tmp25_ = name;
#line 543 "panel.vala"
							if (!g_str_has_prefix (_tmp25_, "xkb:")) {
#line 544 "panel.vala"
								_g_free0 (name);
#line 544 "panel.vala"
								continue;
#line 3287 "panel.c"
							}
#line 546 "panel.vala"
							_tmp27_ = engine;
#line 546 "panel.vala"
							_tmp28_ = ibus_engine_desc_get_layout (_tmp27_);
#line 546 "panel.vala"
							_tmp29_ = layout;
#line 546 "panel.vala"
							if (g_strcmp0 (_tmp28_, _tmp29_) == 0) {
#line 3297 "panel.c"
								IBusEngineDesc* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
#line 547 "panel.vala"
								_tmp30_ = engine;
#line 547 "panel.vala"
								_tmp31_ = ibus_engine_desc_get_layout_variant (_tmp30_);
#line 547 "panel.vala"
								_tmp32_ = variant;
#line 547 "panel.vala"
								_tmp26_ = g_strcmp0 (_tmp31_, _tmp32_) == 0;
#line 3309 "panel.c"
							} else {
#line 546 "panel.vala"
								_tmp26_ = FALSE;
#line 3313 "panel.c"
							}
#line 546 "panel.vala"
							if (_tmp26_) {
#line 3317 "panel.c"
								IBusEngineDesc* _tmp33_;
								IBusEngineDesc* _tmp34_;
#line 548 "panel.vala"
								_tmp33_ = engine;
#line 548 "panel.vala"
								_tmp34_ = _g_object_ref0 (_tmp33_);
#line 548 "panel.vala"
								_g_object_unref0 (current_engine);
#line 548 "panel.vala"
								current_engine = _tmp34_;
#line 549 "panel.vala"
								_g_free0 (name);
#line 549 "panel.vala"
								break;
#line 3332 "panel.c"
							}
#line 540 "panel.vala"
							_g_free0 (name);
#line 3336 "panel.c"
						}
					}
				}
#line 553 "panel.vala"
				_tmp35_ = current_engine;
#line 553 "panel.vala"
				if (_tmp35_ != NULL) {
#line 3344 "panel.c"
					IBusEngineDesc* _tmp36_;
					IBusEngineDesc* _tmp37_;
#line 554 "panel.vala"
					_tmp36_ = current_engine;
#line 554 "panel.vala"
					_tmp37_ = _g_object_ref0 (_tmp36_);
#line 554 "panel.vala"
					xkb_engines = g_list_append (xkb_engines, _tmp37_);
#line 3353 "panel.c"
				} else {
					GList* _tmp38_;
					IBusEngineDesc* _tmp39_;
					GList* _tmp40_;
#line 555 "panel.vala"
					_tmp38_ = xkb_engines;
#line 555 "panel.vala"
					_tmp39_ = us_engine;
#line 555 "panel.vala"
					_tmp40_ = g_list_find (_tmp38_, _tmp39_);
#line 555 "panel.vala"
					if (_tmp40_ == NULL) {
#line 3366 "panel.c"
						const gchar* _tmp41_;
						const gchar* _tmp42_;
						IBusEngineDesc* _tmp43_;
						IBusEngineDesc* _tmp44_;
#line 556 "panel.vala"
						_tmp41_ = layout;
#line 556 "panel.vala"
						_tmp42_ = variant;
#line 556 "panel.vala"
						g_warning ("panel.vala:556: Fallback %s(%s) to us layout.", _tmp41_, _tmp42_);
#line 557 "panel.vala"
						_tmp43_ = us_engine;
#line 557 "panel.vala"
						_tmp44_ = _g_object_ref0 (_tmp43_);
#line 557 "panel.vala"
						xkb_engines = g_list_append (xkb_engines, _tmp44_);
#line 3383 "panel.c"
					}
				}
#line 525 "panel.vala"
				_g_object_unref0 (current_engine);
#line 525 "panel.vala"
				_g_free0 (variant);
#line 525 "panel.vala"
				_g_free0 (layout);
#line 3392 "panel.c"
			}
		}
	}
#line 561 "panel.vala"
	_tmp45_ = xkb_engines;
#line 561 "panel.vala"
	if (g_list_length (_tmp45_) == ((guint) 0)) {
#line 562 "panel.vala"
		g_warning ("panel.vala:562: Not found IBus XKB engines from the session.");
#line 3402 "panel.c"
	}
#line 564 "panel.vala"
	result = xkb_engines;
#line 564 "panel.vala"
	variant_array = (_vala_array_free (variant_array, variant_array_length1, (GDestroyNotify) g_free), NULL);
#line 564 "panel.vala"
	layout_array = (_vala_array_free (layout_array, layout_array_length1, (GDestroyNotify) g_free), NULL);
#line 564 "panel.vala"
	_g_object_unref0 (us_engine);
#line 564 "panel.vala"
	_g_free0 (option);
#line 564 "panel.vala"
	_g_free0 (variants);
#line 564 "panel.vala"
	_g_free0 (layouts);
#line 564 "panel.vala"
	return result;
#line 3420 "panel.c"
}

/**
     * panel_get_engines_from_locale:
     * @self: #Panel class
     * @engines: all engines from ibus_bus_list_engines()
     * @returns: ibus im engines
     *
     * Made ibus engines from the current locale and IBus.EngineDesc.lang .
     * This returns non-XKB engines whose name does not start "xkb:".
     */
static gint
__lambda104_ (IBusEngineDesc* a,
              IBusEngineDesc* b)
{
	gint result;
#line 616 "panel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 616 "panel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 617 "panel.vala"
	result = ((gint) ibus_engine_desc_get_rank (b)) - ((gint) ibus_engine_desc_get_rank (a));
#line 617 "panel.vala"
	return result;
#line 3445 "panel.c"
}

static gint
___lambda104__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = __lambda104_ ((IBusEngineDesc*) a, (IBusEngineDesc*) b);
#line 616 "panel.vala"
	return result;
#line 3456 "panel.c"
}

static GList*
panel_get_engines_from_locale (Panel* self,
                               GList* engines)
{
	gchar* locale = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* lang = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GList* im_engines = NULL;
	GList* _tmp22_;
	GList* _tmp40_;
	GList* result;
#line 576 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 578 "panel.vala"
	_tmp0_ = setlocale (LC_CTYPE, NULL);
#line 578 "panel.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 578 "panel.vala"
	locale = _tmp1_;
#line 580 "panel.vala"
	_tmp2_ = locale;
#line 580 "panel.vala"
	if (_tmp2_ == NULL) {
#line 3492 "panel.c"
		gchar* _tmp3_;
#line 581 "panel.vala"
		_tmp3_ = g_strdup ("C");
#line 581 "panel.vala"
		_g_free0 (locale);
#line 581 "panel.vala"
		locale = _tmp3_;
#line 3500 "panel.c"
	}
#line 583 "panel.vala"
	_tmp4_ = locale;
#line 583 "panel.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ".", 0);
#line 583 "panel.vala"
	_tmp7_ = _tmp6_;
#line 583 "panel.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 583 "panel.vala"
	_tmp8_ = _tmp7_[0];
#line 583 "panel.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 583 "panel.vala"
	_tmp10_ = _tmp9_;
#line 583 "panel.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 583 "panel.vala"
	lang = _tmp10_;
#line 584 "panel.vala"
	im_engines = NULL;
#line 3522 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 587 "panel.vala"
		engine_collection = engines;
#line 587 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3530 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 587 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3534 "panel.c"
			{
				gchar* name = NULL;
				IBusEngineDesc* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				gboolean _tmp15_ = FALSE;
				IBusEngineDesc* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 588 "panel.vala"
				_tmp11_ = engine;
#line 588 "panel.vala"
				_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
#line 588 "panel.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 588 "panel.vala"
				name = _tmp13_;
#line 590 "panel.vala"
				_tmp14_ = name;
#line 590 "panel.vala"
				if (g_str_has_prefix (_tmp14_, "xkb:")) {
#line 591 "panel.vala"
					_g_free0 (name);
#line 591 "panel.vala"
					continue;
#line 3561 "panel.c"
				}
#line 593 "panel.vala"
				_tmp16_ = engine;
#line 593 "panel.vala"
				_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
#line 593 "panel.vala"
				_tmp18_ = lang;
#line 593 "panel.vala"
				if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 3571 "panel.c"
					IBusEngineDesc* _tmp19_;
#line 594 "panel.vala"
					_tmp19_ = engine;
#line 594 "panel.vala"
					_tmp15_ = ibus_engine_desc_get_rank (_tmp19_) > ((guint) 0);
#line 3577 "panel.c"
				} else {
#line 593 "panel.vala"
					_tmp15_ = FALSE;
#line 3581 "panel.c"
				}
#line 593 "panel.vala"
				if (_tmp15_) {
#line 3585 "panel.c"
					IBusEngineDesc* _tmp20_;
					IBusEngineDesc* _tmp21_;
#line 595 "panel.vala"
					_tmp20_ = engine;
#line 595 "panel.vala"
					_tmp21_ = _g_object_ref0 (_tmp20_);
#line 595 "panel.vala"
					im_engines = g_list_append (im_engines, _tmp21_);
#line 3594 "panel.c"
				}
#line 587 "panel.vala"
				_g_free0 (name);
#line 3598 "panel.c"
			}
		}
	}
#line 598 "panel.vala"
	_tmp22_ = im_engines;
#line 598 "panel.vala"
	if (g_list_length (_tmp22_) == ((guint) 0)) {
#line 3606 "panel.c"
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 599 "panel.vala"
		_tmp23_ = lang;
#line 599 "panel.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "_", 0);
#line 599 "panel.vala"
		_tmp26_ = _tmp25_;
#line 599 "panel.vala"
		_tmp26__length1 = _vala_array_length (_tmp24_);
#line 599 "panel.vala"
		_tmp27_ = _tmp26_[0];
#line 599 "panel.vala"
		_tmp28_ = g_strdup (_tmp27_);
#line 599 "panel.vala"
		_g_free0 (lang);
#line 599 "panel.vala"
		lang = _tmp28_;
#line 599 "panel.vala"
		_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 3632 "panel.c"
		{
			GList* engine_collection = NULL;
			GList* engine_it = NULL;
#line 601 "panel.vala"
			engine_collection = engines;
#line 601 "panel.vala"
			for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3640 "panel.c"
				IBusEngineDesc* engine = NULL;
#line 601 "panel.vala"
				engine = (IBusEngineDesc*) engine_it->data;
#line 3644 "panel.c"
				{
					gchar* name = NULL;
					IBusEngineDesc* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean _tmp33_ = FALSE;
					IBusEngineDesc* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
#line 602 "panel.vala"
					_tmp29_ = engine;
#line 602 "panel.vala"
					_tmp30_ = ibus_engine_desc_get_name (_tmp29_);
#line 602 "panel.vala"
					_tmp31_ = g_strdup (_tmp30_);
#line 602 "panel.vala"
					name = _tmp31_;
#line 604 "panel.vala"
					_tmp32_ = name;
#line 604 "panel.vala"
					if (g_str_has_prefix (_tmp32_, "xkb:")) {
#line 605 "panel.vala"
						_g_free0 (name);
#line 605 "panel.vala"
						continue;
#line 3671 "panel.c"
					}
#line 607 "panel.vala"
					_tmp34_ = engine;
#line 607 "panel.vala"
					_tmp35_ = ibus_engine_desc_get_language (_tmp34_);
#line 607 "panel.vala"
					_tmp36_ = lang;
#line 607 "panel.vala"
					if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 3681 "panel.c"
						IBusEngineDesc* _tmp37_;
#line 608 "panel.vala"
						_tmp37_ = engine;
#line 608 "panel.vala"
						_tmp33_ = ibus_engine_desc_get_rank (_tmp37_) > ((guint) 0);
#line 3687 "panel.c"
					} else {
#line 607 "panel.vala"
						_tmp33_ = FALSE;
#line 3691 "panel.c"
					}
#line 607 "panel.vala"
					if (_tmp33_) {
#line 3695 "panel.c"
						IBusEngineDesc* _tmp38_;
						IBusEngineDesc* _tmp39_;
#line 609 "panel.vala"
						_tmp38_ = engine;
#line 609 "panel.vala"
						_tmp39_ = _g_object_ref0 (_tmp38_);
#line 609 "panel.vala"
						im_engines = g_list_append (im_engines, _tmp39_);
#line 3704 "panel.c"
					}
#line 601 "panel.vala"
					_g_free0 (name);
#line 3708 "panel.c"
				}
			}
		}
	}
#line 613 "panel.vala"
	_tmp40_ = im_engines;
#line 613 "panel.vala"
	if (g_list_length (_tmp40_) == ((guint) 0)) {
#line 614 "panel.vala"
		result = im_engines;
#line 614 "panel.vala"
		_g_free0 (lang);
#line 614 "panel.vala"
		_g_free0 (locale);
#line 614 "panel.vala"
		return result;
#line 3725 "panel.c"
	}
#line 616 "panel.vala"
	im_engines = g_list_sort (im_engines, ___lambda104__gcompare_func);
#line 620 "panel.vala"
	result = im_engines;
#line 620 "panel.vala"
	_g_free0 (lang);
#line 620 "panel.vala"
	_g_free0 (locale);
#line 620 "panel.vala"
	return result;
#line 3737 "panel.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 640 "panel.vala"
	if ((*length) == (*size)) {
#line 640 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 640 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3752 "panel.c"
	}
#line 640 "panel.vala"
	(*array)[(*length)++] = value;
#line 640 "panel.vala"
	(*array)[*length] = NULL;
#line 3758 "panel.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 642 "panel.vala"
	if ((*length) == (*size)) {
#line 642 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 642 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3773 "panel.c"
	}
#line 642 "panel.vala"
	(*array)[(*length)++] = value;
#line 642 "panel.vala"
	(*array)[*length] = NULL;
#line 3779 "panel.c"
}

static void
panel_init_engines_order (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_;
	GList* engines = NULL;
	IBusBus* _tmp10_;
	GList* _tmp11_;
	GList* xkb_engines = NULL;
	GList* _tmp12_;
	GList* _tmp13_;
	GList* im_engines = NULL;
	GList* _tmp14_;
	GList* _tmp15_;
	gchar** names = NULL;
	gchar** _tmp16_;
	gint names_length1;
	gint _names_size_;
	GList* _tmp17_;
	GList* _tmp21_;
	GSettings* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
#line 623 "panel.vala"
	g_return_if_fail (self != NULL);
#line 624 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 624 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 624 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "xkb-latin-layouts");
#line 624 "panel.vala"
	_tmp4_ = _tmp3_;
#line 624 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 624 "panel.vala"
	xkb_layout_set_latin_layouts (_tmp0_, _tmp4_, (gint) _vala_array_length (_tmp2_));
#line 624 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 627 "panel.vala"
	if (self->priv->inited_engines_order) {
#line 628 "panel.vala"
		return;
#line 3835 "panel.c"
	}
#line 630 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 630 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "preload-engines");
#line 630 "panel.vala"
	_tmp8_ = _tmp7_;
#line 630 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 630 "panel.vala"
	_tmp9_ = _vala_array_length (_tmp6_) > 0;
#line 630 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 630 "panel.vala"
	if (_tmp9_) {
#line 631 "panel.vala"
		return;
#line 3853 "panel.c"
	}
#line 633 "panel.vala"
	_tmp10_ = self->priv->m_bus;
#line 633 "panel.vala"
	_tmp11_ = ibus_bus_list_engines (_tmp10_);
#line 633 "panel.vala"
	engines = _tmp11_;
#line 634 "panel.vala"
	_tmp12_ = engines;
#line 634 "panel.vala"
	_tmp13_ = panel_get_engines_from_xkb (self, _tmp12_);
#line 634 "panel.vala"
	xkb_engines = _tmp13_;
#line 635 "panel.vala"
	_tmp14_ = engines;
#line 635 "panel.vala"
	_tmp15_ = panel_get_engines_from_locale (self, _tmp14_);
#line 635 "panel.vala"
	im_engines = _tmp15_;
#line 638 "panel.vala"
	_tmp16_ = g_new0 (gchar*, 0 + 1);
#line 638 "panel.vala"
	names = _tmp16_;
#line 638 "panel.vala"
	names_length1 = 0;
#line 638 "panel.vala"
	_names_size_ = names_length1;
#line 639 "panel.vala"
	_tmp17_ = xkb_engines;
#line 3883 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 639 "panel.vala"
		engine_collection = _tmp17_;
#line 639 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3891 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 639 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3895 "panel.c"
			{
				IBusEngineDesc* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
#line 640 "panel.vala"
				_tmp18_ = engine;
#line 640 "panel.vala"
				_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 640 "panel.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 640 "panel.vala"
				_vala_array_add20 (&names, &names_length1, &_names_size_, _tmp20_);
#line 3908 "panel.c"
			}
		}
	}
#line 641 "panel.vala"
	_tmp21_ = im_engines;
#line 3914 "panel.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 641 "panel.vala"
		engine_collection = _tmp21_;
#line 641 "panel.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 3922 "panel.c"
			IBusEngineDesc* engine = NULL;
#line 641 "panel.vala"
			engine = (IBusEngineDesc*) engine_it->data;
#line 3926 "panel.c"
			{
				IBusEngineDesc* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 642 "panel.vala"
				_tmp22_ = engine;
#line 642 "panel.vala"
				_tmp23_ = ibus_engine_desc_get_name (_tmp22_);
#line 642 "panel.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 642 "panel.vala"
				_vala_array_add21 (&names, &names_length1, &_names_size_, _tmp24_);
#line 3939 "panel.c"
			}
		}
	}
#line 644 "panel.vala"
	_tmp25_ = self->priv->m_settings_general;
#line 644 "panel.vala"
	_tmp26_ = names;
#line 644 "panel.vala"
	_tmp26__length1 = names_length1;
#line 644 "panel.vala"
	g_settings_set_strv (_tmp25_, "preload-engines", _tmp26_);
#line 623 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 623 "panel.vala"
	(im_engines == NULL) ? NULL : (im_engines = (_g_list_free__g_object_unref0_ (im_engines), NULL));
#line 623 "panel.vala"
	(xkb_engines == NULL) ? NULL : (xkb_engines = (_g_list_free__g_object_unref0_ (xkb_engines), NULL));
#line 623 "panel.vala"
	(engines == NULL) ? NULL : (engines = (_g_list_free__g_object_unref0_ (engines), NULL));
#line 3959 "panel.c"
}

static void
panel_set_switcher_delay_time (Panel* self)
{
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Switcher* _tmp2_;
#line 648 "panel.vala"
	g_return_if_fail (self != NULL);
#line 649 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 649 "panel.vala"
	self->priv->m_switcher_delay_time = g_settings_get_int (_tmp0_, "switcher-delay-time");
#line 652 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 652 "panel.vala"
	if (_tmp2_ != NULL) {
#line 652 "panel.vala"
		_tmp1_ = self->priv->m_switcher_delay_time >= 0;
#line 3980 "panel.c"
	} else {
#line 652 "panel.vala"
		_tmp1_ = FALSE;
#line 3984 "panel.c"
	}
#line 652 "panel.vala"
	if (_tmp1_) {
#line 3988 "panel.c"
		Switcher* _tmp3_;
#line 653 "panel.vala"
		_tmp3_ = self->priv->m_switcher;
#line 653 "panel.vala"
		switcher_set_popup_delay_time (_tmp3_, (guint) self->priv->m_switcher_delay_time);
#line 3994 "panel.c"
	}
}

static void
panel_set_use_system_keyboard_layout (Panel* self)
{
	GSettings* _tmp0_;
#line 657 "panel.vala"
	g_return_if_fail (self != NULL);
#line 658 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 658 "panel.vala"
	self->priv->m_use_system_keyboard_layout = g_settings_get_boolean (_tmp0_, "use-system-keyboard-layout");
#line 4008 "panel.c"
}

static void
panel_set_embed_preedit_text (Panel* self)
{
	GVariant* variant = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	IBusBus* _tmp3_;
	GVariant* _tmp4_;
#line 662 "panel.vala"
	g_return_if_fail (self != NULL);
#line 663 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 663 "panel.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "embed-preedit-text");
#line 663 "panel.vala"
	variant = _tmp1_;
#line 666 "panel.vala"
	_tmp2_ = variant;
#line 666 "panel.vala"
	if (_tmp2_ == NULL) {
#line 667 "panel.vala"
		_g_variant_unref0 (variant);
#line 667 "panel.vala"
		return;
#line 4036 "panel.c"
	}
#line 670 "panel.vala"
	_tmp3_ = self->priv->m_bus;
#line 670 "panel.vala"
	_tmp4_ = variant;
#line 670 "panel.vala"
	ibus_bus_set_ibus_property (_tmp3_, "EmbedPreeditText", _tmp4_);
#line 662 "panel.vala"
	_g_variant_unref0 (variant);
#line 4046 "panel.c"
}

static void
panel_set_use_global_engine (Panel* self)
{
	GSettings* _tmp0_;
#line 673 "panel.vala"
	g_return_if_fail (self != NULL);
#line 674 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 674 "panel.vala"
	self->priv->m_use_global_engine = g_settings_get_boolean (_tmp0_, "use-global-engine");
#line 4059 "panel.c"
}

static void
panel_set_use_xmodmap (Panel* self)
{
	XKBLayout* _tmp0_;
	GSettings* _tmp1_;
#line 678 "panel.vala"
	g_return_if_fail (self != NULL);
#line 679 "panel.vala"
	_tmp0_ = self->priv->m_xkblayout;
#line 679 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 679 "panel.vala"
	xkb_layout_set_use_xmodmap (_tmp0_, g_settings_get_boolean (_tmp1_, "use-xmodmap"));
#line 4075 "panel.c"
}

static void
panel_set_show_icon_on_systray (Panel* self)
{
#line 683 "panel.vala"
	g_return_if_fail (self != NULL);
#line 684 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4085 "panel.c"
		GtkStatusIcon* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GSettings* _tmp2_;
#line 685 "panel.vala"
		_tmp0_ = self->priv->m_status_icon;
#line 685 "panel.vala"
		if (_tmp0_ == NULL) {
#line 686 "panel.vala"
			return;
#line 4095 "panel.c"
		}
#line 688 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 688 "panel.vala"
		_tmp2_ = self->priv->m_settings_panel;
#line 688 "panel.vala"
		gtk_status_icon_set_visible (_tmp1_, g_settings_get_boolean (_tmp2_, "show-icon-on-systray"));
#line 4103 "panel.c"
	} else {
#line 692 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4107 "panel.c"
			Indicator* _tmp3_;
			GSettings* _tmp4_;
#line 693 "panel.vala"
			_tmp3_ = self->priv->m_indicator;
#line 693 "panel.vala"
			if (_tmp3_ == NULL) {
#line 694 "panel.vala"
				return;
#line 4116 "panel.c"
			}
#line 696 "panel.vala"
			_tmp4_ = self->priv->m_settings_panel;
#line 696 "panel.vala"
			if (g_settings_get_boolean (_tmp4_, "show-icon-on-systray")) {
#line 4122 "panel.c"
				Indicator* _tmp5_;
#line 697 "panel.vala"
				_tmp5_ = self->priv->m_indicator;
#line 697 "panel.vala"
				indicator_set_status (_tmp5_, INDICATOR_STATUS_ACTIVE);
#line 4128 "panel.c"
			} else {
				Indicator* _tmp6_;
#line 699 "panel.vala"
				_tmp6_ = self->priv->m_indicator;
#line 699 "panel.vala"
				indicator_set_status (_tmp6_, INDICATOR_STATUS_PASSIVE);
#line 4135 "panel.c"
			}
		}
	}
}

static void
panel_set_lookup_table_orientation (Panel* self)
{
	CandidatePanel* _tmp0_;
	CandidatePanel* _tmp1_;
	GSettings* _tmp2_;
#line 704 "panel.vala"
	g_return_if_fail (self != NULL);
#line 705 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 705 "panel.vala"
	if (_tmp0_ == NULL) {
#line 706 "panel.vala"
		return;
#line 4155 "panel.c"
	}
#line 708 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 708 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 708 "panel.vala"
	candidate_panel_set_vertical (_tmp1_, g_settings_get_int (_tmp2_, "lookup-table-orientation") == ((gint) IBUS_ORIENTATION_VERTICAL));
#line 4163 "panel.c"
}

static void
panel_set_show_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 713 "panel.vala"
	g_return_if_fail (self != NULL);
#line 714 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 714 "panel.vala"
	if (_tmp0_ == NULL) {
#line 715 "panel.vala"
		return;
#line 4180 "panel.c"
	}
#line 717 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 717 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 717 "panel.vala"
	property_panel_set_show (_tmp1_, g_settings_get_int (_tmp2_, "show"));
#line 4188 "panel.c"
}

static void
panel_set_timeout_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 720 "panel.vala"
	g_return_if_fail (self != NULL);
#line 721 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 721 "panel.vala"
	if (_tmp0_ == NULL) {
#line 722 "panel.vala"
		return;
#line 4205 "panel.c"
	}
#line 724 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 724 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 724 "panel.vala"
	property_panel_set_auto_hide_timeout (_tmp1_, (guint) g_settings_get_int (_tmp2_, "auto-hide-timeout"));
#line 4213 "panel.c"
}

static void
panel_set_follow_input_cursor_when_always_shown_property_panel (Panel* self)
{
	PropertyPanel* _tmp0_;
	PropertyPanel* _tmp1_;
	GSettings* _tmp2_;
#line 728 "panel.vala"
	g_return_if_fail (self != NULL);
#line 729 "panel.vala"
	_tmp0_ = self->priv->m_property_panel;
#line 729 "panel.vala"
	if (_tmp0_ == NULL) {
#line 730 "panel.vala"
		return;
#line 4230 "panel.c"
	}
#line 732 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 732 "panel.vala"
	_tmp2_ = self->priv->m_settings_panel;
#line 732 "panel.vala"
	property_panel_set_follow_input_cursor_when_always_shown (_tmp1_, g_settings_get_boolean (_tmp2_, "follow-input-cursor-when-always-shown"));
#line 4238 "panel.c"
}

static void
panel_set_xkb_icon_rgba (Panel* self)
{
	gchar* spec = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp2_ = {0};
	const gchar* _tmp3_;
#line 737 "panel.vala"
	g_return_if_fail (self != NULL);
#line 738 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 738 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "xkb-icon-rgba");
#line 738 "panel.vala"
	spec = _tmp1_;
#line 740 "panel.vala"
	_tmp2_.red = (gdouble) 0;
#line 740 "panel.vala"
	rgba = _tmp2_;
#line 742 "panel.vala"
	_tmp3_ = spec;
#line 742 "panel.vala"
	if (!gdk_rgba_parse (&rgba, _tmp3_)) {
#line 4266 "panel.c"
		const gchar* _tmp4_;
		GdkRGBA _tmp5_ = {0};
#line 743 "panel.vala"
		_tmp4_ = spec;
#line 743 "panel.vala"
		g_warning ("panel.vala:743: invalid format of xkb-icon-rgba: %s", _tmp4_);
#line 744 "panel.vala"
		memset (&_tmp5_, 0, sizeof (GdkRGBA));
#line 744 "panel.vala"
		_tmp5_.red = 0.0;
#line 744 "panel.vala"
		_tmp5_.green = 0.0;
#line 744 "panel.vala"
		_tmp5_.blue = 0.0;
#line 744 "panel.vala"
		_tmp5_.alpha = 1.0;
#line 744 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp5_;
#line 4285 "panel.c"
	} else {
		GdkRGBA _tmp6_;
#line 747 "panel.vala"
		_tmp6_ = rgba;
#line 747 "panel.vala"
		self->priv->m_xkb_icon_rgba = _tmp6_;
#line 4292 "panel.c"
	}
#line 749 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 4296 "panel.c"
		GHashTable* _tmp7_;
#line 750 "panel.vala"
		_tmp7_ = self->priv->m_xkb_icon_pixbufs;
#line 750 "panel.vala"
		if (g_hash_table_size (_tmp7_) > ((guint) 0)) {
#line 4302 "panel.c"
			GHashTable* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GtkStatusIcon* _tmp10_;
#line 751 "panel.vala"
			_tmp8_ = self->priv->m_xkb_icon_pixbufs;
#line 751 "panel.vala"
			g_hash_table_remove_all (_tmp8_);
#line 753 "panel.vala"
			_tmp10_ = self->priv->m_status_icon;
#line 753 "panel.vala"
			if (_tmp10_ != NULL) {
#line 4314 "panel.c"
				Switcher* _tmp11_;
#line 753 "panel.vala"
				_tmp11_ = self->priv->m_switcher;
#line 753 "panel.vala"
				_tmp9_ = _tmp11_ != NULL;
#line 4320 "panel.c"
			} else {
#line 753 "panel.vala"
				_tmp9_ = FALSE;
#line 4324 "panel.c"
			}
#line 753 "panel.vala"
			if (_tmp9_) {
#line 754 "panel.vala"
				g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4330 "panel.c"
			}
		}
	} else {
#line 758 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 4336 "panel.c"
			GHashTable* _tmp12_;
#line 759 "panel.vala"
			_tmp12_ = self->priv->m_xkb_icon_image;
#line 759 "panel.vala"
			if (g_hash_table_size (_tmp12_) > ((guint) 0)) {
#line 4342 "panel.c"
				GHashTable* _tmp13_;
				gboolean _tmp14_ = FALSE;
				Indicator* _tmp15_;
#line 760 "panel.vala"
				_tmp13_ = self->priv->m_xkb_icon_image;
#line 760 "panel.vala"
				g_hash_table_remove_all (_tmp13_);
#line 762 "panel.vala"
				_tmp15_ = self->priv->m_indicator;
#line 762 "panel.vala"
				if (_tmp15_ != NULL) {
#line 4354 "panel.c"
					Switcher* _tmp16_;
#line 762 "panel.vala"
					_tmp16_ = self->priv->m_switcher;
#line 762 "panel.vala"
					_tmp14_ = _tmp16_ != NULL;
#line 4360 "panel.c"
				} else {
#line 762 "panel.vala"
					_tmp14_ = FALSE;
#line 4364 "panel.c"
				}
#line 762 "panel.vala"
				if (_tmp14_) {
#line 763 "panel.vala"
					g_signal_emit_by_name ((IBusPanelService*) self, "state-changed");
#line 4370 "panel.c"
				}
			}
		}
	}
#line 737 "panel.vala"
	_g_free0 (spec);
#line 4377 "panel.c"
}

static void
panel_set_property_icon_delay_time (Panel* self)
{
	GSettings* _tmp0_;
#line 769 "panel.vala"
	g_return_if_fail (self != NULL);
#line 770 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 770 "panel.vala"
	self->priv->m_property_icon_delay_time = g_settings_get_int (_tmp0_, "property-icon-delay-time");
#line 4390 "panel.c"
}

static gint
panel_compare_versions (Panel* self,
                        const gchar* version1,
                        const gchar* version2)
{
	gchar** version1_list = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint version1_list_length1;
	gint _version1_list_size_;
	gchar** version2_list = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint version2_list_length1;
	gint _version2_list_size_;
	gint major1 = 0;
	gint minor1 = 0;
	gint micro1 = 0;
	gint major2 = 0;
	gint minor2 = 0;
	gint micro2 = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gint result;
#line 775 "panel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 775 "panel.vala"
	g_return_val_if_fail (version1 != NULL, 0);
#line 775 "panel.vala"
	g_return_val_if_fail (version2 != NULL, 0);
#line 776 "panel.vala"
	_tmp1_ = _tmp0_ = g_strsplit (version1, ".", 0);
#line 776 "panel.vala"
	version1_list = _tmp1_;
#line 776 "panel.vala"
	version1_list_length1 = _vala_array_length (_tmp0_);
#line 776 "panel.vala"
	_version1_list_size_ = version1_list_length1;
#line 777 "panel.vala"
	_tmp3_ = _tmp2_ = g_strsplit (version2, ".", 0);
#line 777 "panel.vala"
	version2_list = _tmp3_;
#line 777 "panel.vala"
	version2_list_length1 = _vala_array_length (_tmp2_);
#line 777 "panel.vala"
	_version2_list_size_ = version2_list_length1;
#line 780 "panel.vala"
	if (g_strcmp0 (version1, version2) == 0) {
#line 781 "panel.vala"
		result = 0;
#line 781 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 781 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 781 "panel.vala"
		return result;
#line 4473 "panel.c"
	}
#line 785 "panel.vala"
	if (g_strcmp0 (version1, "") == 0) {
#line 786 "panel.vala"
		result = -1;
#line 786 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 786 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 786 "panel.vala"
		return result;
#line 4485 "panel.c"
	}
#line 788 "panel.vala"
	if (g_strcmp0 (version2, "") == 0) {
#line 789 "panel.vala"
		result = 1;
#line 789 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 789 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 789 "panel.vala"
		return result;
#line 4497 "panel.c"
	}
#line 792 "panel.vala"
	_tmp4_ = version1_list;
#line 792 "panel.vala"
	_tmp4__length1 = version1_list_length1;
#line 792 "panel.vala"
	_vala_assert (_tmp4__length1 >= 3, "version1_list.length >= 3");
#line 793 "panel.vala"
	_tmp5_ = version2_list;
#line 793 "panel.vala"
	_tmp5__length1 = version2_list_length1;
#line 793 "panel.vala"
	_vala_assert (_tmp5__length1 >= 3, "version2_list.length >= 3");
#line 795 "panel.vala"
	_tmp6_ = version1_list;
#line 795 "panel.vala"
	_tmp6__length1 = version1_list_length1;
#line 795 "panel.vala"
	_tmp7_ = _tmp6_[0];
#line 795 "panel.vala"
	major1 = atoi (_tmp7_);
#line 796 "panel.vala"
	_tmp8_ = version1_list;
#line 796 "panel.vala"
	_tmp8__length1 = version1_list_length1;
#line 796 "panel.vala"
	_tmp9_ = _tmp8_[1];
#line 796 "panel.vala"
	minor1 = atoi (_tmp9_);
#line 797 "panel.vala"
	_tmp10_ = version1_list;
#line 797 "panel.vala"
	_tmp10__length1 = version1_list_length1;
#line 797 "panel.vala"
	_tmp11_ = _tmp10_[2];
#line 797 "panel.vala"
	micro1 = atoi (_tmp11_);
#line 799 "panel.vala"
	_tmp12_ = version2_list;
#line 799 "panel.vala"
	_tmp12__length1 = version2_list_length1;
#line 799 "panel.vala"
	_tmp13_ = _tmp12_[0];
#line 799 "panel.vala"
	major2 = atoi (_tmp13_);
#line 800 "panel.vala"
	_tmp14_ = version2_list;
#line 800 "panel.vala"
	_tmp14__length1 = version2_list_length1;
#line 800 "panel.vala"
	_tmp15_ = _tmp14_[1];
#line 800 "panel.vala"
	minor2 = atoi (_tmp15_);
#line 801 "panel.vala"
	_tmp16_ = version2_list;
#line 801 "panel.vala"
	_tmp16__length1 = version2_list_length1;
#line 801 "panel.vala"
	_tmp17_ = _tmp16_[2];
#line 801 "panel.vala"
	micro2 = atoi (_tmp17_);
#line 803 "panel.vala"
	if (major1 == minor1) {
#line 803 "panel.vala"
		_tmp19_ = minor1 == minor2;
#line 4563 "panel.c"
	} else {
#line 803 "panel.vala"
		_tmp19_ = FALSE;
#line 4567 "panel.c"
	}
#line 803 "panel.vala"
	if (_tmp19_) {
#line 803 "panel.vala"
		_tmp18_ = micro1 == micro2;
#line 4573 "panel.c"
	} else {
#line 803 "panel.vala"
		_tmp18_ = FALSE;
#line 4577 "panel.c"
	}
#line 803 "panel.vala"
	if (_tmp18_) {
#line 804 "panel.vala"
		result = 0;
#line 804 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 804 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 804 "panel.vala"
		return result;
#line 4589 "panel.c"
	}
#line 806 "panel.vala"
	if (major1 > major2) {
#line 806 "panel.vala"
		_tmp21_ = TRUE;
#line 4595 "panel.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 807 "panel.vala"
		if (major1 == major2) {
#line 807 "panel.vala"
			_tmp22_ = minor1 > minor2;
#line 4602 "panel.c"
		} else {
#line 807 "panel.vala"
			_tmp22_ = FALSE;
#line 4606 "panel.c"
		}
#line 807 "panel.vala"
		_tmp21_ = _tmp22_;
#line 4610 "panel.c"
	}
#line 806 "panel.vala"
	if (_tmp21_) {
#line 806 "panel.vala"
		_tmp20_ = TRUE;
#line 4616 "panel.c"
	} else {
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
#line 808 "panel.vala"
		if (major1 == major2) {
#line 808 "panel.vala"
			_tmp24_ = minor1 == minor2;
#line 4624 "panel.c"
		} else {
#line 808 "panel.vala"
			_tmp24_ = FALSE;
#line 4628 "panel.c"
		}
#line 808 "panel.vala"
		if (_tmp24_) {
#line 809 "panel.vala"
			_tmp23_ = micro1 > micro2;
#line 4634 "panel.c"
		} else {
#line 808 "panel.vala"
			_tmp23_ = FALSE;
#line 4638 "panel.c"
		}
#line 808 "panel.vala"
		_tmp20_ = _tmp23_;
#line 4642 "panel.c"
	}
#line 806 "panel.vala"
	if (_tmp20_) {
#line 810 "panel.vala"
		result = 1;
#line 810 "panel.vala"
		version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 810 "panel.vala"
		version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 810 "panel.vala"
		return result;
#line 4654 "panel.c"
	}
#line 812 "panel.vala"
	result = -1;
#line 812 "panel.vala"
	version2_list = (_vala_array_free (version2_list, version2_list_length1, (GDestroyNotify) g_free), NULL);
#line 812 "panel.vala"
	version1_list = (_vala_array_free (version1_list, version1_list_length1, (GDestroyNotify) g_free), NULL);
#line 812 "panel.vala"
	return result;
#line 4664 "panel.c"
}

static void
panel_update_version_1_5_8 (Panel* self)
{
#line 816 "panel.vala"
	g_return_if_fail (self != NULL);
#line 817 "panel.vala"
	self->priv->inited_engines_order = FALSE;
#line 4674 "panel.c"
}

static void
panel_set_version (Panel* self)
{
	gchar* prev_version = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* current_version = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
#line 821 "panel.vala"
	g_return_if_fail (self != NULL);
#line 822 "panel.vala"
	_tmp0_ = self->priv->m_settings_general;
#line 822 "panel.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "version");
#line 822 "panel.vala"
	prev_version = _tmp1_;
#line 823 "panel.vala"
	current_version = NULL;
#line 825 "panel.vala"
	_tmp2_ = prev_version;
#line 825 "panel.vala"
	if (panel_compare_versions (self, _tmp2_, "1.5.8") < 0) {
#line 826 "panel.vala"
		panel_update_version_1_5_8 (self);
#line 4706 "panel.c"
	}
#line 828 "panel.vala"
	_tmp3_ = g_strdup_printf ("%d.%d.%d", IBUS_MAJOR_VERSION, IBUS_MINOR_VERSION, IBUS_MICRO_VERSION);
#line 828 "panel.vala"
	_g_free0 (current_version);
#line 828 "panel.vala"
	current_version = _tmp3_;
#line 832 "panel.vala"
	_tmp4_ = prev_version;
#line 832 "panel.vala"
	_tmp5_ = current_version;
#line 832 "panel.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 833 "panel.vala"
		_g_free0 (current_version);
#line 833 "panel.vala"
		_g_free0 (prev_version);
#line 833 "panel.vala"
		return;
#line 4726 "panel.c"
	}
#line 836 "panel.vala"
	_tmp6_ = self->priv->m_settings_general;
#line 836 "panel.vala"
	_tmp7_ = current_version;
#line 836 "panel.vala"
	g_settings_set_string (_tmp6_, "version", _tmp7_);
#line 821 "panel.vala"
	_g_free0 (current_version);
#line 821 "panel.vala"
	_g_free0 (prev_version);
#line 4738 "panel.c"
}

static void
panel_check_wayland (Panel* self)
{
	gchar* message = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp12_;
	NotifyNotification* notification = NULL;
	const gchar* _tmp13_;
	NotifyNotification* _tmp14_;
	NotifyNotification* _tmp15_;
	NotifyNotification* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 840 "panel.vala"
	g_return_if_fail (self != NULL);
#line 841 "panel.vala"
	message = NULL;
#line 842 "panel.vala"
	if (self->priv->m_is_wayland) {
#line 842 "panel.vala"
		_tmp1_ = !self->priv->m_is_wayland_im;
#line 4762 "panel.c"
	} else {
#line 842 "panel.vala"
		_tmp1_ = FALSE;
#line 4766 "panel.c"
	}
#line 842 "panel.vala"
	if (_tmp1_) {
#line 842 "panel.vala"
		_tmp0_ = !panel_is_gnome ();
#line 4772 "panel.c"
	} else {
#line 842 "panel.vala"
		_tmp0_ = FALSE;
#line 4776 "panel.c"
	}
#line 842 "panel.vala"
	if (_tmp0_) {
#line 4780 "panel.c"
		gchar* format = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 843 "panel.vala"
		_tmp2_ = g_strdup (_ ("IBus should be called from the desktop session in " "%s. For KDE, you can launch '%s' " "utility and go to \"Input Devices\" -> " "\"Virtual Keyboard\" section and select " "\"%s\" icon and click \"Apply\" button to " "configure IBus in %s. For other desktop " "sessions, you can copy the 'Exec=' line in %s file " "to a configuration file of the session. " "Please refer each document about the \"Wayland " "input method\" configuration. Before you configure " "the \"Wayland input method\", you should make sure " "that QT_IM_MODULE and GTK_IM_MODULE environment " "variables are unset in the desktop session."));
#line 843 "panel.vala"
		format = _tmp2_;
#line 857 "panel.vala"
		_tmp3_ = format;
#line 857 "panel.vala"
		_tmp4_ = g_strdup_printf (_tmp3_, "Wayland", "systemsettings5", "IBus Wayland", "Wayland", "org.freedesktop.IBus.Panel.Wayland.Gtk3.desktop");
#line 857 "panel.vala"
		_g_free0 (message);
#line 857 "panel.vala"
		message = _tmp4_;
#line 842 "panel.vala"
		_g_free0 (format);
#line 4799 "panel.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 863 "panel.vala"
		if (self->priv->m_is_wayland) {
#line 863 "panel.vala"
			_tmp6_ = self->priv->m_is_wayland_im;
#line 4807 "panel.c"
		} else {
#line 863 "panel.vala"
			_tmp6_ = FALSE;
#line 4811 "panel.c"
		}
#line 863 "panel.vala"
		if (_tmp6_) {
#line 863 "panel.vala"
			_tmp5_ = !panel_is_gnome ();
#line 4817 "panel.c"
		} else {
#line 863 "panel.vala"
			_tmp5_ = FALSE;
#line 4821 "panel.c"
		}
#line 863 "panel.vala"
		if (_tmp5_) {
#line 4825 "panel.c"
			const gchar* _tmp7_;
#line 864 "panel.vala"
			_tmp7_ = g_getenv ("QT_IM_MODULE");
#line 864 "panel.vala"
			if (g_strcmp0 (_tmp7_, "ibus") == 0) {
#line 4831 "panel.c"
				gchar* format = NULL;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 865 "panel.vala"
				_tmp8_ = g_strdup (_ ("Please unset QT_IM_MODULE and GTK_IM_MODULE " "environment variables and 'ibus-daemon --panel " "disable' should be executed as a child process " "of %s component."));
#line 865 "panel.vala"
				format = _tmp8_;
#line 870 "panel.vala"
				_tmp9_ = format;
#line 870 "panel.vala"
				_tmp10_ = g_get_prgname ();
#line 870 "panel.vala"
				_tmp11_ = g_strdup_printf (_tmp9_, _tmp10_);
#line 870 "panel.vala"
				_g_free0 (message);
#line 870 "panel.vala"
				message = _tmp11_;
#line 864 "panel.vala"
				_g_free0 (format);
#line 4853 "panel.c"
			}
		}
	}
#line 873 "panel.vala"
	_tmp12_ = message;
#line 873 "panel.vala"
	if (_tmp12_ == NULL) {
#line 874 "panel.vala"
		_g_free0 (message);
#line 874 "panel.vala"
		return;
#line 4865 "panel.c"
	}
#line 876 "panel.vala"
	if (!notify_is_initted ()) {
#line 877 "panel.vala"
		notify_init ("ibus");
#line 4871 "panel.c"
	}
#line 880 "panel.vala"
	_tmp13_ = message;
#line 880 "panel.vala"
	_tmp14_ = notify_notification_new (_ ("IBus Notification"), _tmp13_, "ibus");
#line 880 "panel.vala"
	notification = _tmp14_;
#line 884 "panel.vala"
	_tmp15_ = notification;
#line 884 "panel.vala"
	notify_notification_set_timeout (_tmp15_, 60 * 1000);
#line 885 "panel.vala"
	_tmp16_ = notification;
#line 885 "panel.vala"
	notify_notification_set_category (_tmp16_, "wayland");
#line 4887 "panel.c"
	{
		NotifyNotification* _tmp17_;
#line 888 "panel.vala"
		_tmp17_ = notification;
#line 888 "panel.vala"
		notify_notification_show (_tmp17_, &_inner_error0_);
#line 888 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4896 "panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		const gchar* _tmp18_;
#line 887 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 890 "panel.vala"
		_tmp18_ = message;
#line 890 "panel.vala"
		g_warning ("panel.vala:890: %s", _tmp18_);
#line 4910 "panel.c"
	}
	__finally0:
#line 887 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 887 "panel.vala"
		_g_object_unref0 (notification);
#line 887 "panel.vala"
		_g_free0 (message);
#line 887 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 887 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 887 "panel.vala"
		return;
#line 4925 "panel.c"
	}
#line 840 "panel.vala"
	_g_object_unref0 (notification);
#line 840 "panel.vala"
	_g_free0 (message);
#line 4931 "panel.c"
}

static void
panel_save_log (Panel* self,
                const gchar* format)
{
	FILE* _tmp0_;
	FILE* _tmp1_;
	FILE* _tmp2_;
#line 898 "panel.vala"
	g_return_if_fail (self != NULL);
#line 898 "panel.vala"
	g_return_if_fail (format != NULL);
#line 899 "panel.vala"
	_tmp0_ = self->priv->m_log;
#line 899 "panel.vala"
	if (_tmp0_ == NULL) {
#line 900 "panel.vala"
		return;
#line 4951 "panel.c"
	}
#line 901 "panel.vala"
	_tmp1_ = self->priv->m_log;
#line 901 "panel.vala"
	fputs (format, _tmp1_);
#line 902 "panel.vala"
	_tmp2_ = self->priv->m_log;
#line 902 "panel.vala"
	fflush (_tmp2_);
#line 4961 "panel.c"
}

void
panel_load_settings (Panel* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSettings* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GList* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
#line 906 "panel.vala"
	g_return_if_fail (self != NULL);
#line 907 "panel.vala"
	panel_set_version (self);
#line 908 "panel.vala"
	panel_check_wayland (self);
#line 910 "panel.vala"
	panel_init_engines_order (self);
#line 914 "panel.vala"
	panel_set_use_system_keyboard_layout (self);
#line 915 "panel.vala"
	panel_set_use_global_engine (self);
#line 916 "panel.vala"
	panel_set_use_xmodmap (self);
#line 917 "panel.vala"
	_tmp0_ = self->priv->m_settings_panel;
#line 917 "panel.vala"
	self->priv->m_use_engine_lang = g_settings_get_boolean (_tmp0_, "use-glyph-from-engine-lang");
#line 919 "panel.vala"
	_tmp1_ = self->priv->m_settings_general;
#line 919 "panel.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "preload-engines");
#line 919 "panel.vala"
	_tmp4_ = _tmp3_;
#line 919 "panel.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 919 "panel.vala"
	_tmp5_ = self->priv->m_settings_general;
#line 919 "panel.vala"
	_tmp7_ = _tmp6_ = g_settings_get_strv (_tmp5_, "engines-order");
#line 919 "panel.vala"
	_tmp8_ = _tmp7_;
#line 919 "panel.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 919 "panel.vala"
	panel_update_engines (self, _tmp4_, (gint) _vala_array_length (_tmp2_), _tmp8_, (gint) _vala_array_length (_tmp6_));
#line 919 "panel.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 919 "panel.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 921 "panel.vala"
	_tmp9_ = self->priv->m_keybindings;
#line 921 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp9_);
#line 924 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 924 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 925 "panel.vala"
	panel_bind_switch_shortcut (self);
#line 926 "panel.vala"
	panel_set_switcher_delay_time (self);
#line 927 "panel.vala"
	panel_set_embed_preedit_text (self);
#line 928 "panel.vala"
	_tmp10_ = self->priv->m_settings_panel;
#line 928 "panel.vala"
	binding_common_set_custom_font (_tmp10_, NULL, &self->priv->m_css_provider);
#line 931 "panel.vala"
	_tmp11_ = self->priv->m_settings_panel;
#line 931 "panel.vala"
	binding_common_set_custom_theme (_tmp11_);
#line 932 "panel.vala"
	_tmp12_ = self->priv->m_settings_panel;
#line 932 "panel.vala"
	binding_common_set_custom_icon (_tmp12_);
#line 933 "panel.vala"
	panel_set_show_icon_on_systray (self);
#line 934 "panel.vala"
	panel_set_lookup_table_orientation (self);
#line 935 "panel.vala"
	panel_set_show_property_panel (self);
#line 936 "panel.vala"
	panel_set_timeout_property_panel (self);
#line 937 "panel.vala"
	panel_set_follow_input_cursor_when_always_shown_property_panel (self);
#line 938 "panel.vala"
	panel_set_xkb_icon_rgba (self);
#line 939 "panel.vala"
	panel_set_property_icon_delay_time (self);
#line 5062 "panel.c"
}

/**
     * disconnect_signals:
     *
     * Call this API before m_panel = null so that the ref_count becomes 0
     */
void
panel_disconnect_signals (Panel* self)
{
	GObject* object = NULL;
	GtkStatusIcon* _tmp0_;
#line 947 "panel.vala"
	g_return_if_fail (self != NULL);
#line 948 "panel.vala"
	_tmp0_ = self->priv->m_status_icon;
#line 948 "panel.vala"
	object = (GObject*) _tmp0_;
#line 950 "panel.vala"
	if (self->priv->m_is_kde) {
#line 5083 "panel.c"
		Indicator* _tmp1_;
#line 951 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 951 "panel.vala"
		object = (GObject*) _tmp1_;
#line 5089 "panel.c"
	}
#line 953 "panel.vala"
	if (self->priv->m_popup_menu_id > ((gulong) 0)) {
#line 5093 "panel.c"
		GObject* _tmp2_;
#line 955 "panel.vala"
		_tmp2_ = object;
#line 955 "panel.vala"
		if (g_signal_handler_is_connected (_tmp2_, self->priv->m_popup_menu_id)) {
#line 5099 "panel.c"
			GObject* _tmp3_;
#line 956 "panel.vala"
			_tmp3_ = object;
#line 956 "panel.vala"
			g_signal_handler_disconnect (_tmp3_, self->priv->m_popup_menu_id);
#line 5105 "panel.c"
		}
#line 957 "panel.vala"
		self->priv->m_popup_menu_id = (gulong) 0;
#line 5109 "panel.c"
	}
#line 959 "panel.vala"
	if (self->priv->m_activate_id > ((gulong) 0)) {
#line 5113 "panel.c"
		GObject* _tmp4_;
#line 960 "panel.vala"
		_tmp4_ = object;
#line 960 "panel.vala"
		if (g_signal_handler_is_connected (_tmp4_, self->priv->m_activate_id)) {
#line 5119 "panel.c"
			GObject* _tmp5_;
#line 961 "panel.vala"
			_tmp5_ = object;
#line 961 "panel.vala"
			g_signal_handler_disconnect (_tmp5_, self->priv->m_activate_id);
#line 5125 "panel.c"
		}
#line 962 "panel.vala"
		self->priv->m_activate_id = (gulong) 0;
#line 5129 "panel.c"
	}
#line 964 "panel.vala"
	if (self->priv->m_registered_status_notifier_item_id > ((gulong) 0)) {
#line 5133 "panel.c"
		GObject* _tmp6_;
#line 965 "panel.vala"
		_tmp6_ = object;
#line 965 "panel.vala"
		if (g_signal_handler_is_connected (_tmp6_, self->priv->m_registered_status_notifier_item_id)) {
#line 5139 "panel.c"
			GObject* _tmp7_;
#line 968 "panel.vala"
			_tmp7_ = object;
#line 968 "panel.vala"
			g_signal_handler_disconnect (_tmp7_, self->priv->m_registered_status_notifier_item_id);
#line 5145 "panel.c"
		}
#line 970 "panel.vala"
		self->priv->m_registered_status_notifier_item_id = (gulong) 0;
#line 5149 "panel.c"
	}
#line 972 "panel.vala"
	if (self->priv->m_preload_engines_id > ((guint) 0)) {
#line 973 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 974 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 5157 "panel.c"
	}
}

/**
     * set_global_shortcut_key_state:
     *
     * Handle IME switcher dialog or Emojier on the focused context only
     * so this API is assumed to use in Wayland.
     */
void
panel_set_global_shortcut_key_state (Panel* self,
                                     IBusBusGlobalBindingType type,
                                     gboolean is_pressed,
                                     gboolean is_backward)
{
#line 985 "panel.vala"
	g_return_if_fail (self != NULL);
#line 989 "panel.vala"
	switch (type) {
#line 989 "panel.vala"
		case IBUS_BUS_GLOBAL_BINDING_TYPE_IME_SWITCHER:
#line 5179 "panel.c"
		{
#line 991 "panel.vala"
			panel_handle_engine_switch_focused (self, is_pressed, is_backward);
#line 992 "panel.vala"
			break;
#line 5185 "panel.c"
		}
		default:
		{
#line 993 "panel.vala"
			break;
#line 5191 "panel.c"
		}
	}
}

void
panel_set_log (Panel* self,
               FILE* log,
               gboolean verbose)
{
#line 998 "panel.vala"
	g_return_if_fail (self != NULL);
#line 998 "panel.vala"
	g_return_if_fail (log != NULL);
#line 999 "panel.vala"
	self->priv->m_log = log;
#line 1000 "panel.vala"
	self->priv->m_verbose = verbose;
#line 5209 "panel.c"
}

static void
panel_engine_contexts_insert (Panel* self,
                              IBusEngineDesc* engine)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	IBusEngineDesc* _tmp5_;
#line 1004 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1004 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1005 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1006 "panel.vala"
		return;
#line 5229 "panel.c"
	}
#line 1008 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1008 "panel.vala"
	if (g_hash_table_size (_tmp0_) >= ((guint) 200)) {
#line 5235 "panel.c"
		GHashTable* _tmp1_;
#line 1009 "panel.vala"
		g_warning ("panel.vala:1009: Contexts by windows are too much counted!");
#line 1010 "panel.vala"
		_tmp1_ = self->priv->m_engine_contexts;
#line 1010 "panel.vala"
		g_hash_table_remove_all (_tmp1_);
#line 5243 "panel.c"
	}
#line 1013 "panel.vala"
	_tmp2_ = self->priv->m_engine_contexts;
#line 1013 "panel.vala"
	_tmp3_ = self->priv->m_current_context_path;
#line 1013 "panel.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 1013 "panel.vala"
	_tmp5_ = _g_object_ref0 (engine);
#line 1013 "panel.vala"
	g_hash_table_replace (_tmp2_, _tmp4_, _tmp5_);
#line 5255 "panel.c"
}

static void
panel_set_language_from_engine (Panel* self,
                                IBusEngineDesc* engine)
{
#line 1016 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1016 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1017 "panel.vala"
	if (self->priv->m_use_engine_lang) {
#line 5268 "panel.c"
		CandidatePanel* _tmp0_;
		const gchar* _tmp1_;
		PangoLanguage* _tmp2_;
		PangoAttrLanguage* _tmp3_;
		PangoAttrLanguage* _tmp4_;
#line 1018 "panel.vala"
		_tmp0_ = self->priv->m_candidate_panel;
#line 1018 "panel.vala"
		_tmp1_ = ibus_engine_desc_get_language (engine);
#line 1018 "panel.vala"
		_tmp2_ = pango_language_from_string (_tmp1_);
#line 1018 "panel.vala"
		_tmp3_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp2_);
#line 1018 "panel.vala"
		_tmp4_ = _tmp3_;
#line 1018 "panel.vala"
		candidate_panel_set_language (_tmp0_, (PangoAttribute*) _tmp4_);
#line 1018 "panel.vala"
		_pango_attribute_destroy0 (_tmp4_);
#line 5288 "panel.c"
	} else {
		CandidatePanel* _tmp5_;
		PangoLanguage* _tmp6_;
		PangoAttrLanguage* _tmp7_;
		PangoAttrLanguage* _tmp8_;
#line 1021 "panel.vala"
		_tmp5_ = self->priv->m_candidate_panel;
#line 1021 "panel.vala"
		_tmp6_ = pango_language_from_string (NULL);
#line 1021 "panel.vala"
		_tmp7_ = (PangoAttrLanguage*) pango_attr_language_new (_tmp6_);
#line 1021 "panel.vala"
		_tmp8_ = _tmp7_;
#line 1021 "panel.vala"
		candidate_panel_set_language (_tmp5_, (PangoAttribute*) _tmp8_);
#line 1021 "panel.vala"
		_pango_attribute_destroy0 (_tmp8_);
#line 5306 "panel.c"
	}
}

static void
panel_set_engine (Panel* self,
                  IBusEngineDesc* engine)
{
	IBusBus* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 1027 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1027 "panel.vala"
	g_return_if_fail (engine != NULL);
#line 1028 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1029 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1030 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 5328 "panel.c"
	}
#line 1033 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1033 "panel.vala"
	_tmp1_ = ibus_engine_desc_get_name (engine);
#line 1033 "panel.vala"
	if (!ibus_bus_set_global_engine (_tmp0_, _tmp1_)) {
#line 5336 "panel.c"
		const gchar* _tmp2_;
#line 1034 "panel.vala"
		_tmp2_ = ibus_engine_desc_get_name (engine);
#line 1034 "panel.vala"
		g_warning ("panel.vala:1034: Switch engine to %s failed.", _tmp2_);
#line 1035 "panel.vala"
		return;
#line 5344 "panel.c"
	}
#line 1042 "panel.vala"
	_tmp3_ = g_strdup ("");
#line 1042 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 1042 "panel.vala"
	self->priv->m_icon_prop_key = _tmp3_;
#line 1045 "panel.vala"
	if (!self->priv->m_use_system_keyboard_layout) {
#line 1045 "panel.vala"
		_tmp4_ = !self->priv->m_is_wayland;
#line 5356 "panel.c"
	} else {
#line 1045 "panel.vala"
		_tmp4_ = FALSE;
#line 5360 "panel.c"
	}
#line 1045 "panel.vala"
	if (_tmp4_) {
#line 5364 "panel.c"
		XKBLayout* _tmp5_;
#line 1046 "panel.vala"
		_tmp5_ = self->priv->m_xkblayout;
#line 1046 "panel.vala"
		xkb_layout_set_layout (_tmp5_, engine);
#line 5370 "panel.c"
	}
#line 1048 "panel.vala"
	panel_set_language_from_engine (self, engine);
#line 1049 "panel.vala"
	panel_engine_contexts_insert (self, engine);
#line 5376 "panel.c"
}

static void
panel_switch_engine (Panel* self,
                     gint i,
                     gboolean force)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	IBusEngineDesc* engine = NULL;
	IBusEngineDesc** _tmp3_;
	gint _tmp3__length1;
	IBusEngineDesc* _tmp4_;
	IBusEngineDesc* _tmp5_;
	IBusEngineDesc* _tmp6_;
#line 1052 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1053 "panel.vala"
	if (i >= 0) {
#line 5396 "panel.c"
		IBusEngineDesc** _tmp1_;
		gint _tmp1__length1;
#line 1053 "panel.vala"
		_tmp1_ = self->priv->m_engines;
#line 1053 "panel.vala"
		_tmp1__length1 = self->priv->m_engines_length1;
#line 1053 "panel.vala"
		_tmp0_ = i < _tmp1__length1;
#line 5405 "panel.c"
	} else {
#line 1053 "panel.vala"
		_tmp0_ = FALSE;
#line 5409 "panel.c"
	}
#line 1053 "panel.vala"
	_vala_assert (_tmp0_, "i >= 0 && i < m_engines.length");
#line 1056 "panel.vala"
	if (i == 0) {
#line 1056 "panel.vala"
		_tmp2_ = !force;
#line 5417 "panel.c"
	} else {
#line 1056 "panel.vala"
		_tmp2_ = FALSE;
#line 5421 "panel.c"
	}
#line 1056 "panel.vala"
	if (_tmp2_) {
#line 1057 "panel.vala"
		return;
#line 5427 "panel.c"
	}
#line 1059 "panel.vala"
	_tmp3_ = self->priv->m_engines;
#line 1059 "panel.vala"
	_tmp3__length1 = self->priv->m_engines_length1;
#line 1059 "panel.vala"
	_tmp4_ = _tmp3_[i];
#line 1059 "panel.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1059 "panel.vala"
	engine = _tmp5_;
#line 1061 "panel.vala"
	_tmp6_ = engine;
#line 1061 "panel.vala"
	panel_set_engine (self, _tmp6_);
#line 1052 "panel.vala"
	_g_object_unref0 (engine);
#line 5445 "panel.c"
}

static void
panel_handle_engine_switch_normal (Panel* self,
                                   GdkEvent* event)
{
#line 1064 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1064 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1065 "panel.vala"
	panel_handle_engine_switch (self, event, FALSE);
#line 5458 "panel.c"
}

static void
panel_handle_engine_switch_reverse (Panel* self,
                                    GdkEvent* event)
{
#line 1068 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1068 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1069 "panel.vala"
	panel_handle_engine_switch (self, event, TRUE);
#line 5471 "panel.c"
}

static void
panel_handle_engine_switch (Panel* self,
                            GdkEvent* event,
                            gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
	guint keyval = 0U;
	GdkEventKey* _tmp1_;
	GdkEventKey* _tmp2_;
	guint modifiers = 0U;
	GdkEventKey* _tmp3_;
	GdkEventKey* _tmp4_;
	guint primary_modifiers = 0U;
	GdkEventKey* _tmp5_;
	GdkEventKey* _tmp6_;
	gboolean pressed = FALSE;
	gboolean _tmp7_ = FALSE;
#line 1072 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1072 "panel.vala"
	g_return_if_fail (event != NULL);
#line 1074 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 1074 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 1074 "panel.vala"
	if (_tmp0__length1 <= 1) {
#line 1075 "panel.vala"
		return;
#line 5504 "panel.c"
	}
#line 1077 "panel.vala"
	_tmp1_ = (GdkEventKey *) (event);
#line 1077 "panel.vala"
	_tmp2_ = _tmp1_;
#line 1077 "panel.vala"
	keyval = _tmp2_->keyval;
#line 1078 "panel.vala"
	_tmp3_ = (GdkEventKey *) (event);
#line 1078 "panel.vala"
	_tmp4_ = _tmp3_;
#line 1078 "panel.vala"
	modifiers = KEYBINDING_MANAGER_MODIFIER_FILTER & _tmp4_->state;
#line 1080 "panel.vala"
	_tmp5_ = (GdkEventKey *) (event);
#line 1080 "panel.vala"
	_tmp6_ = _tmp5_;
#line 1080 "panel.vala"
	primary_modifiers = (guint) keybinding_manager_get_primary_modifier ((guint) _tmp6_->state);
#line 1083 "panel.vala"
	pressed = keybinding_manager_primary_modifier_still_pressed (event, primary_modifiers);
#line 1086 "panel.vala"
	if (reverse) {
#line 1087 "panel.vala"
		modifiers &= (guint) (~GDK_SHIFT_MASK);
#line 5530 "panel.c"
	}
#line 1090 "panel.vala"
	if (pressed) {
#line 1090 "panel.vala"
		_tmp7_ = self->priv->m_switcher_delay_time >= 0;
#line 5536 "panel.c"
	} else {
#line 1090 "panel.vala"
		_tmp7_ = FALSE;
#line 5540 "panel.c"
	}
#line 1090 "panel.vala"
	if (_tmp7_) {
#line 5544 "panel.c"
		gint _tmp8_ = 0;
		gint i = 0;
		Switcher* _tmp10_;
		IBusEngineDesc** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
#line 1091 "panel.vala"
		if (reverse) {
#line 5553 "panel.c"
			IBusEngineDesc** _tmp9_;
			gint _tmp9__length1;
#line 1091 "panel.vala"
			_tmp9_ = self->priv->m_engines;
#line 1091 "panel.vala"
			_tmp9__length1 = self->priv->m_engines_length1;
#line 1091 "panel.vala"
			_tmp8_ = _tmp9__length1 - 1;
#line 5562 "panel.c"
		} else {
#line 1091 "panel.vala"
			_tmp8_ = 1;
#line 5566 "panel.c"
		}
#line 1091 "panel.vala"
		i = _tmp8_;
#line 1102 "panel.vala"
		_tmp10_ = self->priv->m_switcher;
#line 1102 "panel.vala"
		_tmp11_ = self->priv->m_engines;
#line 1102 "panel.vala"
		_tmp11__length1 = self->priv->m_engines_length1;
#line 1102 "panel.vala"
		_tmp12_ = self->priv->m_real_current_context_path;
#line 1102 "panel.vala"
		i = switcher_run (_tmp10_, keyval, modifiers, event, _tmp11_, (gint) _tmp11__length1, i, _tmp12_);
#line 1105 "panel.vala"
		if (i < 0) {
#line 1106 "panel.vala"
			g_debug ("panel.vala:1106: switch cancelled");
#line 5584 "panel.c"
		} else {
#line 1107 "panel.vala"
			if (i == 0) {
#line 1108 "panel.vala"
				g_debug ("panel.vala:1108: do not have to switch");
#line 5590 "panel.c"
			} else {
#line 1110 "panel.vala"
				panel_switcher_focus_set_engine (self);
#line 5594 "panel.c"
			}
		}
	} else {
		gint _tmp13_ = 0;
		gint i = 0;
#line 1113 "panel.vala"
		if (reverse) {
#line 5602 "panel.c"
			IBusEngineDesc** _tmp14_;
			gint _tmp14__length1;
#line 1113 "panel.vala"
			_tmp14_ = self->priv->m_engines;
#line 1113 "panel.vala"
			_tmp14__length1 = self->priv->m_engines_length1;
#line 1113 "panel.vala"
			_tmp13_ = _tmp14__length1 - 1;
#line 5611 "panel.c"
		} else {
#line 1113 "panel.vala"
			_tmp13_ = 1;
#line 5615 "panel.c"
		}
#line 1113 "panel.vala"
		i = _tmp13_;
#line 1114 "panel.vala"
		panel_switch_engine (self, i, FALSE);
#line 5621 "panel.c"
	}
}

static gboolean
___lambda105_ (Panel* self)
{
	gboolean result;
#line 1149 "panel.vala"
	g_usleep ((gulong) 5000000);
#line 1150 "panel.vala"
	panel_handle_engine_switch_release (self, TRUE);
#line 1151 "panel.vala"
	_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1151 "panel.vala"
	self->priv->m_switcher_waiting_release = NULL;
#line 1152 "panel.vala"
	result = TRUE;
#line 1152 "panel.vala"
	return result;
#line 5641 "panel.c"
}

static gpointer
____lambda105__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda105_ ((Panel*) self));
#line 1147 "panel.vala"
	g_object_unref (self);
#line 1147 "panel.vala"
	return result;
#line 5653 "panel.c"
}

static void
panel_handle_engine_switch_focused (Panel* self,
                                    gboolean pressed,
                                    gboolean reverse)
{
	IBusEngineDesc** _tmp0_;
	gint _tmp0__length1;
#line 1119 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1121 "panel.vala"
	_tmp0_ = self->priv->m_engines;
#line 1121 "panel.vala"
	_tmp0__length1 = self->priv->m_engines_length1;
#line 1121 "panel.vala"
	if (_tmp0__length1 == 0) {
#line 1122 "panel.vala"
		return;
#line 5673 "panel.c"
	}
#line 1123 "panel.vala"
	if (pressed) {
#line 5677 "panel.c"
		gint _tmp1_ = 0;
		gint i = 0;
		GThread* _tmp12_;
#line 1124 "panel.vala"
		if (reverse) {
#line 5683 "panel.c"
			IBusEngineDesc** _tmp2_;
			gint _tmp2__length1;
#line 1124 "panel.vala"
			_tmp2_ = self->priv->m_engines;
#line 1124 "panel.vala"
			_tmp2__length1 = self->priv->m_engines_length1;
#line 1124 "panel.vala"
			_tmp1_ = _tmp2__length1 - 1;
#line 5692 "panel.c"
		} else {
#line 1124 "panel.vala"
			_tmp1_ = 1;
#line 5696 "panel.c"
		}
#line 1124 "panel.vala"
		i = _tmp1_;
#line 1125 "panel.vala"
		if (self->priv->m_switcher_selected_index >= 0) {
#line 5702 "panel.c"
			gint _tmp3_ = 0;
			gint _tmp4_ = 0;
#line 1126 "panel.vala"
			if (reverse) {
#line 1126 "panel.vala"
				_tmp3_ = self->priv->m_switcher_selected_index - 1;
#line 5709 "panel.c"
			} else {
#line 1127 "panel.vala"
				_tmp3_ = self->priv->m_switcher_selected_index + 1;
#line 5713 "panel.c"
			}
#line 1126 "panel.vala"
			i = _tmp3_;
#line 1128 "panel.vala"
			if (i < 0) {
#line 5719 "panel.c"
				IBusEngineDesc** _tmp5_;
				gint _tmp5__length1;
#line 1128 "panel.vala"
				_tmp5_ = self->priv->m_engines;
#line 1128 "panel.vala"
				_tmp5__length1 = self->priv->m_engines_length1;
#line 1128 "panel.vala"
				_tmp4_ = _tmp5__length1 - 1;
#line 5728 "panel.c"
			} else {
				gint _tmp6_ = 0;
				IBusEngineDesc** _tmp7_;
				gint _tmp7__length1;
#line 1129 "panel.vala"
				_tmp7_ = self->priv->m_engines;
#line 1129 "panel.vala"
				_tmp7__length1 = self->priv->m_engines_length1;
#line 1129 "panel.vala"
				if (i == _tmp7__length1) {
#line 1129 "panel.vala"
					_tmp6_ = 0;
#line 5741 "panel.c"
				} else {
#line 1129 "panel.vala"
					_tmp6_ = i;
#line 5745 "panel.c"
				}
#line 1129 "panel.vala"
				_tmp4_ = _tmp6_;
#line 5749 "panel.c"
			}
#line 1128 "panel.vala"
			i = _tmp4_;
#line 5753 "panel.c"
		}
#line 1131 "panel.vala"
		if (self->priv->m_switcher_delay_time >= 0) {
#line 5757 "panel.c"
			Switcher* _tmp8_;
			IBusEngineDesc** _tmp9_;
			gint _tmp9__length1;
#line 1132 "panel.vala"
			_tmp8_ = self->priv->m_switcher;
#line 1132 "panel.vala"
			_tmp9_ = self->priv->m_engines;
#line 1132 "panel.vala"
			_tmp9__length1 = self->priv->m_engines_length1;
#line 1132 "panel.vala"
			self->priv->m_switcher_selected_index = switcher_run_popup (_tmp8_, _tmp9_, (gint) _tmp9__length1, i);
#line 5769 "panel.c"
		} else {
#line 1134 "panel.vala"
			self->priv->m_switcher_selected_index = i;
#line 5773 "panel.c"
		}
#line 1135 "panel.vala"
		if (self->priv->m_verbose) {
#line 5777 "panel.c"
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 1136 "panel.vala"
			_tmp10_ = g_strdup_printf ("Panel.%s switcher release %d timer\n", G_STRFUNC, self->priv->m_switcher_selected_index);
#line 1136 "panel.vala"
			_tmp11_ = _tmp10_;
#line 1136 "panel.vala"
			panel_save_log (self, _tmp11_);
#line 1136 "panel.vala"
			_g_free0 (_tmp11_);
#line 5788 "panel.c"
		}
#line 1139 "panel.vala"
		_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1139 "panel.vala"
		self->priv->m_switcher_waiting_release = NULL;
#line 1147 "panel.vala"
		_tmp12_ = g_thread_new ("wait release", ____lambda105__gthread_func, g_object_ref (self));
#line 1147 "panel.vala"
		_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1147 "panel.vala"
		self->priv->m_switcher_waiting_release = _tmp12_;
#line 5800 "panel.c"
	} else {
#line 1155 "panel.vala"
		_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 1155 "panel.vala"
		self->priv->m_switcher_waiting_release = NULL;
#line 1156 "panel.vala"
		panel_handle_engine_switch_release (self, FALSE);
#line 5808 "panel.c"
	}
}

static void
panel_handle_engine_switch_release (Panel* self,
                                    gboolean is_timeout)
{
	Switcher* _tmp3_;
#line 1160 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1161 "panel.vala"
	if (self->priv->m_verbose) {
#line 5821 "panel.c"
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1164 "panel.vala"
		if (is_timeout) {
#line 1164 "panel.vala"
			_tmp0_ = "timeout";
#line 5829 "panel.c"
		} else {
#line 1164 "panel.vala"
			_tmp0_ = "normal";
#line 5833 "panel.c"
		}
#line 1162 "panel.vala"
		_tmp1_ = g_strdup_printf ("Panel.%s switcher release %d %s\n", G_STRFUNC, self->priv->m_switcher_selected_index, _tmp0_);
#line 1162 "panel.vala"
		_tmp2_ = _tmp1_;
#line 1162 "panel.vala"
		panel_save_log (self, _tmp2_);
#line 1162 "panel.vala"
		_g_free0 (_tmp2_);
#line 5843 "panel.c"
	}
#line 1168 "panel.vala"
	_tmp3_ = self->priv->m_switcher;
#line 1168 "panel.vala"
	gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1169 "panel.vala"
	while (TRUE) {
#line 1169 "panel.vala"
		if (!gtk_events_pending ()) {
#line 1169 "panel.vala"
			break;
#line 5855 "panel.c"
		}
#line 1170 "panel.vala"
		gtk_main_iteration ();
#line 5859 "panel.c"
	}
#line 1172 "panel.vala"
	if (self->priv->m_switcher_selected_index < 0) {
#line 1173 "panel.vala"
		return;
#line 5865 "panel.c"
	}
#line 1174 "panel.vala"
	panel_switch_engine (self, self->priv->m_switcher_selected_index, FALSE);
#line 1175 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 5871 "panel.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 1179 "panel.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 1179 "panel.vala"
	return _data7_;
#line 5881 "panel.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 1179 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 5891 "panel.c"
		Panel* self;
#line 1179 "panel.vala"
		self = _data7_->self;
#line 1179 "panel.vala"
		_data7_->names = (_vala_array_free (_data7_->names, _data7_->names_length1, (GDestroyNotify) g_free), NULL);
#line 1179 "panel.vala"
		_g_object_unref0 (self);
#line 1179 "panel.vala"
		g_slice_free (Block7Data, _data7_);
#line 5901 "panel.c"
	}
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1191 "panel.vala"
	if ((*length) == (*size)) {
#line 1191 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1191 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5917 "panel.c"
	}
#line 1191 "panel.vala"
	(*array)[(*length)++] = value;
#line 1191 "panel.vala"
	(*array)[*length] = NULL;
#line 5923 "panel.c"
}

static gboolean
__lambda62_ (Block7Data* _data7_)
{
	Panel* self;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 1195 "panel.vala"
	self = _data7_->self;
#line 1196 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1196 "panel.vala"
	if (!ibus_bus_is_connected (_tmp0_)) {
#line 1197 "panel.vala"
		result = FALSE;
#line 1197 "panel.vala"
		return result;
#line 5945 "panel.c"
	}
#line 1198 "panel.vala"
	_tmp1_ = self->priv->m_bus;
#line 1198 "panel.vala"
	_tmp2_ = _data7_->names;
#line 1198 "panel.vala"
	_tmp2__length1 = _data7_->names_length1;
#line 1198 "panel.vala"
	ibus_bus_preload_engines_async (_tmp1_, _tmp2_, -1, NULL, NULL, NULL);
#line 1201 "panel.vala"
	result = FALSE;
#line 1201 "panel.vala"
	return result;
#line 5959 "panel.c"
}

static gboolean
___lambda62__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda62_ (self);
#line 1192 "panel.vala"
	return result;
#line 5969 "panel.c"
}

static void
panel_run_preload_engines (Panel* self,
                           IBusEngineDesc** engines,
                           gint engines_length1,
                           gint index)
{
	Block7Data* _data7_;
	gchar** _tmp0_;
	IBusEngineDesc* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 1179 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1179 "panel.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 1179 "panel.vala"
	_data7_->_ref_count_ = 1;
#line 1179 "panel.vala"
	_data7_->self = g_object_ref (self);
#line 1180 "panel.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 1180 "panel.vala"
	_data7_->names = _tmp0_;
#line 1180 "panel.vala"
	_data7_->names_length1 = 0;
#line 1180 "panel.vala"
	_data7_->_names_size_ = _data7_->names_length1;
#line 1182 "panel.vala"
	if (engines_length1 <= index) {
#line 1183 "panel.vala"
		block7_data_unref (_data7_);
#line 1183 "panel.vala"
		_data7_ = NULL;
#line 1183 "panel.vala"
		return;
#line 6007 "panel.c"
	}
#line 1186 "panel.vala"
	if (self->priv->m_preload_engines_id != ((guint) 0)) {
#line 1187 "panel.vala"
		g_source_remove (self->priv->m_preload_engines_id);
#line 1188 "panel.vala"
		self->priv->m_preload_engines_id = (guint) 0;
#line 6015 "panel.c"
	}
#line 1191 "panel.vala"
	_tmp1_ = engines[index];
#line 1191 "panel.vala"
	_tmp2_ = ibus_engine_desc_get_name (_tmp1_);
#line 1191 "panel.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1191 "panel.vala"
	_vala_array_add22 (&_data7_->names, &_data7_->names_length1, &_data7_->_names_size_, _tmp3_);
#line 1192 "panel.vala"
	self->priv->m_preload_engines_id = g_timeout_add_full (G_PRIORITY_DEFAULT, PANEL_PRELOAD_ENGINES_DELAY_TIME, ___lambda62__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 1179 "panel.vala"
	block7_data_unref (_data7_);
#line 1179 "panel.vala"
	_data7_ = NULL;
#line 6031 "panel.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 1207 "panel.vala"
	if (length >= 0) {
#line 6040 "panel.c"
		gchar** result;
		gssize i;
#line 1207 "panel.vala"
		result = g_new0 (gchar*, length + 1);
#line 1207 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6047 "panel.c"
			gchar* _tmp0_;
#line 1207 "panel.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1207 "panel.vala"
			result[i] = _tmp0_;
#line 6053 "panel.c"
		}
#line 1207 "panel.vala"
		return result;
#line 6057 "panel.c"
	}
#line 1207 "panel.vala"
	return NULL;
#line 6061 "panel.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 1215 "panel.vala"
	for (i = 0; i < stack_length; i++) {
#line 1215 "panel.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 1215 "panel.vala"
			return TRUE;
#line 6076 "panel.c"
		}
	}
#line 1215 "panel.vala"
	return FALSE;
#line 6081 "panel.c"
}

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1216 "panel.vala"
	if ((*length) == (*size)) {
#line 1216 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1216 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6096 "panel.c"
	}
#line 1216 "panel.vala"
	(*array)[(*length)++] = value;
#line 1216 "panel.vala"
	(*array)[*length] = NULL;
#line 6102 "panel.c"
}

static void
_vala_array_add24 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1222 "panel.vala"
	if ((*length) == (*size)) {
#line 1222 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1222 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6117 "panel.c"
	}
#line 1222 "panel.vala"
	(*array)[(*length)++] = value;
#line 1222 "panel.vala"
	(*array)[*length] = NULL;
#line 6123 "panel.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 1230 "panel.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 1230 "panel.vala"
	return _data8_;
#line 6133 "panel.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 1230 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 6143 "panel.c"
		Panel* self;
#line 1230 "panel.vala"
		self = _data8_->self;
#line 1230 "panel.vala"
		_g_object_unref0 (_data8_->dialog);
#line 1230 "panel.vala"
		_g_object_unref0 (self);
#line 1230 "panel.vala"
		g_slice_free (Block8Data, _data8_);
#line 6153 "panel.c"
	}
}

static void
___lambda61_ (Block8Data* _data8_,
              gint id)
{
	Panel* self;
	GtkMessageDialog* _tmp0_;
#line 1253 "panel.vala"
	self = _data8_->self;
#line 1254 "panel.vala"
	_tmp0_ = _data8_->dialog;
#line 1254 "panel.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 6169 "panel.c"
}

static void
____lambda61__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 1253 "panel.vala"
	___lambda61_ (self, response_id);
#line 6179 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup3 (IBusEngineDesc** self,
                  gssize length)
{
#line 1260 "panel.vala"
	if (length >= 0) {
#line 6188 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1260 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1260 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6195 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1260 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1260 "panel.vala"
			result[i] = _tmp0_;
#line 6201 "panel.c"
		}
#line 1260 "panel.vala"
		return result;
#line 6205 "panel.c"
	}
#line 1260 "panel.vala"
	return NULL;
#line 6209 "panel.c"
}

static IBusEngineDesc**
_vala_array_dup4 (IBusEngineDesc** self,
                  gssize length)
{
#line 1265 "panel.vala"
	if (length >= 0) {
#line 6218 "panel.c"
		IBusEngineDesc** result;
		gssize i;
#line 1265 "panel.vala"
		result = g_new0 (IBusEngineDesc*, length + 1);
#line 1265 "panel.vala"
		for (i = 0; i < length; i++) {
#line 6225 "panel.c"
			IBusEngineDesc* _tmp0_;
#line 1265 "panel.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1265 "panel.vala"
			result[i] = _tmp0_;
#line 6231 "panel.c"
		}
#line 1265 "panel.vala"
		return result;
#line 6235 "panel.c"
	}
#line 1265 "panel.vala"
	return NULL;
#line 6239 "panel.c"
}

static void
panel_update_engines (Panel* self,
                      gchar** unowned_engine_names,
                      gint unowned_engine_names_length1,
                      gchar** order_names,
                      gint order_names_length1)
{
	gchar** engine_names = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint engine_names_length1;
	gint _engine_names_size_;
	gboolean _tmp1_ = FALSE;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** names = NULL;
	gchar** _tmp6_;
	gint names_length1;
	gint _names_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	IBusEngineDesc** engines = NULL;
	IBusBus* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	IBusEngineDesc** _tmp20_;
	IBusEngineDesc** _tmp21_;
	gint engines_length1;
	gint _engines_size_;
	IBusEngineDesc** _tmp22_;
	gint _tmp22__length1;
	gchar** _tmp23_;
	gint _tmp23__length1;
	IBusEngineDesc** _tmp43_;
	gint _tmp43__length1;
#line 1205 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1207 "panel.vala"
	_tmp0_ = (unowned_engine_names != NULL) ? _vala_array_dup2 (unowned_engine_names, unowned_engine_names_length1) : unowned_engine_names;
#line 1207 "panel.vala"
	_tmp0__length1 = unowned_engine_names_length1;
#line 1207 "panel.vala"
	engine_names = _tmp0_;
#line 1207 "panel.vala"
	engine_names_length1 = _tmp0__length1;
#line 1207 "panel.vala"
	_engine_names_size_ = engine_names_length1;
#line 1209 "panel.vala"
	_tmp2_ = engine_names;
#line 1209 "panel.vala"
	_tmp2__length1 = engine_names_length1;
#line 1209 "panel.vala"
	if (_tmp2_ == NULL) {
#line 1209 "panel.vala"
		_tmp1_ = TRUE;
#line 6297 "panel.c"
	} else {
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 1209 "panel.vala"
		_tmp3_ = engine_names;
#line 1209 "panel.vala"
		_tmp3__length1 = engine_names_length1;
#line 1209 "panel.vala"
		_tmp1_ = _tmp3__length1 == 0;
#line 6307 "panel.c"
	}
#line 1209 "panel.vala"
	if (_tmp1_) {
#line 6311 "panel.c"
		gchar* _tmp4_;
		gchar** _tmp5_;
#line 1210 "panel.vala"
		_tmp4_ = g_strdup ("xkb:us::eng");
#line 1210 "panel.vala"
		_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 1210 "panel.vala"
		_tmp5_[0] = _tmp4_;
#line 1210 "panel.vala"
		engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1210 "panel.vala"
		engine_names = _tmp5_;
#line 1210 "panel.vala"
		engine_names_length1 = 1;
#line 1210 "panel.vala"
		_engine_names_size_ = engine_names_length1;
#line 6328 "panel.c"
	}
#line 1212 "panel.vala"
	_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 1212 "panel.vala"
	names = _tmp6_;
#line 1212 "panel.vala"
	names_length1 = 0;
#line 1212 "panel.vala"
	_names_size_ = names_length1;
#line 6338 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1214 "panel.vala"
		name_collection = order_names;
#line 1214 "panel.vala"
		name_collection_length1 = order_names_length1;
#line 1214 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 6350 "panel.c"
			gchar* _tmp7_;
			gchar* name = NULL;
#line 1214 "panel.vala"
			_tmp7_ = g_strdup (name_collection[name_it]);
#line 1214 "panel.vala"
			name = _tmp7_;
#line 6357 "panel.c"
			{
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
#line 1215 "panel.vala"
				_tmp8_ = name;
#line 1215 "panel.vala"
				_tmp9_ = engine_names;
#line 1215 "panel.vala"
				_tmp9__length1 = engine_names_length1;
#line 1215 "panel.vala"
				if (_vala_string_array_contains (_tmp9_, _tmp9__length1, _tmp8_)) {
#line 6370 "panel.c"
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 1216 "panel.vala"
					_tmp10_ = name;
#line 1216 "panel.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 1216 "panel.vala"
					_vala_array_add23 (&names, &names_length1, &_names_size_, _tmp11_);
#line 6379 "panel.c"
				}
#line 1214 "panel.vala"
				_g_free0 (name);
#line 6383 "panel.c"
			}
		}
	}
#line 1219 "panel.vala"
	_tmp12_ = engine_names;
#line 1219 "panel.vala"
	_tmp12__length1 = engine_names_length1;
#line 6391 "panel.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 1219 "panel.vala"
		name_collection = _tmp12_;
#line 1219 "panel.vala"
		name_collection_length1 = _tmp12__length1;
#line 1219 "panel.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 6403 "panel.c"
			gchar* _tmp13_;
			gchar* name = NULL;
#line 1219 "panel.vala"
			_tmp13_ = g_strdup (name_collection[name_it]);
#line 1219 "panel.vala"
			name = _tmp13_;
#line 6410 "panel.c"
			{
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 1220 "panel.vala"
				_tmp14_ = name;
#line 1220 "panel.vala"
				_tmp15_ = names;
#line 1220 "panel.vala"
				_tmp15__length1 = names_length1;
#line 1220 "panel.vala"
				if (_vala_string_array_contains (_tmp15_, _tmp15__length1, _tmp14_)) {
#line 1221 "panel.vala"
					_g_free0 (name);
#line 1221 "panel.vala"
					continue;
#line 6429 "panel.c"
				}
#line 1222 "panel.vala"
				_tmp16_ = name;
#line 1222 "panel.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 1222 "panel.vala"
				_vala_array_add24 (&names, &names_length1, &_names_size_, _tmp17_);
#line 1219 "panel.vala"
				_g_free0 (name);
#line 6439 "panel.c"
			}
		}
	}
#line 1225 "panel.vala"
	_tmp18_ = self->priv->m_bus;
#line 1225 "panel.vala"
	_tmp19_ = names;
#line 1225 "panel.vala"
	_tmp19__length1 = names_length1;
#line 1225 "panel.vala"
	_tmp21_ = _tmp20_ = ibus_bus_get_engines_by_names (_tmp18_, _tmp19_);
#line 1225 "panel.vala"
	engines = _tmp21_;
#line 1225 "panel.vala"
	engines_length1 = _vala_array_length (_tmp20_);
#line 1225 "panel.vala"
	_engines_size_ = engines_length1;
#line 1230 "panel.vala"
	_tmp22_ = engines;
#line 1230 "panel.vala"
	_tmp22__length1 = engines_length1;
#line 1230 "panel.vala"
	_tmp23_ = names;
#line 1230 "panel.vala"
	_tmp23__length1 = names_length1;
#line 1230 "panel.vala"
	if (_tmp22__length1 < _tmp23__length1) {
#line 6467 "panel.c"
		Block8Data* _data8_;
		gchar* message1 = NULL;
		IBusEngineDesc** _tmp24_;
		gint _tmp24__length1;
		gchar* message2 = NULL;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		GtkMessageDialog* _tmp40_;
		GtkMessageDialog* _tmp41_;
		GtkMessageDialog* _tmp42_;
#line 1230 "panel.vala"
		_data8_ = g_slice_new0 (Block8Data);
#line 1230 "panel.vala"
		_data8_->_ref_count_ = 1;
#line 1230 "panel.vala"
		_data8_->self = g_object_ref (self);
#line 1232 "panel.vala"
		_tmp24_ = engines;
#line 1232 "panel.vala"
		_tmp24__length1 = engines_length1;
#line 1232 "panel.vala"
		if (_tmp24__length1 == 0) {
#line 6491 "panel.c"
			gchar** fallback_names = NULL;
			gchar* _tmp25_;
			gchar** _tmp26_;
			gint fallback_names_length1;
			gint _fallback_names_size_;
			GSettings* _tmp27_;
			gchar** _tmp28_;
			gint _tmp28__length1;
			IBusBus* _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			IBusEngineDesc** _tmp31_;
			IBusEngineDesc** _tmp32_;
			gchar** _tmp33_;
			gint _tmp33__length1;
			const gchar* _tmp34_;
			gchar* _tmp35_;
#line 1233 "panel.vala"
			_tmp25_ = g_strdup ("xkb:us::eng");
#line 1233 "panel.vala"
			_tmp26_ = g_new0 (gchar*, 1 + 1);
#line 1233 "panel.vala"
			_tmp26_[0] = _tmp25_;
#line 1233 "panel.vala"
			fallback_names = _tmp26_;
#line 1233 "panel.vala"
			fallback_names_length1 = 1;
#line 1233 "panel.vala"
			_fallback_names_size_ = fallback_names_length1;
#line 1234 "panel.vala"
			_tmp27_ = self->priv->m_settings_general;
#line 1234 "panel.vala"
			_tmp28_ = fallback_names;
#line 1234 "panel.vala"
			_tmp28__length1 = fallback_names_length1;
#line 1234 "panel.vala"
			g_settings_set_strv (_tmp27_, "preload-engines", _tmp28_);
#line 1235 "panel.vala"
			_tmp29_ = self->priv->m_bus;
#line 1235 "panel.vala"
			_tmp30_ = fallback_names;
#line 1235 "panel.vala"
			_tmp30__length1 = fallback_names_length1;
#line 1235 "panel.vala"
			_tmp32_ = _tmp31_ = ibus_bus_get_engines_by_names (_tmp29_, _tmp30_);
#line 1235 "panel.vala"
			engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1235 "panel.vala"
			engines = _tmp32_;
#line 1235 "panel.vala"
			engines_length1 = _vala_array_length (_tmp31_);
#line 1235 "panel.vala"
			_engines_size_ = engines_length1;
#line 1236 "panel.vala"
			_tmp33_ = names;
#line 1236 "panel.vala"
			_tmp33__length1 = names_length1;
#line 1236 "panel.vala"
			_tmp34_ = _tmp33_[0];
#line 1236 "panel.vala"
			_tmp35_ = g_strdup_printf (_ ("Your configured input method %s does not exist " "in IBus input methods so \"US\" layout was " "configured instead of your input method."), _tmp34_);
#line 1236 "panel.vala"
			_g_free0 (message1);
#line 1236 "panel.vala"
			message1 = _tmp35_;
#line 1232 "panel.vala"
			fallback_names = (_vala_array_free (fallback_names, fallback_names_length1, (GDestroyNotify) g_free), NULL);
#line 6559 "panel.c"
		} else {
			gchar* _tmp36_;
#line 1241 "panel.vala"
			_tmp36_ = g_strdup (_ ("At least one of your configured input methods " "does not exist in IBus input methods."));
#line 1241 "panel.vala"
			_g_free0 (message1);
#line 1241 "panel.vala"
			message1 = _tmp36_;
#line 6568 "panel.c"
		}
#line 1244 "panel.vala"
		_tmp37_ = g_strdup (_ ("Please run `ibus-setup` command, open \"Input " "Method\" tab, and configure your input methods " "again."));
#line 1244 "panel.vala"
		message2 = _tmp37_;
#line 1247 "panel.vala"
		_tmp38_ = message1;
#line 1247 "panel.vala"
		_tmp39_ = message2;
#line 1247 "panel.vala"
		_tmp40_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "%s %s", _tmp38_, _tmp39_);
#line 1247 "panel.vala"
		g_object_ref_sink (_tmp40_);
#line 1247 "panel.vala"
		_data8_->dialog = _tmp40_;
#line 1253 "panel.vala"
		_tmp41_ = _data8_->dialog;
#line 1253 "panel.vala"
		g_signal_connect_data ((GtkDialog*) _tmp41_, "response", (GCallback) ____lambda61__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 1256 "panel.vala"
		_tmp42_ = _data8_->dialog;
#line 1256 "panel.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp42_);
#line 1230 "panel.vala"
		_g_free0 (message2);
#line 1230 "panel.vala"
		_g_free0 (message1);
#line 1230 "panel.vala"
		block8_data_unref (_data8_);
#line 1230 "panel.vala"
		_data8_ = NULL;
#line 6600 "panel.c"
	}
#line 1259 "panel.vala"
	_tmp43_ = self->priv->m_engines;
#line 1259 "panel.vala"
	_tmp43__length1 = self->priv->m_engines_length1;
#line 1259 "panel.vala"
	if (_tmp43__length1 == 0) {
#line 6608 "panel.c"
		IBusEngineDesc** _tmp44_;
		gint _tmp44__length1;
		IBusEngineDesc** _tmp45_;
		gint _tmp45__length1;
		IBusEngineDesc** _tmp46_;
		gint _tmp46__length1;
#line 1260 "panel.vala"
		_tmp44_ = engines;
#line 1260 "panel.vala"
		_tmp44__length1 = engines_length1;
#line 1260 "panel.vala"
		_tmp45_ = (_tmp44_ != NULL) ? _vala_array_dup3 (_tmp44_, _tmp44__length1) : _tmp44_;
#line 1260 "panel.vala"
		_tmp45__length1 = _tmp44__length1;
#line 1260 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1260 "panel.vala"
		self->priv->m_engines = _tmp45_;
#line 1260 "panel.vala"
		self->priv->m_engines_length1 = _tmp45__length1;
#line 1260 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 1261 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1262 "panel.vala"
		_tmp46_ = self->priv->m_engines;
#line 1262 "panel.vala"
		_tmp46__length1 = self->priv->m_engines_length1;
#line 1262 "panel.vala"
		panel_run_preload_engines (self, _tmp46_, (gint) _tmp46__length1, 1);
#line 6639 "panel.c"
	} else {
		IBusEngineDesc* current_engine = NULL;
		IBusEngineDesc** _tmp47_;
		gint _tmp47__length1;
		IBusEngineDesc* _tmp48_;
		IBusEngineDesc* _tmp49_;
		IBusEngineDesc** _tmp50_;
		gint _tmp50__length1;
		IBusEngineDesc** _tmp51_;
		gint _tmp51__length1;
		gint i = 0;
		IBusEngineDesc** _tmp62_;
		gint _tmp62__length1;
#line 1264 "panel.vala"
		_tmp47_ = self->priv->m_engines;
#line 1264 "panel.vala"
		_tmp47__length1 = self->priv->m_engines_length1;
#line 1264 "panel.vala"
		_tmp48_ = _tmp47_[0];
#line 1264 "panel.vala"
		_tmp49_ = _g_object_ref0 (_tmp48_);
#line 1264 "panel.vala"
		current_engine = _tmp49_;
#line 1265 "panel.vala"
		_tmp50_ = engines;
#line 1265 "panel.vala"
		_tmp50__length1 = engines_length1;
#line 1265 "panel.vala"
		_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup4 (_tmp50_, _tmp50__length1) : _tmp50_;
#line 1265 "panel.vala"
		_tmp51__length1 = _tmp50__length1;
#line 1265 "panel.vala"
		self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1265 "panel.vala"
		self->priv->m_engines = _tmp51_;
#line 1265 "panel.vala"
		self->priv->m_engines_length1 = _tmp51__length1;
#line 1265 "panel.vala"
		self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 6679 "panel.c"
		{
			gboolean _tmp52_ = FALSE;
#line 1267 "panel.vala"
			i = 0;
#line 1267 "panel.vala"
			_tmp52_ = TRUE;
#line 1267 "panel.vala"
			while (TRUE) {
#line 6688 "panel.c"
				IBusEngineDesc** _tmp54_;
				gint _tmp54__length1;
				IBusEngineDesc* _tmp55_;
				const gchar* _tmp56_;
				IBusEngineDesc** _tmp57_;
				gint _tmp57__length1;
				IBusEngineDesc* _tmp58_;
				const gchar* _tmp59_;
#line 1267 "panel.vala"
				if (!_tmp52_) {
#line 6699 "panel.c"
					gint _tmp53_;
#line 1267 "panel.vala"
					_tmp53_ = i;
#line 1267 "panel.vala"
					i = _tmp53_ + 1;
#line 6705 "panel.c"
				}
#line 1267 "panel.vala"
				_tmp52_ = FALSE;
#line 1267 "panel.vala"
				_tmp54_ = self->priv->m_engines;
#line 1267 "panel.vala"
				_tmp54__length1 = self->priv->m_engines_length1;
#line 1267 "panel.vala"
				if (!(i < _tmp54__length1)) {
#line 1267 "panel.vala"
					break;
#line 6717 "panel.c"
				}
#line 1268 "panel.vala"
				_tmp55_ = current_engine;
#line 1268 "panel.vala"
				_tmp56_ = ibus_engine_desc_get_name (_tmp55_);
#line 1268 "panel.vala"
				_tmp57_ = engines;
#line 1268 "panel.vala"
				_tmp57__length1 = engines_length1;
#line 1268 "panel.vala"
				_tmp58_ = _tmp57_[i];
#line 1268 "panel.vala"
				_tmp59_ = ibus_engine_desc_get_name (_tmp58_);
#line 1268 "panel.vala"
				if (g_strcmp0 (_tmp56_, _tmp59_) == 0) {
#line 1269 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1270 "panel.vala"
					if (i != 0) {
#line 6737 "panel.c"
						IBusEngineDesc** _tmp60_;
						gint _tmp60__length1;
#line 1271 "panel.vala"
						_tmp60_ = engines;
#line 1271 "panel.vala"
						_tmp60__length1 = engines_length1;
#line 1271 "panel.vala"
						panel_run_preload_engines (self, _tmp60_, (gint) _tmp60__length1, 0);
#line 6746 "panel.c"
					} else {
						IBusEngineDesc** _tmp61_;
						gint _tmp61__length1;
#line 1273 "panel.vala"
						_tmp61_ = engines;
#line 1273 "panel.vala"
						_tmp61__length1 = engines_length1;
#line 1273 "panel.vala"
						panel_run_preload_engines (self, _tmp61_, (gint) _tmp61__length1, 1);
#line 6756 "panel.c"
					}
#line 1275 "panel.vala"
					_g_object_unref0 (current_engine);
#line 1275 "panel.vala"
					engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1275 "panel.vala"
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1275 "panel.vala"
					engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 1275 "panel.vala"
					return;
#line 6768 "panel.c"
				}
			}
		}
#line 1278 "panel.vala"
		panel_switch_engine (self, 0, TRUE);
#line 1279 "panel.vala"
		_tmp62_ = engines;
#line 1279 "panel.vala"
		_tmp62__length1 = engines_length1;
#line 1279 "panel.vala"
		panel_run_preload_engines (self, _tmp62_, (gint) _tmp62__length1, 1);
#line 1259 "panel.vala"
		_g_object_unref0 (current_engine);
#line 6782 "panel.c"
	}
#line 1205 "panel.vala"
	engines = (_vala_array_free (engines, engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1205 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1205 "panel.vala"
	engine_names = (_vala_array_free (engine_names, engine_names_length1, (GDestroyNotify) g_free), NULL);
#line 6790 "panel.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 1294 "panel.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 6798 "panel.c"
}

static void
panel_context_render_string (Panel* self,
                             cairo_t* cr,
                             const gchar* symbol,
                             gint image_width,
                             gint image_height)
{
	gint lwidth = 0;
	gint lheight = 0;
	PangoFontDescription* desc = NULL;
	PangoFontDescription* _tmp0_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	PangoLayout* _tmp5_;
	PangoFontDescription* _tmp6_;
	PangoLayout* _tmp7_;
	PangoLayout* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	PangoLayout* _tmp15_;
#line 1284 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1284 "panel.vala"
	g_return_if_fail (cr != NULL);
#line 1284 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1288 "panel.vala"
	lwidth = 0;
#line 1289 "panel.vala"
	lheight = 0;
#line 1290 "panel.vala"
	_tmp0_ = pango_font_description_from_string ("Monospace Bold 22");
#line 1290 "panel.vala"
	desc = _tmp0_;
#line 1291 "panel.vala"
	_tmp1_ = pango_cairo_create_layout (cr);
#line 1291 "panel.vala"
	layout = _tmp1_;
#line 1293 "panel.vala"
	_tmp2_ = strlen (symbol);
#line 1293 "panel.vala"
	_tmp3_ = _tmp2_;
#line 1293 "panel.vala"
	if (_tmp3_ >= 3) {
#line 6851 "panel.c"
		PangoFontDescription* _tmp4_;
#line 1294 "panel.vala"
		_tmp4_ = pango_font_description_from_string ("Monospace Bold 18");
#line 1294 "panel.vala"
		__vala_PangoFontDescription_free0 (desc);
#line 1294 "panel.vala"
		desc = _tmp4_;
#line 6859 "panel.c"
	}
#line 1296 "panel.vala"
	_tmp5_ = layout;
#line 1296 "panel.vala"
	_tmp6_ = desc;
#line 1296 "panel.vala"
	pango_layout_set_font_description (_tmp5_, _tmp6_);
#line 1297 "panel.vala"
	_tmp7_ = layout;
#line 1297 "panel.vala"
	pango_layout_set_text (_tmp7_, symbol, -1);
#line 1298 "panel.vala"
	_tmp8_ = layout;
#line 1298 "panel.vala"
	pango_layout_get_size (_tmp8_, &_tmp9_, &_tmp10_);
#line 1298 "panel.vala"
	lwidth = _tmp9_;
#line 1298 "panel.vala"
	lheight = _tmp10_;
#line 1299 "panel.vala"
	cairo_move_to (cr, (gdouble) ((image_width - (lwidth / PANGO_SCALE)) / 2), (gdouble) ((image_height - (lheight / PANGO_SCALE)) / 2));
#line 1301 "panel.vala"
	_tmp11_ = self->priv->m_xkb_icon_rgba;
#line 1301 "panel.vala"
	_tmp12_ = self->priv->m_xkb_icon_rgba;
#line 1301 "panel.vala"
	_tmp13_ = self->priv->m_xkb_icon_rgba;
#line 1301 "panel.vala"
	_tmp14_ = self->priv->m_xkb_icon_rgba;
#line 1301 "panel.vala"
	cairo_set_source_rgba (cr, _tmp11_.red, _tmp12_.green, _tmp13_.blue, _tmp14_.alpha);
#line 1305 "panel.vala"
	_tmp15_ = layout;
#line 1305 "panel.vala"
	pango_cairo_show_layout (cr, _tmp15_);
#line 1284 "panel.vala"
	_g_object_unref0 (layout);
#line 1284 "panel.vala"
	__vala_PangoFontDescription_free0 (desc);
#line 6899 "panel.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 1313 "panel.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 6907 "panel.c"
}

static cairo_surface_t*
panel_create_cairo_image_surface_with_string (Panel* self,
                                              const gchar* symbol,
                                              gboolean cache)
{
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	gint width = 0;
	cairo_surface_t* _tmp7_;
	gint height = 0;
	cairo_surface_t* _tmp8_;
	gint stride = 0;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_surface_t* _tmp15_;
	cairo_surface_t* result;
#line 1308 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1310 "panel.vala"
	image = NULL;
#line 1312 "panel.vala"
	if (cache) {
#line 6941 "panel.c"
		GHashTable* _tmp0_;
		gconstpointer _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
#line 1313 "panel.vala"
		_tmp0_ = self->priv->m_xkb_icon_image;
#line 1313 "panel.vala"
		_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1313 "panel.vala"
		_tmp2_ = _cairo_surface_reference0 ((cairo_surface_t*) _tmp1_);
#line 1313 "panel.vala"
		_cairo_surface_destroy0 (image);
#line 1313 "panel.vala"
		image = _tmp2_;
#line 1315 "panel.vala"
		_tmp3_ = image;
#line 1315 "panel.vala"
		if (_tmp3_ != NULL) {
#line 1316 "panel.vala"
			result = image;
#line 1316 "panel.vala"
			return result;
#line 6964 "panel.c"
		}
	}
#line 1319 "panel.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 48, 48);
#line 1319 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1319 "panel.vala"
	image = _tmp4_;
#line 1320 "panel.vala"
	_tmp5_ = image;
#line 1320 "panel.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 1320 "panel.vala"
	cr = _tmp6_;
#line 1321 "panel.vala"
	_tmp7_ = image;
#line 1321 "panel.vala"
	width = cairo_image_surface_get_width (_tmp7_);
#line 1322 "panel.vala"
	_tmp8_ = image;
#line 1322 "panel.vala"
	height = cairo_image_surface_get_height (_tmp8_);
#line 1323 "panel.vala"
	_tmp9_ = image;
#line 1323 "panel.vala"
	stride = cairo_image_surface_get_stride (_tmp9_);
#line 1325 "panel.vala"
	_tmp10_ = cr;
#line 1325 "panel.vala"
	cairo_set_source_rgba (_tmp10_, 0.0, 0.0, 0.0, 0.0);
#line 1326 "panel.vala"
	_tmp11_ = cr;
#line 1326 "panel.vala"
	cairo_set_operator (_tmp11_, CAIRO_OPERATOR_SOURCE);
#line 1327 "panel.vala"
	_tmp12_ = cr;
#line 1327 "panel.vala"
	cairo_paint (_tmp12_);
#line 1328 "panel.vala"
	_tmp13_ = cr;
#line 1328 "panel.vala"
	cairo_set_operator (_tmp13_, CAIRO_OPERATOR_OVER);
#line 1329 "panel.vala"
	_tmp14_ = cr;
#line 1329 "panel.vala"
	panel_context_render_string (self, _tmp14_, symbol, width, height);
#line 1330 "panel.vala"
	_tmp15_ = image;
#line 1330 "panel.vala"
	cairo_surface_flush (_tmp15_);
#line 1332 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 1333 "panel.vala"
		if (G_BYTE_ORDER == G_LITTLE_ENDIAN) {
#line 7019 "panel.c"
			guint* data = NULL;
			cairo_surface_t* _tmp16_;
			guchar* _tmp17_;
			gint data_length1;
			gint _data_size_;
			gint length = 0;
#line 1334 "panel.vala"
			_tmp16_ = image;
#line 1334 "panel.vala"
			_tmp17_ = cairo_image_surface_get_data (_tmp16_);
#line 1334 "panel.vala"
			data = (guint*) _tmp17_;
#line 1334 "panel.vala"
			data_length1 = (-1 * sizeof (guchar)) / sizeof (guint);
#line 1334 "panel.vala"
			_data_size_ = data_length1;
#line 1335 "panel.vala"
			length = (stride * height) / ((gint) sizeof (guint));
#line 7038 "panel.c"
			{
				gint i = 0;
#line 1336 "panel.vala"
				i = 0;
#line 7043 "panel.c"
				{
					gboolean _tmp18_ = FALSE;
#line 1336 "panel.vala"
					_tmp18_ = TRUE;
#line 1336 "panel.vala"
					while (TRUE) {
#line 7050 "panel.c"
						guint* _tmp20_;
						gint _tmp20__length1;
						guint* _tmp21_;
						gint _tmp21__length1;
						guint _tmp22_;
#line 1336 "panel.vala"
						if (!_tmp18_) {
#line 7058 "panel.c"
							gint _tmp19_;
#line 1336 "panel.vala"
							_tmp19_ = i;
#line 1336 "panel.vala"
							i = _tmp19_ + 1;
#line 7064 "panel.c"
						}
#line 1336 "panel.vala"
						_tmp18_ = FALSE;
#line 1336 "panel.vala"
						if (!(i < length)) {
#line 1336 "panel.vala"
							break;
#line 7072 "panel.c"
						}
#line 1337 "panel.vala"
						_tmp20_ = data;
#line 1337 "panel.vala"
						_tmp20__length1 = data_length1;
#line 1337 "panel.vala"
						_tmp21_ = data;
#line 1337 "panel.vala"
						_tmp21__length1 = data_length1;
#line 1337 "panel.vala"
						_tmp22_ = _tmp21_[i];
#line 1337 "panel.vala"
						_tmp20_[i] = GUINT_TO_BE (_tmp22_);
#line 7086 "panel.c"
					}
				}
			}
		}
	}
#line 1341 "panel.vala"
	if (cache) {
#line 7094 "panel.c"
		GHashTable* _tmp23_;
		gchar* _tmp24_;
		cairo_surface_t* _tmp25_;
		cairo_surface_t* _tmp26_;
#line 1342 "panel.vala"
		_tmp23_ = self->priv->m_xkb_icon_image;
#line 1342 "panel.vala"
		_tmp24_ = g_strdup (symbol);
#line 1342 "panel.vala"
		_tmp25_ = image;
#line 1342 "panel.vala"
		_tmp26_ = _cairo_surface_reference0 (_tmp25_);
#line 1342 "panel.vala"
		g_hash_table_insert (_tmp23_, _tmp24_, _tmp26_);
#line 7109 "panel.c"
	}
#line 1344 "panel.vala"
	result = image;
#line 1344 "panel.vala"
	_cairo_destroy0 (cr);
#line 1344 "panel.vala"
	return result;
#line 7117 "panel.c"
}

static GdkPixbuf*
panel_create_icon_pixbuf_with_string (Panel* self,
                                      const gchar* symbol)
{
	GdkPixbuf* pixbuf = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	cairo_surface_t* image = NULL;
	cairo_surface_t* _tmp4_;
	gint width = 0;
	cairo_surface_t* _tmp5_;
	gint height = 0;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	GdkPixbuf* _tmp8_;
	GHashTable* _tmp9_;
	gchar* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* result;
#line 1347 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1347 "panel.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1348 "panel.vala"
	_tmp0_ = self->priv->m_xkb_icon_pixbufs;
#line 1348 "panel.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, symbol);
#line 1348 "panel.vala"
	_tmp2_ = _g_object_ref0 ((GdkPixbuf*) _tmp1_);
#line 1348 "panel.vala"
	pixbuf = _tmp2_;
#line 1350 "panel.vala"
	_tmp3_ = pixbuf;
#line 1350 "panel.vala"
	if (_tmp3_ != NULL) {
#line 1351 "panel.vala"
		result = pixbuf;
#line 1351 "panel.vala"
		return result;
#line 7162 "panel.c"
	}
#line 1353 "panel.vala"
	_tmp4_ = panel_create_cairo_image_surface_with_string (self, symbol, FALSE);
#line 1353 "panel.vala"
	image = _tmp4_;
#line 1354 "panel.vala"
	_tmp5_ = image;
#line 1354 "panel.vala"
	width = cairo_image_surface_get_width (_tmp5_);
#line 1355 "panel.vala"
	_tmp6_ = image;
#line 1355 "panel.vala"
	height = cairo_image_surface_get_height (_tmp6_);
#line 1356 "panel.vala"
	_tmp7_ = image;
#line 1356 "panel.vala"
	_tmp8_ = gdk_pixbuf_get_from_surface (_tmp7_, 0, 0, width, height);
#line 1356 "panel.vala"
	_g_object_unref0 (pixbuf);
#line 1356 "panel.vala"
	pixbuf = _tmp8_;
#line 1357 "panel.vala"
	_tmp9_ = self->priv->m_xkb_icon_pixbufs;
#line 1357 "panel.vala"
	_tmp10_ = g_strdup (symbol);
#line 1357 "panel.vala"
	_tmp11_ = pixbuf;
#line 1357 "panel.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1357 "panel.vala"
	g_hash_table_insert (_tmp9_, _tmp10_, _tmp12_);
#line 1358 "panel.vala"
	result = pixbuf;
#line 1358 "panel.vala"
	_cairo_surface_destroy0 (image);
#line 1358 "panel.vala"
	return result;
#line 7200 "panel.c"
}

static void
__lambda88_ (Panel* self,
             GPid pid,
             gint state)
{
#line 1382 "panel.vala"
	if (pid != self->priv->m_setup_pid) {
#line 1383 "panel.vala"
		return;
#line 7212 "panel.c"
	}
#line 1384 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 1385 "panel.vala"
	g_spawn_close_pid (pid);
#line 7218 "panel.c"
}

static void
___lambda88__gchild_watch_func (GPid pid,
                                gint wait_status,
                                gpointer self)
{
#line 1381 "panel.vala"
	__lambda88_ ((Panel*) self, pid, wait_status);
#line 7228 "panel.c"
}

static void
panel_show_setup_dialog (Panel* self)
{
	gchar* binary = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1361 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1362 "panel.vala"
	if (self->priv->m_setup_pid != ((GPid) 0)) {
#line 1363 "panel.vala"
		if (kill ((pid_t) self->priv->m_setup_pid, (gint) SIGUSR1) == 0) {
#line 1364 "panel.vala"
			return;
#line 7245 "panel.c"
		}
#line 1365 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 7249 "panel.c"
	}
#line 1368 "panel.vala"
	_tmp0_ = g_build_filename (BINDIR, "ibus-setup", NULL);
#line 1368 "panel.vala"
	binary = _tmp0_;
#line 7255 "panel.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		GPid _tmp6_ = 0;
#line 1370 "panel.vala"
		_tmp1_ = binary;
#line 1370 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1370 "panel.vala"
		_tmp3_ = g_strdup ("ibus-setup");
#line 1370 "panel.vala"
		_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 1370 "panel.vala"
		_tmp4_[0] = _tmp2_;
#line 1370 "panel.vala"
		_tmp4_[1] = _tmp3_;
#line 1370 "panel.vala"
		_tmp5_ = _tmp4_;
#line 1370 "panel.vala"
		_tmp5__length1 = 2;
#line 1370 "panel.vala"
		g_spawn_async (NULL, _tmp5_, NULL, G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp6_, &_inner_error0_);
#line 1370 "panel.vala"
		self->priv->m_setup_pid = _tmp6_;
#line 1370 "panel.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 1370 "panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1370 "panel.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 7290 "panel.c"
				goto __catch0_g_spawn_error;
			}
#line 1370 "panel.vala"
			_g_free0 (binary);
#line 1370 "panel.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1370 "panel.vala"
			g_clear_error (&_inner_error0_);
#line 1370 "panel.vala"
			return;
#line 7301 "panel.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1369 "panel.vala"
		e = _inner_error0_;
#line 1369 "panel.vala"
		_inner_error0_ = NULL;
#line 1377 "panel.vala"
		_tmp7_ = binary;
#line 1377 "panel.vala"
		_tmp8_ = e;
#line 1377 "panel.vala"
		_tmp9_ = _tmp8_->message;
#line 1377 "panel.vala"
		g_warning ("panel.vala:1377: Execute %s failed! %s", _tmp7_, _tmp9_);
#line 1378 "panel.vala"
		self->priv->m_setup_pid = (GPid) 0;
#line 1369 "panel.vala"
		_g_error_free0 (e);
#line 7327 "panel.c"
	}
	__finally0:
#line 1369 "panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1369 "panel.vala"
		_g_free0 (binary);
#line 1369 "panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1369 "panel.vala"
		g_clear_error (&_inner_error0_);
#line 1369 "panel.vala"
		return;
#line 7340 "panel.c"
	}
#line 1381 "panel.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->m_setup_pid, ___lambda88__gchild_watch_func, g_object_ref (self), g_object_unref);
#line 1361 "panel.vala"
	_g_free0 (binary);
#line 7346 "panel.c"
}

static void
panel_show_about_dialog (Panel* self)
{
	GtkAboutDialog* _tmp0_;
	GtkAboutDialog* _tmp21_;
#line 1389 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1390 "panel.vala"
	_tmp0_ = self->priv->m_about_dialog;
#line 1390 "panel.vala"
	if (_tmp0_ == NULL) {
#line 7360 "panel.c"
		GtkAboutDialog* _tmp1_;
		GtkAboutDialog* _tmp2_;
		GtkAboutDialog* _tmp3_;
		gchar* copyright = NULL;
		gchar* _tmp4_;
		GtkAboutDialog* _tmp5_;
		const gchar* _tmp6_;
		GtkAboutDialog* _tmp7_;
		GtkAboutDialog* _tmp8_;
		GtkAboutDialog* _tmp9_;
		GtkAboutDialog* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GtkAboutDialog* _tmp14_;
		gchar* _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		GtkAboutDialog* _tmp18_;
		GtkAboutDialog* _tmp19_;
		GtkAboutDialog* _tmp20_;
#line 1391 "panel.vala"
		_tmp1_ = (GtkAboutDialog*) gtk_about_dialog_new ();
#line 1391 "panel.vala"
		g_object_ref_sink (_tmp1_);
#line 1391 "panel.vala"
		_g_object_unref0 (self->priv->m_about_dialog);
#line 1391 "panel.vala"
		self->priv->m_about_dialog = _tmp1_;
#line 1392 "panel.vala"
		_tmp2_ = self->priv->m_about_dialog;
#line 1392 "panel.vala"
		gtk_about_dialog_set_program_name (_tmp2_, "IBus");
#line 1393 "panel.vala"
		_tmp3_ = self->priv->m_about_dialog;
#line 1393 "panel.vala"
		gtk_about_dialog_set_version (_tmp3_, PACKAGE_VERSION);
#line 1395 "panel.vala"
		_tmp4_ = g_strdup ("Copyright © 2007-2015 Peng Huang\n" "Copyright © 2015-2022 Takao Fujiwara\n" "Copyright © 2007-2015 Red Hat, Inc.\n");
#line 1395 "panel.vala"
		copyright = _tmp4_;
#line 1400 "panel.vala"
		_tmp5_ = self->priv->m_about_dialog;
#line 1400 "panel.vala"
		_tmp6_ = copyright;
#line 1400 "panel.vala"
		gtk_about_dialog_set_copyright (_tmp5_, _tmp6_);
#line 1401 "panel.vala"
		_tmp7_ = self->priv->m_about_dialog;
#line 1401 "panel.vala"
		gtk_about_dialog_set_license (_tmp7_, "LGPL");
#line 1402 "panel.vala"
		_tmp8_ = self->priv->m_about_dialog;
#line 1402 "panel.vala"
		gtk_about_dialog_set_comments (_tmp8_, _ ("IBus is an intelligent input bus for Linux/Unix."));
#line 1403 "panel.vala"
		_tmp9_ = self->priv->m_about_dialog;
#line 1403 "panel.vala"
		gtk_about_dialog_set_website (_tmp9_, "https://github.com/ibus/ibus/wiki");
#line 1404 "panel.vala"
		_tmp10_ = self->priv->m_about_dialog;
#line 1404 "panel.vala"
		_tmp11_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1404 "panel.vala"
		_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 1404 "panel.vala"
		_tmp12_[0] = _tmp11_;
#line 1404 "panel.vala"
		_tmp13_ = _tmp12_;
#line 1404 "panel.vala"
		_tmp13__length1 = 1;
#line 1404 "panel.vala"
		gtk_about_dialog_set_authors (_tmp10_, _tmp13_);
#line 1404 "panel.vala"
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 1405 "panel.vala"
		_tmp14_ = self->priv->m_about_dialog;
#line 1405 "panel.vala"
		_tmp15_ = g_strdup ("Peng Huang <shawn.p.huang@gmail.com>");
#line 1405 "panel.vala"
		_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 1405 "panel.vala"
		_tmp16_[0] = _tmp15_;
#line 1405 "panel.vala"
		_tmp17_ = _tmp16_;
#line 1405 "panel.vala"
		_tmp17__length1 = 1;
#line 1405 "panel.vala"
		gtk_about_dialog_set_documenters (_tmp14_, _tmp17_);
#line 1405 "panel.vala"
		_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 1406 "panel.vala"
		_tmp18_ = self->priv->m_about_dialog;
#line 1406 "panel.vala"
		gtk_about_dialog_set_translator_credits (_tmp18_, _ ("translator-credits"));
#line 1407 "panel.vala"
		_tmp19_ = self->priv->m_about_dialog;
#line 1407 "panel.vala"
		gtk_about_dialog_set_logo_icon_name (_tmp19_, "ibus");
#line 1408 "panel.vala"
		_tmp20_ = self->priv->m_about_dialog;
#line 1408 "panel.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp20_, "ibus");
#line 1390 "panel.vala"
		_g_free0 (copyright);
#line 7468 "panel.c"
	}
#line 1411 "panel.vala"
	_tmp21_ = self->priv->m_about_dialog;
#line 1411 "panel.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) _tmp21_)) {
#line 7474 "panel.c"
		GtkAboutDialog* _tmp22_;
		GtkAboutDialog* _tmp23_;
#line 1412 "panel.vala"
		_tmp22_ = self->priv->m_about_dialog;
#line 1412 "panel.vala"
		gtk_dialog_run ((GtkDialog*) _tmp22_);
#line 1413 "panel.vala"
		_tmp23_ = self->priv->m_about_dialog;
#line 1413 "panel.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 7485 "panel.c"
	} else {
		GtkAboutDialog* _tmp24_;
#line 1415 "panel.vala"
		_tmp24_ = self->priv->m_about_dialog;
#line 1415 "panel.vala"
		gtk_window_present ((GtkWindow*) _tmp24_);
#line 7492 "panel.c"
	}
}

static void
__lambda87_ (Panel* self,
             GtkMenuItem* i)
{
#line 1435 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1435 "panel.vala"
	panel_show_setup_dialog (self);
#line 7504 "panel.c"
}

static void
___lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1435 "panel.vala"
	__lambda87_ ((Panel*) self, _sender);
#line 7513 "panel.c"
}

static void
__lambda89_ (Panel* self,
             GtkMenuItem* i)
{
	IBusExtensionEvent* event = NULL;
	IBusExtensionEvent* _tmp0_;
	IBusExtensionEvent* _tmp1_;
#line 1440 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1441 "panel.vala"
	_tmp0_ = ibus_extension_event_new ("name", "emoji", "is-enabled", TRUE, "params", "category-list", NULL);
#line 1441 "panel.vala"
	g_object_ref_sink (_tmp0_);
#line 1441 "panel.vala"
	event = _tmp0_;
#line 1449 "panel.vala"
	_tmp1_ = _g_object_ref0 (event);
#line 1449 "panel.vala"
	ibus_panel_service_panel_extension ((IBusPanelService*) self, _tmp1_);
#line 1440 "panel.vala"
	_g_object_unref0 (event);
#line 7537 "panel.c"
}

static void
___lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1440 "panel.vala"
	__lambda89_ ((Panel*) self, _sender);
#line 7546 "panel.c"
}

static void
__lambda90_ (Panel* self,
             GtkMenuItem* i)
{
#line 1455 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1455 "panel.vala"
	panel_show_about_dialog (self);
#line 7557 "panel.c"
}

static void
___lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1455 "panel.vala"
	__lambda90_ ((Panel*) self, _sender);
#line 7566 "panel.c"
}

static void
__lambda91_ (Panel* self,
             GtkMenuItem* i)
{
	IBusBus* _tmp0_;
#line 1461 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1461 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1461 "panel.vala"
	ibus_bus_exit (_tmp0_, TRUE);
#line 7580 "panel.c"
}

static void
___lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1461 "panel.vala"
	__lambda91_ ((Panel*) self, _sender);
#line 7589 "panel.c"
}

static void
__lambda92_ (Panel* self,
             GtkMenuItem* i)
{
	IBusBus* _tmp0_;
#line 1465 "panel.vala"
	g_return_if_fail (i != NULL);
#line 1465 "panel.vala"
	_tmp0_ = self->priv->m_bus;
#line 1465 "panel.vala"
	ibus_bus_exit (_tmp0_, FALSE);
#line 7603 "panel.c"
}

static void
___lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 1465 "panel.vala"
	__lambda92_ ((Panel*) self, _sender);
#line 7612 "panel.c"
}

static GtkMenu*
panel_create_context_menu (Panel* self,
                           gboolean use_x11)
{
	GtkMenu* _tmp0_;
	GdkDisplay* display_backup = NULL;
	gboolean _tmp3_ = FALSE;
	GtkMenuItem* item = NULL;
	GtkMenu* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenu* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenu* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenu* _tmp22_;
	GtkSeparatorMenuItem* _tmp23_;
	GtkSeparatorMenuItem* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenu* _tmp27_;
	GtkMenuItem* _tmp28_;
	GtkMenuItem* _tmp29_;
	GtkMenuItem* _tmp30_;
	GtkMenu* _tmp31_;
	GtkMenuItem* _tmp32_;
	GtkMenu* _tmp33_;
	GdkDisplay* _tmp34_;
	GtkMenu* _tmp37_;
	GtkMenu* _tmp38_;
	GtkMenu* result;
#line 1419 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1420 "panel.vala"
	_tmp0_ = self->priv->m_sys_menu;
#line 1420 "panel.vala"
	if (_tmp0_ != NULL) {
#line 7658 "panel.c"
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
#line 1421 "panel.vala"
		_tmp1_ = self->priv->m_sys_menu;
#line 1421 "panel.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1421 "panel.vala"
		result = _tmp2_;
#line 1421 "panel.vala"
		return result;
#line 7669 "panel.c"
	}
#line 1423 "panel.vala"
	display_backup = NULL;
#line 1424 "panel.vala"
	if (use_x11) {
#line 1424 "panel.vala"
		_tmp3_ = !binding_common_default_is_xdisplay ();
#line 7677 "panel.c"
	} else {
#line 1424 "panel.vala"
		_tmp3_ = FALSE;
#line 7681 "panel.c"
	}
#line 1424 "panel.vala"
	if (_tmp3_) {
#line 7685 "panel.c"
		GdkDisplay* _tmp4_;
		GdkDisplay* _tmp5_;
		GdkDisplayManager* _tmp6_;
		GdkX11Display* _tmp7_;
		GdkDisplay* _tmp8_;
#line 1425 "panel.vala"
		_tmp4_ = gdk_display_get_default ();
#line 1425 "panel.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1425 "panel.vala"
		_g_object_unref0 (display_backup);
#line 1425 "panel.vala"
		display_backup = _tmp5_;
#line 1426 "panel.vala"
		_tmp6_ = gdk_display_manager_get ();
#line 1426 "panel.vala"
		_tmp7_ = binding_common_get_xdisplay ();
#line 1426 "panel.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gdk_display_get_type (), GdkDisplay);
#line 1426 "panel.vala"
		gdk_display_manager_set_default_display (_tmp6_, _tmp8_);
#line 1426 "panel.vala"
		_g_object_unref0 (_tmp8_);
#line 7709 "panel.c"
	}
#line 1432 "panel.vala"
	_tmp9_ = (GtkMenu*) gtk_menu_new ();
#line 1432 "panel.vala"
	g_object_ref_sink (_tmp9_);
#line 1432 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 1432 "panel.vala"
	self->priv->m_sys_menu = _tmp9_;
#line 1434 "panel.vala"
	_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Preferences"));
#line 1434 "panel.vala"
	g_object_ref_sink (_tmp10_);
#line 1434 "panel.vala"
	_g_object_unref0 (item);
#line 1434 "panel.vala"
	item = _tmp10_;
#line 1435 "panel.vala"
	_tmp11_ = item;
#line 1435 "panel.vala"
	g_signal_connect_object (_tmp11_, "activate", (GCallback) ___lambda87__gtk_menu_item_activate, self, 0);
#line 1436 "panel.vala"
	_tmp12_ = self->priv->m_sys_menu;
#line 1436 "panel.vala"
	_tmp13_ = item;
#line 1436 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp12_, _tmp13_);
#line 1439 "panel.vala"
	_tmp14_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Emoji Choice"));
#line 1439 "panel.vala"
	g_object_ref_sink (_tmp14_);
#line 1439 "panel.vala"
	_g_object_unref0 (item);
#line 1439 "panel.vala"
	item = _tmp14_;
#line 1440 "panel.vala"
	_tmp15_ = item;
#line 1440 "panel.vala"
	g_signal_connect_object (_tmp15_, "activate", (GCallback) ___lambda89__gtk_menu_item_activate, self, 0);
#line 1451 "panel.vala"
	_tmp16_ = self->priv->m_sys_menu;
#line 1451 "panel.vala"
	_tmp17_ = item;
#line 1451 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp16_, _tmp17_);
#line 1454 "panel.vala"
	_tmp18_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("About"));
#line 1454 "panel.vala"
	g_object_ref_sink (_tmp18_);
#line 1454 "panel.vala"
	_g_object_unref0 (item);
#line 1454 "panel.vala"
	item = _tmp18_;
#line 1455 "panel.vala"
	_tmp19_ = item;
#line 1455 "panel.vala"
	g_signal_connect_object (_tmp19_, "activate", (GCallback) ___lambda90__gtk_menu_item_activate, self, 0);
#line 1456 "panel.vala"
	_tmp20_ = self->priv->m_sys_menu;
#line 1456 "panel.vala"
	_tmp21_ = item;
#line 1456 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp20_, _tmp21_);
#line 1458 "panel.vala"
	_tmp22_ = self->priv->m_sys_menu;
#line 1458 "panel.vala"
	_tmp23_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1458 "panel.vala"
	g_object_ref_sink (_tmp23_);
#line 1458 "panel.vala"
	_tmp24_ = _tmp23_;
#line 1458 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, (GtkMenuItem*) _tmp24_);
#line 1458 "panel.vala"
	_g_object_unref0 (_tmp24_);
#line 1460 "panel.vala"
	_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restart"));
#line 1460 "panel.vala"
	g_object_ref_sink (_tmp25_);
#line 1460 "panel.vala"
	_g_object_unref0 (item);
#line 1460 "panel.vala"
	item = _tmp25_;
#line 1461 "panel.vala"
	_tmp26_ = item;
#line 1461 "panel.vala"
	g_signal_connect_object (_tmp26_, "activate", (GCallback) ___lambda91__gtk_menu_item_activate, self, 0);
#line 1462 "panel.vala"
	_tmp27_ = self->priv->m_sys_menu;
#line 1462 "panel.vala"
	_tmp28_ = item;
#line 1462 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp27_, _tmp28_);
#line 1464 "panel.vala"
	_tmp29_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Quit"));
#line 1464 "panel.vala"
	g_object_ref_sink (_tmp29_);
#line 1464 "panel.vala"
	_g_object_unref0 (item);
#line 1464 "panel.vala"
	item = _tmp29_;
#line 1465 "panel.vala"
	_tmp30_ = item;
#line 1465 "panel.vala"
	g_signal_connect_object (_tmp30_, "activate", (GCallback) ___lambda92__gtk_menu_item_activate, self, 0);
#line 1466 "panel.vala"
	_tmp31_ = self->priv->m_sys_menu;
#line 1466 "panel.vala"
	_tmp32_ = item;
#line 1466 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp31_, _tmp32_);
#line 1468 "panel.vala"
	_tmp33_ = self->priv->m_sys_menu;
#line 1468 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp33_);
#line 1470 "panel.vala"
	_tmp34_ = display_backup;
#line 1470 "panel.vala"
	if (_tmp34_ != NULL) {
#line 7829 "panel.c"
		GdkDisplayManager* _tmp35_;
		GdkDisplay* _tmp36_;
#line 1471 "panel.vala"
		_tmp35_ = gdk_display_manager_get ();
#line 1471 "panel.vala"
		_tmp36_ = display_backup;
#line 1471 "panel.vala"
		gdk_display_manager_set_default_display (_tmp35_, _tmp36_);
#line 7838 "panel.c"
	}
#line 1473 "panel.vala"
	_tmp37_ = self->priv->m_sys_menu;
#line 1473 "panel.vala"
	_tmp38_ = _g_object_ref0 (_tmp37_);
#line 1473 "panel.vala"
	result = _tmp38_;
#line 1473 "panel.vala"
	_g_object_unref0 (item);
#line 1473 "panel.vala"
	_g_object_unref0 (display_backup);
#line 1473 "panel.vala"
	return result;
#line 7852 "panel.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 1491 "panel.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 1491 "panel.vala"
	return _data9_;
#line 7862 "panel.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 1491 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 7872 "panel.c"
		Panel* self;
#line 1491 "panel.vala"
		self = _data9_->self;
#line 1491 "panel.vala"
		_g_object_unref0 (_data9_->e);
#line 1491 "panel.vala"
		_g_object_unref0 (self);
#line 1491 "panel.vala"
		g_slice_free (Block9Data, _data9_);
#line 7882 "panel.c"
	}
}

static void
____lambda93_ (Block9Data* _data9_,
               GtkMenuItem* item)
{
	Panel* self;
#line 1501 "panel.vala"
	self = _data9_->self;
#line 1501 "panel.vala"
	g_return_if_fail (item != NULL);
#line 7895 "panel.c"
	{
		gint i = 0;
#line 1502 "panel.vala"
		i = 0;
#line 7900 "panel.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1502 "panel.vala"
			_tmp0_ = TRUE;
#line 1502 "panel.vala"
			while (TRUE) {
#line 7907 "panel.c"
				IBusEngineDesc** _tmp2_;
				gint _tmp2__length1;
				IBusEngineDesc* _tmp3_;
				IBusEngineDesc** _tmp4_;
				gint _tmp4__length1;
				IBusEngineDesc* _tmp5_;
#line 1502 "panel.vala"
				if (!_tmp0_) {
#line 7916 "panel.c"
					gint _tmp1_;
#line 1502 "panel.vala"
					_tmp1_ = i;
#line 1502 "panel.vala"
					i = _tmp1_ + 1;
#line 7922 "panel.c"
				}
#line 1502 "panel.vala"
				_tmp0_ = FALSE;
#line 1502 "panel.vala"
				_tmp2_ = self->priv->m_engines;
#line 1502 "panel.vala"
				_tmp2__length1 = self->priv->m_engines_length1;
#line 1502 "panel.vala"
				if (!(i < _tmp2__length1)) {
#line 1502 "panel.vala"
					break;
#line 7934 "panel.c"
				}
#line 1503 "panel.vala"
				_tmp3_ = _data9_->e;
#line 1503 "panel.vala"
				_tmp4_ = self->priv->m_engines;
#line 1503 "panel.vala"
				_tmp4__length1 = self->priv->m_engines_length1;
#line 1503 "panel.vala"
				_tmp5_ = _tmp4_[i];
#line 1503 "panel.vala"
				if (_tmp3_ == _tmp5_) {
#line 1504 "panel.vala"
					panel_switch_engine (self, i, FALSE);
#line 1505 "panel.vala"
					break;
#line 7950 "panel.c"
				}
			}
		}
	}
}

static void
_____lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 1501 "panel.vala"
	____lambda93_ (self, _sender);
#line 7963 "panel.c"
}

static GtkMenu*
panel_create_activate_menu (Panel* self,
                            gboolean use_x11)
{
	GdkDisplay* display_backup = NULL;
	gboolean _tmp0_ = FALSE;
	GtkMenu* _tmp6_;
	PropertyManager* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenu* _tmp9_;
	GtkSeparatorMenuItem* _tmp10_;
	GtkSeparatorMenuItem* _tmp11_;
	IBusEngineDesc** _tmp12_;
	gint _tmp12__length1;
	GtkMenu* _tmp39_;
	GtkMenu* _tmp40_;
	GdkDisplay* _tmp41_;
	GtkMenu* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenu* result;
#line 1476 "panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "panel.vala"
	display_backup = NULL;
#line 1478 "panel.vala"
	if (use_x11) {
#line 1478 "panel.vala"
		_tmp0_ = !binding_common_default_is_xdisplay ();
#line 7994 "panel.c"
	} else {
#line 1478 "panel.vala"
		_tmp0_ = FALSE;
#line 7998 "panel.c"
	}
#line 1478 "panel.vala"
	if (_tmp0_) {
#line 8002 "panel.c"
		GdkDisplay* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkDisplayManager* _tmp3_;
		GdkX11Display* _tmp4_;
		GdkDisplay* _tmp5_;
#line 1479 "panel.vala"
		_tmp1_ = gdk_display_get_default ();
#line 1479 "panel.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1479 "panel.vala"
		_g_object_unref0 (display_backup);
#line 1479 "panel.vala"
		display_backup = _tmp2_;
#line 1480 "panel.vala"
		_tmp3_ = gdk_display_manager_get ();
#line 1480 "panel.vala"
		_tmp4_ = binding_common_get_xdisplay ();
#line 1480 "panel.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gdk_display_get_type (), GdkDisplay);
#line 1480 "panel.vala"
		gdk_display_manager_set_default_display (_tmp3_, _tmp5_);
#line 1480 "panel.vala"
		_g_object_unref0 (_tmp5_);
#line 8026 "panel.c"
	}
#line 1483 "panel.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 1483 "panel.vala"
	g_object_ref_sink (_tmp6_);
#line 1483 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 1483 "panel.vala"
	self->priv->m_ime_menu = _tmp6_;
#line 1486 "panel.vala"
	_tmp7_ = self->priv->m_property_manager;
#line 1486 "panel.vala"
	_tmp8_ = self->priv->m_ime_menu;
#line 1486 "panel.vala"
	property_manager_create_menu_items (_tmp7_, _tmp8_);
#line 1488 "panel.vala"
	_tmp9_ = self->priv->m_ime_menu;
#line 1488 "panel.vala"
	_tmp10_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1488 "panel.vala"
	g_object_ref_sink (_tmp10_);
#line 1488 "panel.vala"
	_tmp11_ = _tmp10_;
#line 1488 "panel.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp9_, (GtkMenuItem*) _tmp11_);
#line 1488 "panel.vala"
	_g_object_unref0 (_tmp11_);
#line 1491 "panel.vala"
	_tmp12_ = self->priv->m_engines;
#line 1491 "panel.vala"
	_tmp12__length1 = self->priv->m_engines_length1;
#line 8058 "panel.c"
	{
		IBusEngineDesc** engine_collection = NULL;
		gint engine_collection_length1 = 0;
		gint _engine_collection_size_ = 0;
		gint engine_it = 0;
#line 1491 "panel.vala"
		engine_collection = _tmp12_;
#line 1491 "panel.vala"
		engine_collection_length1 = _tmp12__length1;
#line 1491 "panel.vala"
		for (engine_it = 0; engine_it < engine_collection_length1; engine_it = engine_it + 1) {
#line 8070 "panel.c"
			IBusEngineDesc* _tmp13_;
			IBusEngineDesc* engine = NULL;
#line 1491 "panel.vala"
			_tmp13_ = _g_object_ref0 (engine_collection[engine_it]);
#line 1491 "panel.vala"
			engine = _tmp13_;
#line 8077 "panel.c"
			{
				Block9Data* _data9_;
				gchar* language = NULL;
				IBusEngineDesc* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* longname = NULL;
				IBusEngineDesc* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* textdomain = NULL;
				IBusEngineDesc* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* transname = NULL;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				GtkMenuItem* item = NULL;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				const gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				GtkMenuItem* _tmp32_;
				GtkMenuItem* _tmp33_;
				IBusEngineDesc* _tmp34_;
				IBusEngineDesc* _tmp35_;
				GtkMenuItem* _tmp36_;
				GtkMenu* _tmp37_;
				GtkMenuItem* _tmp38_;
#line 1491 "panel.vala"
				_data9_ = g_slice_new0 (Block9Data);
#line 1491 "panel.vala"
				_data9_->_ref_count_ = 1;
#line 1491 "panel.vala"
				_data9_->self = g_object_ref (self);
#line 1492 "panel.vala"
				_tmp14_ = engine;
#line 1492 "panel.vala"
				_tmp15_ = ibus_engine_desc_get_language (_tmp14_);
#line 1492 "panel.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 1492 "panel.vala"
				language = _tmp16_;
#line 1493 "panel.vala"
				_tmp17_ = engine;
#line 1493 "panel.vala"
				_tmp18_ = ibus_engine_desc_get_longname (_tmp17_);
#line 1493 "panel.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 1493 "panel.vala"
				longname = _tmp19_;
#line 1494 "panel.vala"
				_tmp20_ = engine;
#line 1494 "panel.vala"
				_tmp21_ = ibus_engine_desc_get_textdomain (_tmp20_);
#line 1494 "panel.vala"
				_tmp22_ = g_strdup (_tmp21_);
#line 1494 "panel.vala"
				textdomain = _tmp22_;
#line 1495 "panel.vala"
				_tmp23_ = textdomain;
#line 1495 "panel.vala"
				_tmp24_ = longname;
#line 1495 "panel.vala"
				_tmp25_ = g_strdup (g_dgettext (_tmp23_, _tmp24_));
#line 1495 "panel.vala"
				transname = _tmp25_;
#line 1496 "panel.vala"
				_tmp26_ = language;
#line 1496 "panel.vala"
				_tmp27_ = ibus_get_language_name (_tmp26_);
#line 1496 "panel.vala"
				_tmp28_ = _tmp27_;
#line 1496 "panel.vala"
				_tmp29_ = transname;
#line 1496 "panel.vala"
				_tmp30_ = g_strdup_printf ("%s - %s", _tmp28_, _tmp29_);
#line 1496 "panel.vala"
				_tmp31_ = _tmp30_;
#line 1496 "panel.vala"
				_tmp32_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp31_);
#line 1496 "panel.vala"
				g_object_ref_sink (_tmp32_);
#line 1496 "panel.vala"
				_tmp33_ = _tmp32_;
#line 1496 "panel.vala"
				_g_free0 (_tmp31_);
#line 1496 "panel.vala"
				_g_free0 (_tmp28_);
#line 1496 "panel.vala"
				item = _tmp33_;
#line 1500 "panel.vala"
				_tmp34_ = engine;
#line 1500 "panel.vala"
				_tmp35_ = _g_object_ref0 (_tmp34_);
#line 1500 "panel.vala"
				_data9_->e = _tmp35_;
#line 1501 "panel.vala"
				_tmp36_ = item;
#line 1501 "panel.vala"
				g_signal_connect_data (_tmp36_, "activate", (GCallback) _____lambda93__gtk_menu_item_activate, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 1509 "panel.vala"
				_tmp37_ = self->priv->m_ime_menu;
#line 1509 "panel.vala"
				_tmp38_ = item;
#line 1509 "panel.vala"
				gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 1491 "panel.vala"
				_g_object_unref0 (item);
#line 1491 "panel.vala"
				_g_free0 (transname);
#line 1491 "panel.vala"
				_g_free0 (textdomain);
#line 1491 "panel.vala"
				_g_free0 (longname);
#line 1491 "panel.vala"
				_g_free0 (language);
#line 1491 "panel.vala"
				_g_object_unref0 (engine);
#line 1491 "panel.vala"
				block9_data_unref (_data9_);
#line 1491 "panel.vala"
				_data9_ = NULL;
#line 8204 "panel.c"
			}
		}
	}
#line 1512 "panel.vala"
	_tmp39_ = self->priv->m_ime_menu;
#line 1512 "panel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp39_);
#line 1515 "panel.vala"
	_tmp40_ = self->priv->m_ime_menu;
#line 1515 "panel.vala"
	gtk_menu_shell_set_take_focus ((GtkMenuShell*) _tmp40_, FALSE);
#line 1517 "panel.vala"
	_tmp41_ = display_backup;
#line 1517 "panel.vala"
	if (_tmp41_ != NULL) {
#line 8220 "panel.c"
		GdkDisplayManager* _tmp42_;
		GdkDisplay* _tmp43_;
#line 1518 "panel.vala"
		_tmp42_ = gdk_display_manager_get ();
#line 1518 "panel.vala"
		_tmp43_ = display_backup;
#line 1518 "panel.vala"
		gdk_display_manager_set_default_display (_tmp42_, _tmp43_);
#line 8229 "panel.c"
	}
#line 1519 "panel.vala"
	_tmp44_ = self->priv->m_ime_menu;
#line 1519 "panel.vala"
	_tmp45_ = _g_object_ref0 (_tmp44_);
#line 1519 "panel.vala"
	result = _tmp45_;
#line 1519 "panel.vala"
	_g_object_unref0 (display_backup);
#line 1519 "panel.vala"
	return result;
#line 8241 "panel.c"
}

static void
panel_set_properties (Panel* self,
                      IBusPropList* props)
{
	gint i = 0;
#line 1522 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1522 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1523 "panel.vala"
	i = 0;
#line 1524 "panel.vala"
	while (TRUE) {
#line 8257 "panel.c"
		IBusProperty* prop = NULL;
		IBusProperty* _tmp0_;
		IBusProperty* _tmp1_;
		IBusProperty* _tmp2_;
		IBusProperty* _tmp3_;
		gint _tmp4_;
#line 1525 "panel.vala"
		_tmp0_ = ibus_prop_list_get (props, (guint) i);
#line 1525 "panel.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1525 "panel.vala"
		prop = _tmp1_;
#line 1526 "panel.vala"
		_tmp2_ = prop;
#line 1526 "panel.vala"
		if (_tmp2_ == NULL) {
#line 1527 "panel.vala"
			_g_object_unref0 (prop);
#line 1527 "panel.vala"
			break;
#line 8278 "panel.c"
		}
#line 1528 "panel.vala"
		_tmp3_ = ibus_prop_list_get (props, (guint) i);
#line 1528 "panel.vala"
		panel_set_property (self, _tmp3_, TRUE);
#line 1529 "panel.vala"
		_tmp4_ = i;
#line 1529 "panel.vala"
		i = _tmp4_ + 1;
#line 1524 "panel.vala"
		_g_object_unref0 (prop);
#line 8290 "panel.c"
	}
}

static void
panel_set_property (Panel* self,
                    IBusProperty* prop,
                    gboolean all_update)
{
	gchar* symbol = NULL;
	IBusText* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 1533 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1533 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1534 "panel.vala"
	_tmp0_ = ibus_property_get_symbol (prop);
#line 1534 "panel.vala"
	_tmp1_ = ibus_text_get_text (_tmp0_);
#line 1534 "panel.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1534 "panel.vala"
	symbol = _tmp2_;
#line 1536 "panel.vala"
	_tmp5_ = self->priv->m_icon_prop_key;
#line 1536 "panel.vala"
	if (g_strcmp0 (_tmp5_, "") != 0) {
#line 8322 "panel.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1536 "panel.vala"
		_tmp6_ = ibus_property_get_key (prop);
#line 1536 "panel.vala"
		_tmp7_ = self->priv->m_icon_prop_key;
#line 1536 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 8331 "panel.c"
	} else {
#line 1536 "panel.vala"
		_tmp4_ = FALSE;
#line 8335 "panel.c"
	}
#line 1536 "panel.vala"
	if (_tmp4_) {
#line 8339 "panel.c"
		const gchar* _tmp8_;
#line 1537 "panel.vala"
		_tmp8_ = symbol;
#line 1537 "panel.vala"
		_tmp3_ = g_strcmp0 (_tmp8_, "") != 0;
#line 8345 "panel.c"
	} else {
#line 1536 "panel.vala"
		_tmp3_ = FALSE;
#line 8349 "panel.c"
	}
#line 1536 "panel.vala"
	if (_tmp3_) {
#line 8353 "panel.c"
		const gchar* _tmp9_;
#line 1538 "panel.vala"
		_tmp9_ = symbol;
#line 1538 "panel.vala"
		panel_animate_icon (self, _tmp9_, all_update);
#line 8359 "panel.c"
	}
#line 1533 "panel.vala"
	_g_free0 (symbol);
#line 8363 "panel.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1541 "panel.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1541 "panel.vala"
	return _data10_;
#line 8373 "panel.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1541 "panel.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 8383 "panel.c"
		Panel* self;
#line 1541 "panel.vala"
		self = _data10_->self;
#line 1541 "panel.vala"
		_g_free0 (_data10_->symbol);
#line 1541 "panel.vala"
		_g_object_unref0 (self);
#line 1541 "panel.vala"
		g_slice_free (Block10Data, _data10_);
#line 8393 "panel.c"
	}
}

static gboolean
__lambda106_ (Block10Data* _data10_)
{
	Panel* self;
	gboolean result;
#line 1554 "panel.vala"
	self = _data10_->self;
#line 1555 "panel.vala"
	self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 1557 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 8408 "panel.c"
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp0_;
		GtkStatusIcon* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 1558 "panel.vala"
		_tmp0_ = panel_create_icon_pixbuf_with_string (self, _data10_->symbol);
#line 1558 "panel.vala"
		pixbuf = _tmp0_;
#line 1559 "panel.vala"
		_tmp1_ = self->priv->m_status_icon;
#line 1559 "panel.vala"
		_tmp2_ = pixbuf;
#line 1559 "panel.vala"
		gtk_status_icon_set_from_pixbuf (_tmp1_, _tmp2_);
#line 1557 "panel.vala"
		_g_object_unref0 (pixbuf);
#line 8425 "panel.c"
	} else {
#line 1562 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 8429 "panel.c"
			cairo_surface_t* image = NULL;
			cairo_surface_t* _tmp3_;
			Indicator* _tmp4_;
			cairo_surface_t* _tmp5_;
#line 1563 "panel.vala"
			_tmp3_ = panel_create_cairo_image_surface_with_string (self, _data10_->symbol, TRUE);
#line 1563 "panel.vala"
			image = _tmp3_;
#line 1565 "panel.vala"
			_tmp4_ = self->priv->m_indicator;
#line 1565 "panel.vala"
			_tmp5_ = image;
#line 1565 "panel.vala"
			indicator_set_cairo_image_surface_full (_tmp4_, _tmp5_, "");
#line 1562 "panel.vala"
			_cairo_surface_destroy0 (image);
#line 8446 "panel.c"
		}
	}
#line 1569 "panel.vala"
	result = FALSE;
#line 1569 "panel.vala"
	return result;
#line 8453 "panel.c"
}

static gboolean
___lambda106__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda106_ (self);
#line 1554 "panel.vala"
	return result;
#line 8463 "panel.c"
}

static void
panel_animate_icon (Panel* self,
                    const gchar* symbol,
                    gboolean all_update)
{
	Block10Data* _data10_;
	gchar* _tmp0_;
	guint timeout = 0U;
#line 1541 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1541 "panel.vala"
	g_return_if_fail (symbol != NULL);
#line 1541 "panel.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 1541 "panel.vala"
	_data10_->_ref_count_ = 1;
#line 1541 "panel.vala"
	_data10_->self = g_object_ref (self);
#line 1541 "panel.vala"
	_tmp0_ = g_strdup (symbol);
#line 1541 "panel.vala"
	_g_free0 (_data10_->symbol);
#line 1541 "panel.vala"
	_data10_->symbol = _tmp0_;
#line 1542 "panel.vala"
	if (self->priv->m_property_icon_delay_time < 0) {
#line 1543 "panel.vala"
		block10_data_unref (_data10_);
#line 1543 "panel.vala"
		_data10_ = NULL;
#line 1543 "panel.vala"
		return;
#line 8498 "panel.c"
	}
#line 1545 "panel.vala"
	timeout = (guint) 0;
#line 1546 "panel.vala"
	if (all_update) {
#line 1547 "panel.vala"
		timeout = (guint) self->priv->m_property_icon_delay_time;
#line 8506 "panel.c"
	}
#line 1549 "panel.vala"
	if (self->priv->m_property_icon_delay_time_id > ((guint) 0)) {
#line 1550 "panel.vala"
		g_source_remove (self->priv->m_property_icon_delay_time_id);
#line 1551 "panel.vala"
		self->priv->m_property_icon_delay_time_id = (guint) 0;
#line 8514 "panel.c"
	}
#line 1554 "panel.vala"
	self->priv->m_property_icon_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, timeout, ___lambda106__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 1541 "panel.vala"
	block10_data_unref (_data10_);
#line 1541 "panel.vala"
	_data10_ = NULL;
#line 8522 "panel.c"
}

static void
panel_real_set_cursor_location (IBusPanelService* base,
                                gint x,
                                gint y,
                                gint width,
                                gint height)
{
	Panel * self;
	CandidatePanel* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1574 "panel.vala"
	self = (Panel*) base;
#line 1576 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1576 "panel.vala"
	candidate_panel_set_cursor_location (_tmp0_, x, y, width, height);
#line 1577 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1577 "panel.vala"
	property_panel_set_cursor_location (_tmp1_, x, y, width, height);
#line 8545 "panel.c"
}

static gboolean
panel_switcher_focus_set_engine_real (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
	gboolean result;
#line 1580 "panel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1581 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1581 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1581 "panel.vala"
	selected_engine = _tmp1_;
#line 1582 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 1582 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1582 "panel.vala"
	prev_context_path = _tmp3_;
#line 1583 "panel.vala"
	_tmp6_ = selected_engine;
#line 1583 "panel.vala"
	if (_tmp6_ != NULL) {
#line 8579 "panel.c"
		const gchar* _tmp7_;
#line 1584 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1584 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 8585 "panel.c"
	} else {
#line 1583 "panel.vala"
		_tmp5_ = FALSE;
#line 8589 "panel.c"
	}
#line 1583 "panel.vala"
	if (_tmp5_) {
#line 8593 "panel.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 1585 "panel.vala"
		_tmp8_ = prev_context_path;
#line 1585 "panel.vala"
		_tmp9_ = self->priv->m_current_context_path;
#line 1585 "panel.vala"
		_tmp4_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
#line 8602 "panel.c"
	} else {
#line 1583 "panel.vala"
		_tmp4_ = FALSE;
#line 8606 "panel.c"
	}
#line 1583 "panel.vala"
	if (_tmp4_) {
#line 8610 "panel.c"
		IBusEngineDesc* _tmp10_;
		Switcher* _tmp11_;
#line 1586 "panel.vala"
		_tmp10_ = selected_engine;
#line 1586 "panel.vala"
		panel_set_engine (self, _tmp10_);
#line 1587 "panel.vala"
		_tmp11_ = self->priv->m_switcher;
#line 1587 "panel.vala"
		switcher_reset (_tmp11_);
#line 1588 "panel.vala"
		result = TRUE;
#line 1588 "panel.vala"
		_g_free0 (prev_context_path);
#line 1588 "panel.vala"
		_g_object_unref0 (selected_engine);
#line 1588 "panel.vala"
		return result;
#line 8629 "panel.c"
	}
#line 1591 "panel.vala"
	result = FALSE;
#line 1591 "panel.vala"
	_g_free0 (prev_context_path);
#line 1591 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 1591 "panel.vala"
	return result;
#line 8639 "panel.c"
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 1600 "panel.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 8647 "panel.c"
}

static gboolean
___lambda69_ (Panel* self)
{
	gboolean result;
#line 1608 "panel.vala"
	panel_switcher_focus_set_engine_real (self);
#line 1609 "panel.vala"
	self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1610 "panel.vala"
	result = FALSE;
#line 1610 "panel.vala"
	return result;
#line 8662 "panel.c"
}

static gboolean
____lambda69__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda69_ ((Panel*) self);
#line 1606 "panel.vala"
	return result;
#line 8672 "panel.c"
}

static void
panel_switcher_focus_set_engine (Panel* self)
{
	IBusEngineDesc* selected_engine = NULL;
	Switcher* _tmp0_;
	IBusEngineDesc* _tmp1_;
	gchar* prev_context_path = NULL;
	Switcher* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	IBusEngineDesc* _tmp6_;
#line 1594 "panel.vala"
	g_return_if_fail (self != NULL);
#line 1595 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1595 "panel.vala"
	_tmp1_ = switcher_get_selected_engine (_tmp0_);
#line 1595 "panel.vala"
	selected_engine = _tmp1_;
#line 1596 "panel.vala"
	_tmp2_ = self->priv->m_switcher;
#line 1596 "panel.vala"
	_tmp3_ = switcher_get_input_context_path (_tmp2_);
#line 1596 "panel.vala"
	prev_context_path = _tmp3_;
#line 1597 "panel.vala"
	_tmp6_ = selected_engine;
#line 1597 "panel.vala"
	if (_tmp6_ == NULL) {
#line 8705 "panel.c"
		const gchar* _tmp7_;
#line 1598 "panel.vala"
		_tmp7_ = prev_context_path;
#line 1598 "panel.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 8711 "panel.c"
	} else {
#line 1597 "panel.vala"
		_tmp5_ = FALSE;
#line 8715 "panel.c"
	}
#line 1597 "panel.vala"
	if (_tmp5_) {
#line 8719 "panel.c"
		Switcher* _tmp8_;
#line 1599 "panel.vala"
		_tmp8_ = self->priv->m_switcher;
#line 1599 "panel.vala"
		_tmp4_ = switcher_is_running (_tmp8_);
#line 8725 "panel.c"
	} else {
#line 1597 "panel.vala"
		_tmp4_ = FALSE;
#line 8729 "panel.c"
	}
#line 1597 "panel.vala"
	if (_tmp4_) {
#line 8733 "panel.c"
		GMainContext* context = NULL;
		GMainContext* _tmp9_;
		GMainContext* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 1600 "panel.vala"
		_tmp9_ = g_main_context_default ();
#line 1600 "panel.vala"
		_tmp10_ = _g_main_context_ref0 (_tmp9_);
#line 1600 "panel.vala"
		context = _tmp10_;
#line 1601 "panel.vala"
		if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 8746 "panel.c"
			GMainContext* _tmp12_;
			GSource* _tmp13_;
#line 1602 "panel.vala"
			_tmp12_ = context;
#line 1602 "panel.vala"
			_tmp13_ = g_main_context_find_source_by_id (_tmp12_, self->priv->m_switcher_focus_set_engine_id);
#line 1602 "panel.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 8755 "panel.c"
		} else {
#line 1601 "panel.vala"
			_tmp11_ = FALSE;
#line 8759 "panel.c"
		}
#line 1601 "panel.vala"
		if (_tmp11_) {
#line 1604 "panel.vala"
			g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 8765 "panel.c"
		}
#line 1606 "panel.vala"
		self->priv->m_switcher_focus_set_engine_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda69__gsource_func, g_object_ref (self), g_object_unref);
#line 1597 "panel.vala"
		_g_main_context_unref0 (context);
#line 8771 "panel.c"
	} else {
#line 1613 "panel.vala"
		if (panel_switcher_focus_set_engine_real (self)) {
#line 8775 "panel.c"
			GMainContext* context = NULL;
			GMainContext* _tmp14_;
			GMainContext* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 1614 "panel.vala"
			_tmp14_ = g_main_context_default ();
#line 1614 "panel.vala"
			_tmp15_ = _g_main_context_ref0 (_tmp14_);
#line 1614 "panel.vala"
			context = _tmp15_;
#line 1615 "panel.vala"
			if (self->priv->m_switcher_focus_set_engine_id > ((guint) 0)) {
#line 8788 "panel.c"
				GMainContext* _tmp17_;
				GSource* _tmp18_;
#line 1616 "panel.vala"
				_tmp17_ = context;
#line 1616 "panel.vala"
				_tmp18_ = g_main_context_find_source_by_id (_tmp17_, self->priv->m_switcher_focus_set_engine_id);
#line 1616 "panel.vala"
				_tmp16_ = _tmp18_ != NULL;
#line 8797 "panel.c"
			} else {
#line 1615 "panel.vala"
				_tmp16_ = FALSE;
#line 8801 "panel.c"
			}
#line 1615 "panel.vala"
			if (_tmp16_) {
#line 1618 "panel.vala"
				g_source_remove (self->priv->m_switcher_focus_set_engine_id);
#line 8807 "panel.c"
			}
#line 1620 "panel.vala"
			self->priv->m_switcher_focus_set_engine_id = (guint) -1;
#line 1613 "panel.vala"
			_g_main_context_unref0 (context);
#line 8813 "panel.c"
		}
	}
#line 1594 "panel.vala"
	_g_free0 (prev_context_path);
#line 1594 "panel.vala"
	_g_object_unref0 (selected_engine);
#line 8820 "panel.c"
}

static void
panel_real_focus_in (IBusPanelService* base,
                     const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
	IBusEngineDesc* engine = NULL;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	IBusEngineDesc* _tmp6_;
	IBusEngineDesc* _tmp7_;
	IBusEngineDesc* _tmp20_;
#line 1625 "panel.vala"
	self = (Panel*) base;
#line 1625 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1626 "panel.vala"
	_tmp0_ = g_strdup (input_context_path);
#line 1626 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1626 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 1635 "panel.vala"
	if (!g_str_has_suffix (input_context_path, "InputContext_1")) {
#line 8847 "panel.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1636 "panel.vala"
		_tmp1_ = self->priv->m_current_context_path;
#line 1636 "panel.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1636 "panel.vala"
		_g_free0 (self->priv->m_real_current_context_path);
#line 1636 "panel.vala"
		self->priv->m_real_current_context_path = _tmp2_;
#line 1637 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1637 "panel.vala"
		property_panel_focus_in (_tmp3_);
#line 1638 "panel.vala"
		panel_switcher_focus_set_engine (self);
#line 8865 "panel.c"
	}
#line 1641 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1642 "panel.vala"
		return;
#line 8871 "panel.c"
	}
#line 1644 "panel.vala"
	_tmp4_ = self->priv->m_engine_contexts;
#line 1644 "panel.vala"
	_tmp5_ = g_hash_table_lookup (_tmp4_, input_context_path);
#line 1644 "panel.vala"
	_tmp6_ = _g_object_ref0 ((IBusEngineDesc*) _tmp5_);
#line 1644 "panel.vala"
	engine = _tmp6_;
#line 1646 "panel.vala"
	_tmp7_ = engine;
#line 1646 "panel.vala"
	if (_tmp7_ == NULL) {
#line 8885 "panel.c"
		IBusEngineDesc* _tmp8_ = NULL;
		IBusEngineDesc** _tmp9_;
		gint _tmp9__length1;
		IBusEngineDesc* _tmp12_;
		IBusEngineDesc* _tmp13_;
#line 1658 "panel.vala"
		_tmp9_ = self->priv->m_engines;
#line 1658 "panel.vala"
		_tmp9__length1 = self->priv->m_engines_length1;
#line 1658 "panel.vala"
		if (_tmp9__length1 > 0) {
#line 8897 "panel.c"
			IBusEngineDesc** _tmp10_;
			gint _tmp10__length1;
			IBusEngineDesc* _tmp11_;
#line 1658 "panel.vala"
			_tmp10_ = self->priv->m_engines;
#line 1658 "panel.vala"
			_tmp10__length1 = self->priv->m_engines_length1;
#line 1658 "panel.vala"
			_tmp11_ = _tmp10_[0];
#line 1658 "panel.vala"
			_tmp8_ = _tmp11_;
#line 8909 "panel.c"
		} else {
#line 1658 "panel.vala"
			_tmp8_ = NULL;
#line 8913 "panel.c"
		}
#line 1658 "panel.vala"
		_tmp12_ = _g_object_ref0 (_tmp8_);
#line 1658 "panel.vala"
		_g_object_unref0 (engine);
#line 1658 "panel.vala"
		engine = _tmp12_;
#line 1660 "panel.vala"
		_tmp13_ = engine;
#line 1660 "panel.vala"
		if (_tmp13_ == NULL) {
#line 1661 "panel.vala"
			_g_object_unref0 (engine);
#line 1661 "panel.vala"
			return;
#line 8929 "panel.c"
		}
	} else {
		gboolean in_engines = FALSE;
		IBusEngineDesc** _tmp14_;
		gint _tmp14__length1;
#line 1663 "panel.vala"
		in_engines = FALSE;
#line 1665 "panel.vala"
		_tmp14_ = self->priv->m_engines;
#line 1665 "panel.vala"
		_tmp14__length1 = self->priv->m_engines_length1;
#line 8941 "panel.c"
		{
			IBusEngineDesc** e_collection = NULL;
			gint e_collection_length1 = 0;
			gint _e_collection_size_ = 0;
			gint e_it = 0;
#line 1665 "panel.vala"
			e_collection = _tmp14_;
#line 1665 "panel.vala"
			e_collection_length1 = _tmp14__length1;
#line 1665 "panel.vala"
			for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 8953 "panel.c"
				IBusEngineDesc* _tmp15_;
				IBusEngineDesc* e = NULL;
#line 1665 "panel.vala"
				_tmp15_ = _g_object_ref0 (e_collection[e_it]);
#line 1665 "panel.vala"
				e = _tmp15_;
#line 8960 "panel.c"
				{
					IBusEngineDesc* _tmp16_;
					const gchar* _tmp17_;
					IBusEngineDesc* _tmp18_;
					const gchar* _tmp19_;
#line 1666 "panel.vala"
					_tmp16_ = engine;
#line 1666 "panel.vala"
					_tmp17_ = ibus_engine_desc_get_name (_tmp16_);
#line 1666 "panel.vala"
					_tmp18_ = e;
#line 1666 "panel.vala"
					_tmp19_ = ibus_engine_desc_get_name (_tmp18_);
#line 1666 "panel.vala"
					if (g_strcmp0 (_tmp17_, _tmp19_) == 0) {
#line 1667 "panel.vala"
						in_engines = TRUE;
#line 1668 "panel.vala"
						_g_object_unref0 (e);
#line 1668 "panel.vala"
						break;
#line 8982 "panel.c"
					}
#line 1665 "panel.vala"
					_g_object_unref0 (e);
#line 8986 "panel.c"
				}
			}
		}
#line 1674 "panel.vala"
		if (!in_engines) {
#line 1675 "panel.vala"
			_g_object_unref0 (engine);
#line 1675 "panel.vala"
			return;
#line 8996 "panel.c"
		}
	}
#line 1678 "panel.vala"
	_tmp20_ = engine;
#line 1678 "panel.vala"
	panel_set_engine (self, _tmp20_);
#line 1625 "panel.vala"
	_g_object_unref0 (engine);
#line 9005 "panel.c"
}

static void
panel_real_focus_out (IBusPanelService* base,
                      const gchar* input_context_path)
{
	Panel * self;
	gchar* _tmp0_;
#line 1681 "panel.vala"
	self = (Panel*) base;
#line 1681 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1682 "panel.vala"
	_tmp0_ = g_strdup ("");
#line 1682 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 1682 "panel.vala"
	self->priv->m_current_context_path = _tmp0_;
#line 9024 "panel.c"
}

static void
panel_real_destroy_context (IBusPanelService* base,
                            const gchar* input_context_path)
{
	Panel * self;
	GHashTable* _tmp0_;
#line 1685 "panel.vala"
	self = (Panel*) base;
#line 1685 "panel.vala"
	g_return_if_fail (input_context_path != NULL);
#line 1686 "panel.vala"
	if (self->priv->m_use_global_engine) {
#line 1687 "panel.vala"
		return;
#line 9041 "panel.c"
	}
#line 1689 "panel.vala"
	_tmp0_ = self->priv->m_engine_contexts;
#line 1689 "panel.vala"
	g_hash_table_remove (_tmp0_, input_context_path);
#line 9047 "panel.c"
}

static gboolean
__lambda107_ (Panel* self)
{
	Indicator* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	gboolean result;
#line 1710 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 1710 "panel.vala"
	_tmp1_ = panel_create_activate_menu (self, FALSE);
#line 1710 "panel.vala"
	_tmp2_ = _tmp1_;
#line 1710 "panel.vala"
	indicator_set_menu (_tmp0_, _tmp2_);
#line 1710 "panel.vala"
	_g_object_unref0 (_tmp2_);
#line 1711 "panel.vala"
	result = FALSE;
#line 1711 "panel.vala"
	return result;
#line 9071 "panel.c"
}

static gboolean
___lambda107__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda107_ ((Panel*) self);
#line 1706 "panel.vala"
	return result;
#line 9081 "panel.c"
}

static void
panel_real_register_properties (IBusPanelService* base,
                                IBusPropList* props)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1692 "panel.vala"
	self = (Panel*) base;
#line 1692 "panel.vala"
	g_return_if_fail (props != NULL);
#line 1693 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1693 "panel.vala"
	property_manager_set_properties (_tmp0_, props);
#line 1694 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1694 "panel.vala"
	property_panel_set_properties (_tmp1_, props);
#line 1695 "panel.vala"
	panel_set_properties (self, props);
#line 1698 "panel.vala"
	if (self->priv->m_icon_type != PANEL_ICON_TYPE_INDICATOR) {
#line 1699 "panel.vala"
		return;
#line 9109 "panel.c"
	}
#line 1700 "panel.vala"
	if (self->priv->m_is_context_menu) {
#line 1701 "panel.vala"
		return;
#line 9115 "panel.c"
	}
#line 1702 "panel.vala"
	if (self->priv->m_menu_update_delay_time_id > ((guint) 0)) {
#line 1703 "panel.vala"
		g_source_remove (self->priv->m_menu_update_delay_time_id);
#line 1704 "panel.vala"
		self->priv->m_menu_update_delay_time_id = (guint) 0;
#line 9123 "panel.c"
	}
#line 1706 "panel.vala"
	self->priv->m_menu_update_delay_time_id = g_timeout_add_full (G_PRIORITY_DEFAULT, self->priv->m_menu_update_delay_time, ___lambda107__gsource_func, g_object_ref (self), g_object_unref);
#line 9127 "panel.c"
}

static void
panel_real_update_property (IBusPanelService* base,
                            IBusProperty* prop)
{
	Panel * self;
	PropertyManager* _tmp0_;
	PropertyPanel* _tmp1_;
#line 1716 "panel.vala"
	self = (Panel*) base;
#line 1716 "panel.vala"
	g_return_if_fail (prop != NULL);
#line 1717 "panel.vala"
	_tmp0_ = self->priv->m_property_manager;
#line 1717 "panel.vala"
	property_manager_update_property (_tmp0_, prop);
#line 1718 "panel.vala"
	_tmp1_ = self->priv->m_property_panel;
#line 1718 "panel.vala"
	property_panel_update_property (_tmp1_, prop);
#line 1719 "panel.vala"
	panel_set_property (self, prop, FALSE);
#line 9151 "panel.c"
}

static void
panel_real_update_preedit_text (IBusPanelService* base,
                                IBusText* text,
                                guint cursor_pos,
                                gboolean visible)
{
	Panel * self;
#line 1722 "panel.vala"
	self = (Panel*) base;
#line 1722 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1725 "panel.vala"
	if (visible) {
#line 9167 "panel.c"
		CandidatePanel* _tmp0_;
		PropertyPanel* _tmp1_;
#line 1726 "panel.vala"
		_tmp0_ = self->priv->m_candidate_panel;
#line 1726 "panel.vala"
		candidate_panel_set_preedit_text (_tmp0_, text, cursor_pos);
#line 1727 "panel.vala"
		_tmp1_ = self->priv->m_property_panel;
#line 1727 "panel.vala"
		property_panel_set_preedit_text (_tmp1_, text, cursor_pos);
#line 9178 "panel.c"
	} else {
		CandidatePanel* _tmp2_;
		PropertyPanel* _tmp3_;
#line 1729 "panel.vala"
		_tmp2_ = self->priv->m_candidate_panel;
#line 1729 "panel.vala"
		candidate_panel_set_preedit_text (_tmp2_, NULL, (guint) 0);
#line 1730 "panel.vala"
		_tmp3_ = self->priv->m_property_panel;
#line 1730 "panel.vala"
		property_panel_set_preedit_text (_tmp3_, NULL, (guint) 0);
#line 9190 "panel.c"
	}
}

static void
panel_real_hide_preedit_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1734 "panel.vala"
	self = (Panel*) base;
#line 1735 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1735 "panel.vala"
	candidate_panel_set_preedit_text (_tmp0_, NULL, (guint) 0);
#line 9205 "panel.c"
}

static void
panel_real_update_auxiliary_text (IBusPanelService* base,
                                  IBusText* text,
                                  gboolean visible)
{
	Panel * self;
	IBusText* _tmp0_ = NULL;
	CandidatePanel* _tmp1_;
	IBusText* _tmp2_ = NULL;
	PropertyPanel* _tmp3_;
#line 1738 "panel.vala"
	self = (Panel*) base;
#line 1738 "panel.vala"
	g_return_if_fail (text != NULL);
#line 1740 "panel.vala"
	if (visible) {
#line 1740 "panel.vala"
		_tmp0_ = text;
#line 9226 "panel.c"
	} else {
#line 1740 "panel.vala"
		_tmp0_ = NULL;
#line 9230 "panel.c"
	}
#line 1740 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 1740 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp1_, _tmp0_);
#line 1741 "panel.vala"
	if (visible) {
#line 1741 "panel.vala"
		_tmp2_ = text;
#line 9240 "panel.c"
	} else {
#line 1741 "panel.vala"
		_tmp2_ = NULL;
#line 9244 "panel.c"
	}
#line 1741 "panel.vala"
	_tmp3_ = self->priv->m_property_panel;
#line 1741 "panel.vala"
	property_panel_set_auxiliary_text (_tmp3_, _tmp2_);
#line 9250 "panel.c"
}

static void
panel_real_hide_auxiliary_text (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1744 "panel.vala"
	self = (Panel*) base;
#line 1745 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1745 "panel.vala"
	candidate_panel_set_auxiliary_text (_tmp0_, NULL);
#line 9264 "panel.c"
}

static void
panel_real_update_lookup_table (IBusPanelService* base,
                                IBusLookupTable* table,
                                gboolean visible)
{
	Panel * self;
	IBusLookupTable* _tmp0_ = NULL;
	CandidatePanel* _tmp1_;
	IBusLookupTable* _tmp2_ = NULL;
	PropertyPanel* _tmp3_;
#line 1748 "panel.vala"
	self = (Panel*) base;
#line 1748 "panel.vala"
	g_return_if_fail (table != NULL);
#line 1750 "panel.vala"
	if (visible) {
#line 1750 "panel.vala"
		_tmp0_ = table;
#line 9285 "panel.c"
	} else {
#line 1750 "panel.vala"
		_tmp0_ = NULL;
#line 9289 "panel.c"
	}
#line 1750 "panel.vala"
	_tmp1_ = self->priv->m_candidate_panel;
#line 1750 "panel.vala"
	candidate_panel_set_lookup_table (_tmp1_, _tmp0_);
#line 1751 "panel.vala"
	if (visible) {
#line 1751 "panel.vala"
		_tmp2_ = table;
#line 9299 "panel.c"
	} else {
#line 1751 "panel.vala"
		_tmp2_ = NULL;
#line 9303 "panel.c"
	}
#line 1751 "panel.vala"
	_tmp3_ = self->priv->m_property_panel;
#line 1751 "panel.vala"
	property_panel_set_lookup_table (_tmp3_, _tmp2_);
#line 9309 "panel.c"
}

static void
panel_real_hide_lookup_table (IBusPanelService* base)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1754 "panel.vala"
	self = (Panel*) base;
#line 1755 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1755 "panel.vala"
	candidate_panel_set_lookup_table (_tmp0_, NULL);
#line 9323 "panel.c"
}

static void
panel_real_set_content_type (IBusPanelService* base,
                             guint purpose,
                             guint hints)
{
	Panel * self;
	CandidatePanel* _tmp0_;
#line 1758 "panel.vala"
	self = (Panel*) base;
#line 1759 "panel.vala"
	_tmp0_ = self->priv->m_candidate_panel;
#line 1759 "panel.vala"
	candidate_panel_set_content_type (_tmp0_, purpose, hints);
#line 9339 "panel.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 9356 "panel.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 9383 "panel.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 9389 "panel.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 9395 "panel.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 9399 "panel.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 9407 "panel.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 9411 "panel.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 9423 "panel.c"
}

static void
_vala_array_add25 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1859 "panel.vala"
	if ((*length) == (*size)) {
#line 1859 "panel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1859 "panel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9438 "panel.c"
	}
#line 1859 "panel.vala"
	(*array)[(*length)++] = value;
#line 1859 "panel.vala"
	(*array)[*length] = NULL;
#line 9444 "panel.c"
}

static void
panel_real_state_changed (IBusPanelService* base)
{
	Panel * self;
	Switcher* _tmp0_;
	gchar* icon_name = NULL;
	gchar* _tmp2_;
	IBusEngineDesc* engine = NULL;
	IBusBus* _tmp3_;
	IBusEngineDesc* _tmp4_;
	IBusEngineDesc* _tmp5_;
	const gchar* _tmp13_;
	IBusEngineDesc* _tmp54_;
	gint i = 0;
	IBusEngineDesc** _tmp63_;
	gint _tmp63__length1;
	IBusEngineDesc** _tmp70_;
	gint _tmp70__length1;
	IBusEngineDesc* _tmp71_;
	IBusEngineDesc* _tmp72_;
	gchar** names = NULL;
	gchar** _tmp73_;
	gint names_length1;
	gint _names_size_;
	IBusEngineDesc** _tmp74_;
	gint _tmp74__length1;
	GSettings* _tmp79_;
	gchar** _tmp80_;
	gint _tmp80__length1;
#line 1762 "panel.vala"
	self = (Panel*) base;
#line 1764 "panel.vala"
	_tmp0_ = self->priv->m_switcher;
#line 1764 "panel.vala"
	if (switcher_is_running (_tmp0_)) {
#line 1765 "panel.vala"
		return;
#line 9484 "panel.c"
	}
#line 1768 "panel.vala"
	if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9488 "panel.c"
		Indicator* _tmp1_;
#line 1770 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 1770 "panel.vala"
		if (_tmp1_ == NULL) {
#line 1771 "panel.vala"
			return;
#line 9496 "panel.c"
		}
	}
#line 1775 "panel.vala"
	_tmp2_ = g_strdup ("ibus-keyboard");
#line 1775 "panel.vala"
	icon_name = _tmp2_;
#line 1777 "panel.vala"
	_tmp3_ = self->priv->m_bus;
#line 1777 "panel.vala"
	_tmp4_ = ibus_bus_get_global_engine (_tmp3_);
#line 1777 "panel.vala"
	engine = _tmp4_;
#line 1778 "panel.vala"
	_tmp5_ = engine;
#line 1778 "panel.vala"
	if (_tmp5_ != NULL) {
#line 9513 "panel.c"
		IBusEngineDesc* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		IBusEngineDesc* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1779 "panel.vala"
		_tmp6_ = engine;
#line 1779 "panel.vala"
		_tmp7_ = ibus_engine_desc_get_icon (_tmp6_);
#line 1779 "panel.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 1779 "panel.vala"
		_g_free0 (icon_name);
#line 1779 "panel.vala"
		icon_name = _tmp8_;
#line 1780 "panel.vala"
		_tmp9_ = engine;
#line 1780 "panel.vala"
		_tmp10_ = ibus_engine_desc_get_icon_prop_key (_tmp9_);
#line 1780 "panel.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1780 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1780 "panel.vala"
		self->priv->m_icon_prop_key = _tmp11_;
#line 9540 "panel.c"
	} else {
		gchar* _tmp12_;
#line 1782 "panel.vala"
		_tmp12_ = g_strdup ("");
#line 1782 "panel.vala"
		_g_free0 (self->priv->m_icon_prop_key);
#line 1782 "panel.vala"
		self->priv->m_icon_prop_key = _tmp12_;
#line 9549 "panel.c"
	}
#line 1785 "panel.vala"
	_tmp13_ = icon_name;
#line 1785 "panel.vala"
	if (string_get (_tmp13_, (glong) 0) == '/') {
#line 1786 "panel.vala"
		if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9557 "panel.c"
			GtkStatusIcon* _tmp14_;
			const gchar* _tmp15_;
#line 1787 "panel.vala"
			_tmp14_ = self->priv->m_status_icon;
#line 1787 "panel.vala"
			_tmp15_ = icon_name;
#line 1787 "panel.vala"
			gtk_status_icon_set_from_file (_tmp14_, _tmp15_);
#line 9566 "panel.c"
		} else {
#line 1789 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9570 "panel.c"
				Indicator* _tmp16_;
				const gchar* _tmp17_;
#line 1790 "panel.vala"
				_tmp16_ = self->priv->m_indicator;
#line 1790 "panel.vala"
				_tmp17_ = icon_name;
#line 1790 "panel.vala"
				indicator_set_icon_full (_tmp16_, _tmp17_, "");
#line 9579 "panel.c"
			}
		}
	} else {
		gchar* language = NULL;
		IBusEngineDesc* _tmp18_;
		const gchar* _tmp32_;
#line 1793 "panel.vala"
		language = NULL;
#line 1795 "panel.vala"
		_tmp18_ = engine;
#line 1795 "panel.vala"
		if (_tmp18_ != NULL) {
#line 9592 "panel.c"
			gchar* name = NULL;
			IBusEngineDesc* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gboolean _tmp22_ = FALSE;
			const gchar* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
#line 1796 "panel.vala"
			_tmp19_ = engine;
#line 1796 "panel.vala"
			_tmp20_ = ibus_engine_desc_get_name (_tmp19_);
#line 1796 "panel.vala"
			_tmp21_ = g_strdup (_tmp20_);
#line 1796 "panel.vala"
			name = _tmp21_;
#line 1797 "panel.vala"
			_tmp23_ = name;
#line 1797 "panel.vala"
			_tmp24_ = strlen (_tmp23_);
#line 1797 "panel.vala"
			_tmp25_ = _tmp24_;
#line 1797 "panel.vala"
			if (_tmp25_ >= 4) {
#line 9617 "panel.c"
				const gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 1797 "panel.vala"
				_tmp26_ = name;
#line 1797 "panel.vala"
				_tmp27_ = string_slice (_tmp26_, (glong) 0, (glong) 4);
#line 1797 "panel.vala"
				_tmp28_ = _tmp27_;
#line 1797 "panel.vala"
				_tmp22_ = g_strcmp0 (_tmp28_, "xkb:") == 0;
#line 1797 "panel.vala"
				_g_free0 (_tmp28_);
#line 9631 "panel.c"
			} else {
#line 1797 "panel.vala"
				_tmp22_ = FALSE;
#line 9635 "panel.c"
			}
#line 1797 "panel.vala"
			if (_tmp22_) {
#line 9639 "panel.c"
				Switcher* _tmp29_;
				IBusEngineDesc* _tmp30_;
				gchar* _tmp31_;
#line 1798 "panel.vala"
				_tmp29_ = self->priv->m_switcher;
#line 1798 "panel.vala"
				_tmp30_ = engine;
#line 1798 "panel.vala"
				_tmp31_ = switcher_get_xkb_language (_tmp29_, _tmp30_);
#line 1798 "panel.vala"
				_g_free0 (language);
#line 1798 "panel.vala"
				language = _tmp31_;
#line 9653 "panel.c"
			}
#line 1795 "panel.vala"
			_g_free0 (name);
#line 9657 "panel.c"
		}
#line 1801 "panel.vala"
		_tmp32_ = language;
#line 1801 "panel.vala"
		if (_tmp32_ != NULL) {
#line 1802 "panel.vala"
			if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9665 "panel.c"
				GdkPixbuf* pixbuf = NULL;
				const gchar* _tmp33_;
				GdkPixbuf* _tmp34_;
				GtkStatusIcon* _tmp35_;
				GdkPixbuf* _tmp36_;
#line 1803 "panel.vala"
				_tmp33_ = language;
#line 1803 "panel.vala"
				_tmp34_ = panel_create_icon_pixbuf_with_string (self, _tmp33_);
#line 1803 "panel.vala"
				pixbuf = _tmp34_;
#line 1805 "panel.vala"
				_tmp35_ = self->priv->m_status_icon;
#line 1805 "panel.vala"
				_tmp36_ = pixbuf;
#line 1805 "panel.vala"
				gtk_status_icon_set_from_pixbuf (_tmp35_, _tmp36_);
#line 1802 "panel.vala"
				_g_object_unref0 (pixbuf);
#line 9685 "panel.c"
			} else {
#line 1808 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9689 "panel.c"
					cairo_surface_t* image = NULL;
					const gchar* _tmp37_;
					cairo_surface_t* _tmp38_;
					Indicator* _tmp39_;
					cairo_surface_t* _tmp40_;
#line 1809 "panel.vala"
					_tmp37_ = language;
#line 1809 "panel.vala"
					_tmp38_ = panel_create_cairo_image_surface_with_string (self, _tmp37_, TRUE);
#line 1809 "panel.vala"
					image = _tmp38_;
#line 1812 "panel.vala"
					_tmp39_ = self->priv->m_indicator;
#line 1812 "panel.vala"
					_tmp40_ = image;
#line 1812 "panel.vala"
					indicator_set_cairo_image_surface_full (_tmp39_, _tmp40_, "");
#line 1808 "panel.vala"
					_cairo_surface_destroy0 (image);
#line 9709 "panel.c"
				}
			}
		} else {
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp41_;
			GtkIconTheme* _tmp42_;
			GtkIconTheme* _tmp43_;
			const gchar* _tmp44_;
			GtkIconInfo* _tmp45_;
			GtkIconInfo* _tmp46_;
			gboolean _tmp47_;
#line 1816 "panel.vala"
			_tmp41_ = gtk_icon_theme_get_default ();
#line 1816 "panel.vala"
			_tmp42_ = _g_object_ref0 (_tmp41_);
#line 1816 "panel.vala"
			theme = _tmp42_;
#line 1817 "panel.vala"
			_tmp43_ = theme;
#line 1817 "panel.vala"
			_tmp44_ = icon_name;
#line 1817 "panel.vala"
			_tmp45_ = gtk_icon_theme_lookup_icon (_tmp43_, _tmp44_, 48, 0);
#line 1817 "panel.vala"
			_tmp46_ = _tmp45_;
#line 1817 "panel.vala"
			_tmp47_ = _tmp46_ != NULL;
#line 1817 "panel.vala"
			_g_object_unref0 (_tmp46_);
#line 1817 "panel.vala"
			if (_tmp47_) {
#line 1818 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9743 "panel.c"
					GtkStatusIcon* _tmp48_;
					const gchar* _tmp49_;
#line 1819 "panel.vala"
					_tmp48_ = self->priv->m_status_icon;
#line 1819 "panel.vala"
					_tmp49_ = icon_name;
#line 1819 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp48_, _tmp49_);
#line 9752 "panel.c"
				} else {
#line 1821 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9756 "panel.c"
						Indicator* _tmp50_;
						const gchar* _tmp51_;
#line 1822 "panel.vala"
						_tmp50_ = self->priv->m_indicator;
#line 1822 "panel.vala"
						_tmp51_ = icon_name;
#line 1822 "panel.vala"
						indicator_set_icon_full (_tmp50_, _tmp51_, "");
#line 9765 "panel.c"
					}
				}
			} else {
#line 1825 "panel.vala"
				if (self->priv->m_icon_type == PANEL_ICON_TYPE_STATUS_ICON) {
#line 9771 "panel.c"
					GtkStatusIcon* _tmp52_;
#line 1826 "panel.vala"
					_tmp52_ = self->priv->m_status_icon;
#line 1826 "panel.vala"
					gtk_status_icon_set_from_icon_name (_tmp52_, "ibus-engine");
#line 9777 "panel.c"
				} else {
#line 1828 "panel.vala"
					if (self->priv->m_icon_type == PANEL_ICON_TYPE_INDICATOR) {
#line 9781 "panel.c"
						Indicator* _tmp53_;
#line 1829 "panel.vala"
						_tmp53_ = self->priv->m_indicator;
#line 1829 "panel.vala"
						indicator_set_icon_full (_tmp53_, "ibus-engine", "");
#line 9787 "panel.c"
					}
				}
			}
#line 1801 "panel.vala"
			_g_object_unref0 (theme);
#line 9793 "panel.c"
		}
#line 1785 "panel.vala"
		_g_free0 (language);
#line 9797 "panel.c"
	}
#line 1835 "panel.vala"
	_tmp54_ = engine;
#line 1835 "panel.vala"
	if (_tmp54_ == NULL) {
#line 1836 "panel.vala"
		_g_object_unref0 (engine);
#line 1836 "panel.vala"
		_g_free0 (icon_name);
#line 1836 "panel.vala"
		return;
#line 9809 "panel.c"
	}
	{
		gboolean _tmp55_ = FALSE;
#line 1839 "panel.vala"
		i = 0;
#line 1839 "panel.vala"
		_tmp55_ = TRUE;
#line 1839 "panel.vala"
		while (TRUE) {
#line 9819 "panel.c"
			IBusEngineDesc** _tmp57_;
			gint _tmp57__length1;
			IBusEngineDesc** _tmp58_;
			gint _tmp58__length1;
			IBusEngineDesc* _tmp59_;
			const gchar* _tmp60_;
			IBusEngineDesc* _tmp61_;
			const gchar* _tmp62_;
#line 1839 "panel.vala"
			if (!_tmp55_) {
#line 9830 "panel.c"
				gint _tmp56_;
#line 1839 "panel.vala"
				_tmp56_ = i;
#line 1839 "panel.vala"
				i = _tmp56_ + 1;
#line 9836 "panel.c"
			}
#line 1839 "panel.vala"
			_tmp55_ = FALSE;
#line 1839 "panel.vala"
			_tmp57_ = self->priv->m_engines;
#line 1839 "panel.vala"
			_tmp57__length1 = self->priv->m_engines_length1;
#line 1839 "panel.vala"
			if (!(i < _tmp57__length1)) {
#line 1839 "panel.vala"
				break;
#line 9848 "panel.c"
			}
#line 1840 "panel.vala"
			_tmp58_ = self->priv->m_engines;
#line 1840 "panel.vala"
			_tmp58__length1 = self->priv->m_engines_length1;
#line 1840 "panel.vala"
			_tmp59_ = _tmp58_[i];
#line 1840 "panel.vala"
			_tmp60_ = ibus_engine_desc_get_name (_tmp59_);
#line 1840 "panel.vala"
			_tmp61_ = engine;
#line 1840 "panel.vala"
			_tmp62_ = ibus_engine_desc_get_name (_tmp61_);
#line 1840 "panel.vala"
			if (g_strcmp0 (_tmp60_, _tmp62_) == 0) {
#line 1841 "panel.vala"
				break;
#line 9866 "panel.c"
			}
		}
	}
#line 1845 "panel.vala"
	if (i == 0) {
#line 1846 "panel.vala"
		_g_object_unref0 (engine);
#line 1846 "panel.vala"
		_g_free0 (icon_name);
#line 1846 "panel.vala"
		return;
#line 9878 "panel.c"
	}
#line 1849 "panel.vala"
	_tmp63_ = self->priv->m_engines;
#line 1849 "panel.vala"
	_tmp63__length1 = self->priv->m_engines_length1;
#line 1849 "panel.vala"
	if (i >= _tmp63__length1) {
#line 1850 "panel.vala"
		_g_object_unref0 (engine);
#line 1850 "panel.vala"
		_g_free0 (icon_name);
#line 1850 "panel.vala"
		return;
#line 9892 "panel.c"
	}
	{
		gint j = 0;
#line 1852 "panel.vala"
		j = i;
#line 9898 "panel.c"
		{
			gboolean _tmp64_ = FALSE;
#line 1852 "panel.vala"
			_tmp64_ = TRUE;
#line 1852 "panel.vala"
			while (TRUE) {
#line 9905 "panel.c"
				IBusEngineDesc** _tmp66_;
				gint _tmp66__length1;
				IBusEngineDesc** _tmp67_;
				gint _tmp67__length1;
				IBusEngineDesc* _tmp68_;
				IBusEngineDesc* _tmp69_;
#line 1852 "panel.vala"
				if (!_tmp64_) {
#line 9914 "panel.c"
					gint _tmp65_;
#line 1852 "panel.vala"
					_tmp65_ = j;
#line 1852 "panel.vala"
					j = _tmp65_ - 1;
#line 9920 "panel.c"
				}
#line 1852 "panel.vala"
				_tmp64_ = FALSE;
#line 1852 "panel.vala"
				if (!(j > 0)) {
#line 1852 "panel.vala"
					break;
#line 9928 "panel.c"
				}
#line 1853 "panel.vala"
				_tmp66_ = self->priv->m_engines;
#line 1853 "panel.vala"
				_tmp66__length1 = self->priv->m_engines_length1;
#line 1853 "panel.vala"
				_tmp67_ = self->priv->m_engines;
#line 1853 "panel.vala"
				_tmp67__length1 = self->priv->m_engines_length1;
#line 1853 "panel.vala"
				_tmp68_ = _tmp67_[j - 1];
#line 1853 "panel.vala"
				_tmp69_ = _g_object_ref0 (_tmp68_);
#line 1853 "panel.vala"
				_g_object_unref0 (_tmp66_[j]);
#line 1853 "panel.vala"
				_tmp66_[j] = _tmp69_;
#line 9946 "panel.c"
			}
		}
	}
#line 1855 "panel.vala"
	_tmp70_ = self->priv->m_engines;
#line 1855 "panel.vala"
	_tmp70__length1 = self->priv->m_engines_length1;
#line 1855 "panel.vala"
	_tmp71_ = engine;
#line 1855 "panel.vala"
	_tmp72_ = _g_object_ref0 (_tmp71_);
#line 1855 "panel.vala"
	_g_object_unref0 (_tmp70_[0]);
#line 1855 "panel.vala"
	_tmp70_[0] = _tmp72_;
#line 1857 "panel.vala"
	_tmp73_ = g_new0 (gchar*, 0 + 1);
#line 1857 "panel.vala"
	names = _tmp73_;
#line 1857 "panel.vala"
	names_length1 = 0;
#line 1857 "panel.vala"
	_names_size_ = names_length1;
#line 1858 "panel.vala"
	_tmp74_ = self->priv->m_engines;
#line 1858 "panel.vala"
	_tmp74__length1 = self->priv->m_engines_length1;
#line 9974 "panel.c"
	{
		IBusEngineDesc** desc_collection = NULL;
		gint desc_collection_length1 = 0;
		gint _desc_collection_size_ = 0;
		gint desc_it = 0;
#line 1858 "panel.vala"
		desc_collection = _tmp74_;
#line 1858 "panel.vala"
		desc_collection_length1 = _tmp74__length1;
#line 1858 "panel.vala"
		for (desc_it = 0; desc_it < desc_collection_length1; desc_it = desc_it + 1) {
#line 9986 "panel.c"
			IBusEngineDesc* _tmp75_;
			IBusEngineDesc* desc = NULL;
#line 1858 "panel.vala"
			_tmp75_ = _g_object_ref0 (desc_collection[desc_it]);
#line 1858 "panel.vala"
			desc = _tmp75_;
#line 9993 "panel.c"
			{
				IBusEngineDesc* _tmp76_;
				const gchar* _tmp77_;
				gchar* _tmp78_;
#line 1859 "panel.vala"
				_tmp76_ = desc;
#line 1859 "panel.vala"
				_tmp77_ = ibus_engine_desc_get_name (_tmp76_);
#line 1859 "panel.vala"
				_tmp78_ = g_strdup (_tmp77_);
#line 1859 "panel.vala"
				_vala_array_add25 (&names, &names_length1, &_names_size_, _tmp78_);
#line 1858 "panel.vala"
				_g_object_unref0 (desc);
#line 10008 "panel.c"
			}
		}
	}
#line 1861 "panel.vala"
	_tmp79_ = self->priv->m_settings_general;
#line 1861 "panel.vala"
	_tmp80_ = names;
#line 1861 "panel.vala"
	_tmp80__length1 = names_length1;
#line 1861 "panel.vala"
	g_settings_set_strv (_tmp79_, "engines-order", _tmp80_);
#line 1762 "panel.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 1762 "panel.vala"
	_g_object_unref0 (engine);
#line 1762 "panel.vala"
	_g_free0 (icon_name);
#line 10026 "panel.c"
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "panel.vala"
	g_return_if_fail (n_param_values == 4);
#line 24 "panel.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "panel.vala"
		data1 = closure->data;
#line 24 "panel.vala"
		data2 = param_values->data[0].v_pointer;
#line 10051 "panel.c"
	} else {
#line 24 "panel.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "panel.vala"
		data2 = closure->data;
#line 10057 "panel.c"
	}
#line 24 "panel.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 24 "panel.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 10063 "panel.c"
}

static void
panel_class_init (PanelClass * klass,
                  gpointer klass_data)
{
#line 24 "panel.vala"
	panel_parent_class = g_type_class_peek_parent (klass);
#line 24 "panel.vala"
	g_type_class_adjust_private_offset (klass, &Panel_private_offset);
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_cursor_location = (void (*) (IBusPanelService*, gint, gint, gint, gint)) panel_real_set_cursor_location;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_in = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_in;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->focus_out = (void (*) (IBusPanelService*, const gchar*)) panel_real_focus_out;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->destroy_context = (void (*) (IBusPanelService*, const gchar*)) panel_real_destroy_context;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->register_properties = (void (*) (IBusPanelService*, IBusPropList*)) panel_real_register_properties;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_property = (void (*) (IBusPanelService*, IBusProperty*)) panel_real_update_property;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_preedit_text = (void (*) (IBusPanelService*, IBusText*, guint, gboolean)) panel_real_update_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_preedit_text = (void (*) (IBusPanelService*)) panel_real_hide_preedit_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_auxiliary_text = (void (*) (IBusPanelService*, IBusText*, gboolean)) panel_real_update_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_auxiliary_text = (void (*) (IBusPanelService*)) panel_real_hide_auxiliary_text;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->update_lookup_table = (void (*) (IBusPanelService*, IBusLookupTable*, gboolean)) panel_real_update_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->hide_lookup_table = (void (*) (IBusPanelService*)) panel_real_hide_lookup_table;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->set_content_type = (void (*) (IBusPanelService*, guint, guint)) panel_real_set_content_type;
#line 24 "panel.vala"
	((IBusPanelServiceClass *) klass)->state_changed = (void (*) (IBusPanelService*)) panel_real_state_changed;
#line 24 "panel.vala"
	G_OBJECT_CLASS (klass)->finalize = panel_finalize;
#line 24 "panel.vala"
	panel_signals[PANEL_REALIZE_SURFACE_SIGNAL] = g_signal_new ("realize-surface", TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 24 "panel.vala"
	panel_signals[PANEL_UPDATE_SHORTCUT_KEYS_SIGNAL] = g_signal_new ("update-shortcut-keys", TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT_ENUM, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_INT, BINDING_COMMON_TYPE_KEY_EVENT_FUNC_TYPE);
#line 10108 "panel.c"
}

static void
panel_instance_init (Panel * self,
                     gpointer klass)
{
	IBusEngineDesc** _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	XKBLayout* _tmp13_;
	gchar* _tmp14_;
#line 24 "panel.vala"
	self->priv = panel_get_instance_private (self);
#line 32 "panel.vala"
	self->priv->m_settings_general = NULL;
#line 33 "panel.vala"
	self->priv->m_settings_hotkey = NULL;
#line 34 "panel.vala"
	self->priv->m_settings_panel = NULL;
#line 35 "panel.vala"
	self->priv->m_icon_type = PANEL_ICON_TYPE_STATUS_ICON;
#line 42 "panel.vala"
	_tmp0_ = g_new0 (IBusEngineDesc*, 0 + 1);
#line 42 "panel.vala"
	self->priv->m_engines = _tmp0_;
#line 42 "panel.vala"
	self->priv->m_engines_length1 = 0;
#line 42 "panel.vala"
	self->priv->_m_engines_size_ = self->priv->m_engines_length1;
#line 43 "panel.vala"
	_tmp1_ = g_str_hash;
#line 43 "panel.vala"
	_tmp2_ = g_str_equal;
#line 43 "panel.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
#line 43 "panel.vala"
	self->priv->m_engine_contexts = _tmp3_;
#line 46 "panel.vala"
	_tmp4_ = g_strdup ("");
#line 46 "panel.vala"
	self->priv->m_current_context_path = _tmp4_;
#line 47 "panel.vala"
	_tmp5_ = g_strdup ("");
#line 47 "panel.vala"
	self->priv->m_real_current_context_path = _tmp5_;
#line 48 "panel.vala"
	self->priv->m_use_global_engine = TRUE;
#line 49 "panel.vala"
	self->priv->m_use_engine_lang = TRUE;
#line 53 "panel.vala"
	self->priv->m_switcher_selected_index = -1;
#line 57 "panel.vala"
	self->priv->m_setup_pid = (GPid) 0;
#line 60 "panel.vala"
	self->priv->m_switcher_delay_time = 400;
#line 61 "panel.vala"
	self->priv->m_use_system_keyboard_layout = FALSE;
#line 62 "panel.vala"
	_tmp6_ = g_str_hash;
#line 62 "panel.vala"
	_tmp7_ = g_str_equal;
#line 62 "panel.vala"
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, _g_free0_, _g_object_unref0_);
#line 62 "panel.vala"
	self->priv->m_xkb_icon_pixbufs = _tmp8_;
#line 65 "panel.vala"
	_tmp9_ = g_str_hash;
#line 65 "panel.vala"
	_tmp10_ = g_str_equal;
#line 65 "panel.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, _g_free0_, _cairo_surface_destroy0_);
#line 65 "panel.vala"
	self->priv->m_xkb_icon_image = _tmp11_;
#line 68 "panel.vala"
	memset (&_tmp12_, 0, sizeof (GdkRGBA));
#line 68 "panel.vala"
	_tmp12_.red = 0.0;
#line 68 "panel.vala"
	_tmp12_.green = 0.0;
#line 68 "panel.vala"
	_tmp12_.blue = 0.0;
#line 68 "panel.vala"
	_tmp12_.alpha = 1.0;
#line 68 "panel.vala"
	self->priv->m_xkb_icon_rgba = _tmp12_;
#line 70 "panel.vala"
	_tmp13_ = xkb_layout_new ();
#line 70 "panel.vala"
	self->priv->m_xkblayout = _tmp13_;
#line 71 "panel.vala"
	self->priv->inited_engines_order = TRUE;
#line 74 "panel.vala"
	_tmp14_ = g_strdup ("");
#line 74 "panel.vala"
	self->priv->m_icon_prop_key = _tmp14_;
#line 75 "panel.vala"
	self->priv->m_property_icon_delay_time = 500;
#line 77 "panel.vala"
	self->priv->m_menu_update_delay_time = (guint) 100;
#line 82 "panel.vala"
	self->priv->m_is_kde = panel_is_kde ();
#line 93 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 10222 "panel.c"
}

static void
panel_finalize (GObject * obj)
{
	Panel * self;
	Indicator* _tmp0_;
	GList* _tmp2_;
#line 24 "panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PANEL, Panel);
#line 177 "panel.vala"
	_tmp0_ = self->priv->m_indicator;
#line 177 "panel.vala"
	if (_tmp0_ != NULL) {
#line 10237 "panel.c"
		Indicator* _tmp1_;
#line 178 "panel.vala"
		_tmp1_ = self->priv->m_indicator;
#line 178 "panel.vala"
		indicator_unregister_connection (_tmp1_);
#line 10243 "panel.c"
	}
#line 180 "panel.vala"
	_tmp2_ = self->priv->m_keybindings;
#line 180 "panel.vala"
	binding_common_unbind_switch_shortcut (BINDING_COMMON_KEY_EVENT_FUNC_TYPE_ANY, _tmp2_);
#line 182 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 182 "panel.vala"
	self->priv->m_keybindings = NULL;
#line 31 "panel.vala"
	_g_object_unref0 (self->priv->m_bus);
#line 32 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_general);
#line 33 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_hotkey);
#line 34 "panel.vala"
	_g_object_unref0 (self->priv->m_settings_panel);
#line 37 "panel.vala"
	_g_object_unref0 (self->priv->m_indicator);
#line 39 "panel.vala"
	_g_object_unref0 (self->priv->m_status_icon);
#line 40 "panel.vala"
	_g_object_unref0 (self->priv->m_ime_menu);
#line 41 "panel.vala"
	_g_object_unref0 (self->priv->m_sys_menu);
#line 42 "panel.vala"
	self->priv->m_engines = (_vala_array_free (self->priv->m_engines, self->priv->m_engines_length1, (GDestroyNotify) g_object_unref), NULL);
#line 43 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_engine_contexts);
#line 46 "panel.vala"
	_g_free0 (self->priv->m_current_context_path);
#line 47 "panel.vala"
	_g_free0 (self->priv->m_real_current_context_path);
#line 50 "panel.vala"
	_g_object_unref0 (self->priv->m_candidate_panel);
#line 51 "panel.vala"
	_g_object_unref0 (self->priv->m_switcher);
#line 54 "panel.vala"
	_g_thread_unref0 (self->priv->m_switcher_waiting_release);
#line 55 "panel.vala"
	_property_manager_unref0 (self->priv->m_property_manager);
#line 56 "panel.vala"
	_g_object_unref0 (self->priv->m_property_panel);
#line 58 "panel.vala"
	_g_object_unref0 (self->priv->m_about_dialog);
#line 59 "panel.vala"
	_g_object_unref0 (self->priv->m_css_provider);
#line 62 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_pixbufs);
#line 65 "panel.vala"
	_g_hash_table_unref0 (self->priv->m_xkb_icon_image);
#line 70 "panel.vala"
	_xkb_layout_unref0 (self->priv->m_xkblayout);
#line 74 "panel.vala"
	_g_free0 (self->priv->m_icon_prop_key);
#line 93 "panel.vala"
	(self->priv->m_keybindings == NULL) ? NULL : (self->priv->m_keybindings = (_g_list_free__g_object_unref0_ (self->priv->m_keybindings), NULL));
#line 24 "panel.vala"
	G_OBJECT_CLASS (panel_parent_class)->finalize (obj);
#line 10303 "panel.c"
}

static GType
panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Panel), 0, (GInstanceInitFunc) panel_instance_init, NULL };
	GType panel_type_id;
	panel_type_id = g_type_register_static (ibus_panel_service_get_type (), "Panel", &g_define_type_info, 0);
	Panel_private_offset = g_type_add_instance_private (panel_type_id, sizeof (PanelPrivate));
	return panel_type_id;
}

GType
panel_get_type (void)
{
	static volatile gsize panel_type_id__once = 0;
	if (g_once_init_enter (&panel_type_id__once)) {
		GType panel_type_id;
		panel_type_id = panel_get_type_once ();
		g_once_init_leave (&panel_type_id__once, panel_type_id);
	}
	return panel_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 10335 "panel.c"
		gssize i;
#line 23 "emojier.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "emojier.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "emojier.vala"
				destroy_func (((gpointer*) array)[i]);
#line 10343 "panel.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 23 "emojier.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "emojier.vala"
	g_free (array);
#line 10358 "panel.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 23 "emojier.vala"
	if (array) {
#line 23 "emojier.vala"
		while (((gpointer*) array)[length]) {
#line 23 "emojier.vala"
			length++;
#line 10372 "panel.c"
		}
	}
#line 23 "emojier.vala"
	return length;
#line 10377 "panel.c"
}

